<?php
/**
 * Database Integration.
 *
 * @package User Activity Log PRO
 */

/**
 * Exit if accessed directly.
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! function_exists( 'ualp_dbintegration' ) ) {
	/**
	 * DB Integrations.
	 */
	function ualp_dbintegration() {
		?>
		<div class="wrap">
			<h1><?php esc_html_e( 'External Database Integrations', 'user_activity_log_pro' ); ?></h1>
			<?php
			if ( isset( $_SESSION['success_msg'] ) ) {
				?>
				<div class="success_msg">
				<?php
					ualp_admin_notice_message( 'updated', $_SESSION['success_msg'] );
					unset( $_SESSION['success_msg'] );
				?>
				</div>
				<?php
			}
			?>
			<div class="tab_parent_parent ualpParentTabs">
				<h2 class="nav-tab-wrapper nav-tab-wrapper">
					<a class="nav-tab nav-tab-active ualp_db_settings" data-href="ualp_db_settings" href="javascript:void(0)" >
						<?php esc_html_e( 'Database Integrations Options', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab nav-tab-active ualp_db_migrate" data-href="ualp_db_migrate" href="javascript:void(0)" >
						<?php esc_html_e( 'Database Migration', 'user_activity_log_pro' ); ?>
					</a>
				</h2>
			</div>
			<div class="ualpTabContentWrap">
				<div id="ualp_db_settings" class="ualpContentDiv"><?php ualp_db_settings(); ?></div>
				<div id="ualp_db_migrate" class="ualpContentDiv"><?php ualp_db_migrate(); ?></div>
			</div>
		</div>
		<?php
	}
}
