<?php
/**
 * Generate Reports.
 *
 * @package User Activity Log PRO
 */

/**
 * Exit if accessed directly.
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! function_exists( 'ualp_reports' ) ) {
	/**
	 * DB Integrations.
	 */
	function ualp_reports() {
		?>
		<div class="wrap">
			<h1><?php esc_html_e( 'Generate Reports', 'user_activity_log_pro' ); ?></h1>
			<div class="tab_parent_parent ualpParentTabs">
				<h2 class="nav-tab-wrapper nav-tab-wrapper">
					<a class="nav-tab nav-tab-active ualp_generate_reports" data-href="ualp_generate_reports" href="javascript:void(0)" >
						<?php esc_html_e( 'Generate Reports', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab ualp_statistics_reports" data-href="ualp_statistics_reports" href="javascript:void(0)">
						<?php esc_html_e( 'Statistics Reports', 'user_activity_log_pro' ); ?>
					</a>
				</h2>
			</div>
			<div class="ualpTabContentWrap">
				<div id="ualp_generate_reports" style="display: none" class="ualpContentDiv"><?php ualp_generate_reports(); ?></div>
				<div id="ualp_statistics_reports" style="display: none" class="ualpContentDiv"><?php ualp_statistics_reports(); ?></div>
			</div>
		</div>
		<?php
	}
}

if ( ! function_exists( 'ualp_generate_reports' ) ) {
	/**
	 * Generate Reports.
	 */
	function ualp_generate_reports() {
		if ( is_network_admin() && ualp_multi_site_support_return() ) {
			$adminurl = network_admin_url( 'admin.php' );
		} else {
			$adminurl = admin_url( 'admin.php' );
		}
		global $wpdb, $externaldb,$allhookdetails;
		$args_kses                           = ualp_args_kses();
		$users                               = $externaldb->get_results( $externaldb->prepare( 'SELECT DISTINCT user_name FROM ' . UALP_TABLENAME . ' WHERE 1 = 1 AND user_name <> %s ORDER BY user_name', '""' ) );
		$user_id                             = $externaldb->get_results(
			'SELECT DISTINCT user_id FROM ' . UALP_TABLENAME . ' WHERE 1 = 1 ORDER BY user_id
        '
		);
		$ips                                 = $externaldb->get_results( 'SELECT DISTINCT ip_address FROM ' . UALP_TABLENAME . ' WHERE 1 = 1 ORDER BY ip_address' );
		$hooks                               = $externaldb->get_results( 'SELECT DISTINCT hook FROM ' . UALP_TABLENAME . ' WHERE 1 = 1 ORDER BY hook' );
		$types                               = $externaldb->get_results( $externaldb->prepare( 'SELECT DISTINCT object_type FROM ' . UALP_TABLENAME . ' WHERE 1 = 1 AND object_type <> %s ORDER BY object_type', '""' ) );
		$countrys                            = $externaldb->get_results( 'SELECT DISTINCT country FROM ' . UALP_TABLENAME . ' WHERE 1 = 1 ORDER BY country' );
		$ualp_generate_report_start_date     = '';
		$ualp_generate_report_end_date       = '';
		$ualp_generate_report_format         = '';
		$ualp_generate_report_username_list  = array();
		$ualp_generate_report_userrole_list  = array();
		$ualp_generate_report_country_list   = array();
		$ualp_generate_report_ipaddress_list = array();
		$ualp_generate_report_logtype_list   = array();
		$username_list                       = array();
		$userrole_list                       = array();
		$ipaddress_list                      = array();
		$logtype_list                        = array();
		$hook_list                           = array();
		$reportposttype_list                 = array();
		$reportallpost                       = array();
		$ualp_generate_report_username_list  = get_option( 'ualp_generate_report_username_list' );
		$ualp_generate_report_userrole_list  = get_option( 'ualp_generate_report_userrole_list' );
		$ualp_generate_report_ipaddress_list = get_option( 'ualp_generate_report_ipaddress_list' );
		$ualp_generate_report_country_list   = get_option( 'ualp_generate_report_country_list' );
		$ualp_generate_report_logtype_list   = get_option( 'ualp_generate_report_logtype_list' );
		$ualp_generate_report_hook_list      = get_option( 'ualp_generate_report_hook_list' );
		$ualp_generate_report_posttype_list  = get_option( 'ualp_generate_report_posttype_list' );
		$ualp_generate_report_allpost_list   = get_option( 'ualp_generate_report_allpost_list' );
		$ualp_generate_report_start_date     = get_option( 'ualp_generate_report_start_date', '' );
		$ualp_generate_report_end_date       = get_option( 'ualp_generate_report_end_date', '' );
		$ualp_generate_report_format         = get_option( 'ualp_generate_report_format' );
		if ( isset( $ualp_generate_report_username_list ) && ! empty( $ualp_generate_report_username_list ) ) {
			$username_list = maybe_unserialize( $ualp_generate_report_username_list );
		}
		if ( isset( $ualp_generate_report_userrole_list ) && ! empty( $ualp_generate_report_userrole_list ) ) {
			$userrole_list = maybe_unserialize( $ualp_generate_report_userrole_list );
		}
		if ( isset( $ualp_generate_report_ipaddress_list ) && ! empty( $ualp_generate_report_ipaddress_list ) ) {
			$ipaddress_list = maybe_unserialize( $ualp_generate_report_ipaddress_list );
		}
		if ( isset( $ualp_generate_report_logtype_list ) && ! empty( $ualp_generate_report_logtype_list ) ) {
			$logtype_list = maybe_unserialize( $ualp_generate_report_logtype_list );
		}
		if ( isset( $ualp_generate_report_hook_list ) && ! empty( $ualp_generate_report_hook_list ) ) {
			$hook_list = maybe_unserialize( $ualp_generate_report_hook_list );
		}
		if ( isset( $ualp_generate_report_posttype_list ) && ! empty( $ualp_generate_report_posttype_list ) ) {
			$reportposttype_list = maybe_unserialize( $ualp_generate_report_posttype_list );
		}
		if ( isset( $ualp_generate_report_allpost_list ) && ! empty( $ualp_generate_report_allpost_list ) ) {
			$reportallpost = maybe_unserialize( $ualp_generate_report_allpost_list );
		}
		if ( isset( $ualp_generate_report_country_list ) && ! empty( $ualp_generate_report_country_list ) ) {
			$country_list = maybe_unserialize( $ualp_generate_report_country_list );
		}
		?>
	   
		<div class="UalpGenerateReportCover"> 
			<div class="padding_left_right_15">
				<div class="generatereportcover">
					<?php
					$qry_str  = isset( $_SERVER['QUERY_STRING'] ) ? sanitize_text_field( wp_unslash( $_SERVER['QUERY_STRING'] ) ) : '';
					$req_page = isset( $_REQUEST['page'] ) ? sanitize_text_field( wp_unslash( $_REQUEST['page'] ) ) : '';
					?>
				<form method="POST" class="ualpGenerateReportForm" action="<?php echo esc_attr( $adminurl ) . '?' . esc_attr( $qry_str ); ?>">
				<input type="hidden" name="page" value="<?php echo esc_attr( $req_page ); ?>" />
					<h3 class="ualpHeaderTitle"><?php esc_html_e( 'Generate Reports', 'user_activity_log_pro' ); ?></h3>
					<div class="generate_report_steps_1">
						<span class="generate_report_step_title"><b><?php esc_html_e( 'Step 1', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;<?php esc_html_e( 'Select the type of report', 'user_activity_log_pro' ); ?></b></span>
						<div class="generate_report_type_cover">
							<div class="generate_report_type_label">Select Users</div>
							<div class="generate_report_type_value">
								<?php
								if ( $users ) {
									$output = array();
									foreach ( $users as $_user ) {
										if ( isset( $_user->user_name ) && '' != $_user->user_name ) {
											$output[] = sprintf( '<option value="%s" %s>%s</option>', $_user->user_name, in_array( $_user->user_name, $username_list ) ? 'selected="selected"' : '', $_user->user_name );
										}
									}
									echo '<select class="chosen-filter" name="usershow[]" id="ualp-filter-usershow" data-placeholder="' . esc_html__( 'Select Users', 'user_activity_log_pro' ) . '"multiple>';
									echo wp_kses( implode( '', $output ), $args_kses );
									echo '</select>';
								}
								?>
								<span class="report-note"><b><?php esc_html_e( 'Note', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;</b><?php esc_html_e( 'Default All Users Selected', 'user_activity_log_pro' ); ?></span>
							</div>
						</div>
						<div class="generate_report_type_cover">
							<div class="generate_report_type_label">Select Roles</div>
							<div class="generate_report_type_value">
								<?php

								if ( $user_id ) {
									$output     = array();
									$user_roles = array();
									foreach ( $user_id as $alluserroleid ) {
										foreach ( $alluserroleid as $alluserrole ) {
											if ( '' != $alluserrole && 0 != $alluserrole ) {
												$userroles = get_user_by( 'id', $alluserrole );
												if ( isset( $userroles->roles ) ) {
													$user_roles = $userroles->roles;
												}
											}
											foreach ( $user_roles as $user_id_role ) {
												$output[] = sprintf( '<option value="%s" %s>%s</option>', $user_id_role, in_array( $user_id_role, $userrole_list ) ? 'selected="selected"' : '', $user_id_role );
											}
										}
									}
									echo '<select class="chosen-filter" name="capshow[]" id="ualp-filter-capshow" data-placeholder="' . esc_html__( 'Select Roles', 'user_activity_log_pro' ) . '"multiple>';
									echo wp_kses( implode( '', array_unique( $output ) ), $args_kses );
									echo '</select>';
								}
								?>
								<span class="report-note"><b><?php esc_html_e( 'Note', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;</b><?php esc_html_e( 'Default All Roles Selected', 'user_activity_log_pro' ); ?></span>
							</div>
						</div>
						<div class="generate_report_type_cover">
							<div class="generate_report_type_label">Select Types</div>
							<div class="generate_report_type_value">
								<?php
								if ( $types ) {
									$output = array();
									foreach ( $types as $type ) {
										if ( isset( $type->object_type ) && '' != $type->object_type ) {
											$output[] = sprintf( '<option value="%s" %s>%s</option>', $type->object_type, in_array( $type->object_type, $logtype_list ) ? 'selected="selected"' : '', $type->object_type );
										}
									}
									echo '<select class="chosen-filter" name="showlogtype[]" id="ualp-filter-type" data-placeholder="' . esc_html__( 'Select Types', 'user_activity_log_pro' ) . '"multiple>';
									echo wp_kses( implode( '', $output ), $args_kses );
									echo '</select>';
								}
								?>
								<span class="report-note"><b><?php esc_html_e( 'Note', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;</b><?php esc_html_e( 'Default All Types Selected', 'user_activity_log_pro' ); ?></span>
							</div>
						</div>
						<div class="generate_report_type_cover">
							<div class="generate_report_type_label">Select Activities</div>
							<div class="generate_report_type_value">
								<?php
								if ( $hooks ) {
									$output = array();

									foreach ( $hooks as $hook ) {
										if ( isset( $hook->hook ) && '' != $hook->hook ) {
											$label = $hook->hook;
											foreach ( $allhookdetails as $key => $val ) {
												if ( $hook->hook == $key ) {
													$label = $val;
												}
											}
											$output[] = sprintf( '<option value="%s" %s>%s</option>', $hook->hook, in_array( $hook->hook, $hook_list ) ? 'selected="selected"' : '', $label );
										}
									}
									echo '<select class="chosen-filter" name="showhook[]" id="ualp-report-showhook" data-placeholder="' . esc_html__( 'Select activity', 'user_activity_log_pro' ) . '"multiple>';
									echo wp_kses( implode( '', $output ), $args_kses );
									echo '</select>';
								}
								?>
								<span class="report-note"><b><?php esc_html_e( 'Note', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;</b><?php esc_html_e( 'Default All Activities Selected', 'user_activity_log_pro' ); ?></span>
								<div class="custom-report-hook">
									<h3><?php esc_html_e( 'Advance filter', 'user_activity_log_pro' ); ?></h3>
									<?php
									global $wp,$externaldb;
									$transition_where = '1 = 1';
									if ( ! is_network_admin() && ualp_multi_site_support_return() ) {
										$transition_where .= " AND site_id = '" . get_current_blog_id() . "'";
									}
									$transition_post_status = $externaldb->get_results(
										'SELECT * FROM ' . UALP_TABLENAME . '
                                                WHERE ' . $transition_where . ' and hook="transition_post_status" 
                                                ORDER BY hook
                                        '
									);
									$transition_posttype    = array();
									$transition_posttitle   = array();
									foreach ( $transition_post_status as $all_posts ) {
										$post_id_type  = $all_posts->object_type;
										$post_id_title = $all_posts->post_title;
										if ( '' != $post_id_type ) {
											$transition_posttype[ $post_id_type ] = $post_id_type;
										}

										if ( $post_id_type == $reportposttype_list ) {
											$transition_posttitle[ $all_posts->post_id ] = $post_id_title;
										} else {
											$transition_posttitle[ $all_posts->post_id ] = $post_id_title;
										}
										$transition_posttype  = array_unique( $transition_posttype );
										$transition_posttitle = array_unique( $transition_posttitle );
									}
									echo '<div class=" pull-left">';
									echo '<div class="ualp-report-posttype">';
									$tranposttype = array();
									foreach ( $transition_posttype as $key => $val ) {
											$tranposttype[] = sprintf( '<option value="%s" %s>%s</option>', $key, in_array( $key, $reportposttype_list ) ? 'selected="selected"' : '', $val );
									}
									echo '<select class="chosen-filter" name="showposttype" id="ualp-report-showposttype" data-placeholder="' . esc_html__( 'Select Post Type', 'user_activity_log_pro' ) . '" multiple>';
									echo wp_kses( implode( '', $tranposttype ), $args_kses );
									echo '</select>';
									echo '<span class="report-note"><b>' . esc_html__( 'Note', 'user_activity_log_pro' ) . '&nbsp;:&nbsp;</b>' . esc_html__( 'Default All Posts type Selected', 'user_activity_log_pro' ) . '</span>';
									echo '</div>';
									echo '<div class="ualp-report-allpost">';
									$tranallpost = array();
									foreach ( $transition_posttitle as $key => $val ) {
											$tranallpost[] = sprintf( '<option value="%s" %s>%s</option>', $key, in_array( $key, $reportallpost ) ? 'selected="selected"' : '', $val );
									}
									echo '<select class="chosen-filter" name="showallpost" id="ualp-report-showallpost" data-placeholder="' . esc_html__( 'Select Posts', 'user_activity_log_pro' ) . '" multiple>';
									echo wp_kses( implode( '', $tranallpost ), $args_kses );
									echo '</select>';
									echo '<span class="report-note"><b>' . esc_html__( 'Note', 'user_activity_log_pro' ) . '&nbsp;:&nbsp;</b>' . esc_html__( 'Default All Posts Selected', 'user_activity_log_pro' ) . '</span>';
									echo '</div>';
									echo '</div>';
									?>
								</div>
							</div>
						</div>
						<?php if ( ualp_allow_ip() ) { ?>
						<div class="generate_report_type_cover">
							<div class="generate_report_type_label">Select IP Address</div>
							<div class="generate_report_type_value">
								<?php
								if ( $ips && ualp_allow_ip() ) {
									$output = array();
									foreach ( $ips as $ip ) {
										if ( isset( $ip->ip_address ) && '' != $ip->ip_address ) {
											$output[] = sprintf( '<option value="%s" %s>%s</option>', $ip->ip_address, in_array( $ip->ip_address, $ipaddress_list ) ? 'selected="selected"' : '', $ip->ip_address );
										}
									}
									echo '<select class="chosen-filter" name="showip[]" id="ualp-filter-showip" data-placeholder="' . esc_html__( 'Select IP Address', 'user_activity_log_pro' ) . '"multiple>';
									echo wp_kses( implode( '', $output ), $args_kses );
									echo '</select>';
								}
								?>
								<span class="report-note"><b><?php esc_html_e( 'Note', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;</b><?php esc_html_e( 'Default All IP-address Selected', 'user_activity_log_pro' ); ?></span>
							</div>
						</div>
						<?php } ?>
						<?php if ( ualp_allow_country() ) { ?>
						<div class="generate_report_type_cover">
							<div class="generate_report_type_label">Select Country</div>
							<div class="generate_report_type_value">
								<?php
								if ( $countrys && ualp_allow_country() ) {
									$output = array();
									foreach ( $countrys as $country ) {
										if ( isset( $country->country_name ) && '' != $country->country_name ) {
											$output[] = sprintf( '<option value="%s" %s>%s</option>', $country->country_name, in_array( $country->country_name, $country_list ) ? 'selected="selected"' : '', $country->country_name );
										}
									}
									echo '<select class="chosen-filter" name="showcountry[]" id="ualp-filter-showcountry" data-placeholder="' . esc_html__( 'Select Country', 'user_activity_log_pro' ) . '" multiple>';
									echo wp_kses( implode( '', $output ), $args_kses );
									echo '</select>';
								}
								?>
								<span class="report-note"><b><?php esc_html_e( 'Note', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;</b><?php esc_html_e( 'Default All Country Selected', 'user_activity_log_pro' ); ?></span>
							</div>
						</div>
						<?php } ?>
					</div>
					<div class="generate_report_steps_2">
						<b><?php esc_html_e( 'Step 2', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;<?php esc_html_e( 'Select the date range', 'user_activity_log_pro' ); ?></b><br>
						<span class="ualp_schedule_date_description"><?php esc_html_e( 'Note', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;<?php esc_html_e( 'Do not specify any dates if you are creating a scheduled report.', 'user_activity_log_pro' ); ?></span>
						<div class="generate_report_type_cover">
							<div class="generate_report_type_label"><label>Start Date</label>
								<input type="text" name="start_date" value="<?php echo esc_attr( $ualp_generate_report_start_date ); ?>" class="datepicker start-date">
							</div>
							<div class="generate_report_type_label"><label>End Date</label>
								<input type="text" name="end_date" value="<?php echo esc_attr( $ualp_generate_report_end_date ); ?>" class="datepicker end-date">
							</div>
						</div>
					</div>
					<div class="generate_report_steps_3">
						<div class="generate_report_format_wrap">
							<b><?php esc_html_e( 'Step 3', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;<?php esc_html_e( 'Select Report Format', 'user_activity_log_pro' ); ?></b>
							<div class="generate_report_type_cover">
								<span class="report_format_span">
								<input type="radio" name="report_format" value="html" id="rhtml" checked><label for="rhtml">HTML</label>
								</span>
								<span class="report_format_span">
								<input type="radio" name="report_format" value="csv" id="rcsv"><label for="rcsv">CSV</label>
								</span>
								<span class="report_format_span">
								<input type="radio" name="report_format" value="pdf" id="rpdf"><label for="rpdf">PDF</label>
								</span>
								<span class="report_format_span">
								<input type="radio" name="report_format" value="json" id="rjson"><label for="rjson">JSON</label>
								</span>
							</div>
						</div>
					</div>
					<div class="generate-report-submit-wrap">
						<input type="submit" value="Generate Report" name="export" class="button button-primary">
					</div>
					</form>
					<?php
					if ( isset( $_REQUEST['ualp_generate_reports_nonce'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_REQUEST['ualp_generate_reports_nonce'] ) ), 'ualp_generate_reports_action' ) ) {
						$qry_str  = isset( $_SERVER['QUERY_STRING'] ) ? sanitize_text_field( wp_unslash( $_SERVER['QUERY_STRING'] ) ) : '';
						$req_page = isset( $_REQUEST['page'] ) ? sanitize_text_field( wp_unslash( $_REQUEST['page'] ) ) : '';
					}
					?>
					<form method="POST" class="ualpGenerateReportForm" action="<?php echo esc_attr( $adminurl ) . '?' . esc_attr( $qry_str ); ?>">
						<input type="hidden" name="page" value="<?php echo esc_attr( $req_page ); ?>" />
						<div class="generate_schedule_report_wrap">
							<h3><?php esc_html_e( 'Schedule Report Setting', 'user_activity_log_pro' ); ?></h3>
							<span class="schedule_description"><?php esc_html_e( 'Use the button below to use the above criteria for daily, weekly and monthly summary report which is sent automatically via email', 'user_activity_log_pro' ); ?></span>
							<div class="schedule_report_cover">
								<div class="schedule_report_label">
									<label><?php esc_html_e( 'Email Address', 'user_activity_log_pro' ); ?></label>
								</div>
								<div class="schedule_report_value">
									<input type="text" value="" name="ualp_schedule_email" id="ualp_schedule_email" required>
								</div>
							</div>
							<div class="schedule_report_cover">
								<div class="schedule_report_label">
									<label><?php esc_html_e( 'Report Name', 'user_activity_log_pro' ); ?></label>
								</div>
								<div class="schedule_report_value">
									<input type="text" value="" name="ualp_report_name" id="ualp_report_name" required>
									<input type="hidden" value="" name="ualp_report_id" id="ualp_report_id">
								</div>
							</div>
							<div class="schedule_report_cover">
								<div class="schedule_report_label">
									<label><?php esc_html_e( 'Frequency', 'user_activity_log_pro' ); ?></label>
								</div>
								<div class="schedule_report_value">
									<input type="radio" value="daily" name="ualp_report_frequency" id="Daily" checked><label for="Daily"><?php esc_html_e( 'Daily', 'user_activity_log_pro' ); ?></label>&nbsp;
									<input type="radio" value="weekly" name="ualp_report_frequency" id="Weekly"><label for="Weekly"><?php esc_html_e( 'Weekly', 'user_activity_log_pro' ); ?></label>&nbsp;
									<input type="radio" value="monthly" name="ualp_report_frequency" id="Monthly"><label for="Monthly"><?php esc_html_e( 'Monthly', 'user_activity_log_pro' ); ?></label>&nbsp;
									<input type="radio" value="quarterly" name="ualp_report_frequency" id="Quarterly"><label for="Quarterly"><?php esc_html_e( 'Quarterly', 'user_activity_log_pro' ); ?></label>
								</div>
							</div>
							<div class="schedule_submit_wrap">
								<input type="submit" value="Save Change" name="schedule_submit" class="button button-primary">
							</div>
						</div>
						<?php
							$schedule_report_content = $externaldb->get_results( 'SELECT * FROM ' . UALP_SCHEDULE_TABLENAME );
							$s                       = 0;
						if ( isset( $schedule_report_content ) && ! empty( $schedule_report_content ) ) {
							?>
						<div class="schdule_report_list_wrap">
							<h3><?php esc_html_e( 'Configured Report List', 'user_activity_log_pro' ); ?></h3>
							<div class="schedule_error_report_message" style="display:none"><span><?php esc_html_e( 'Something went wrong. Mail not sent.', 'user_activity_log_pro' ); ?></span></div>
							<div class="schedule_report_message" style="display:none"><span><?php esc_html_e( 'Successfully send report', 'user_activity_log_pro' ); ?></span></div>
							<table class="schdule_report_table_wrap widefat">
								<thead>
									<tr>
									<th><?php esc_html_e( 'Name', 'user_activity_log_pro' ); ?></th>
									<th><?php esc_html_e( 'Email Address', 'user_activity_log_pro' ); ?></th>
									<th><?php esc_html_e( 'Frequency', 'user_activity_log_pro' ); ?></th>
									<th><?php esc_html_e( 'Action', 'user_activity_log_pro' ); ?></th>
									</tr>
								</thead>
								<tbody>
								<?php
								foreach ( $schedule_report_content as $all_schedule_report_content ) {
									$report_id         = $all_schedule_report_content->uactrid;
									$report_title      = $all_schedule_report_content->report_title;
									$schedule_email_id = $all_schedule_report_content->schedule_email_id;
									$report_frequency  = $all_schedule_report_content->report_frequency;
									echo '<tr>';
									echo '<td>' . esc_html( $report_title ) . '</td>';
									echo '<td>' . esc_html( $schedule_email_id ) . '</td>';
									echo '<td>' . esc_html( $report_frequency ) . '</td>';
									echo '<td><a class="ualp_schedule_report_send button" data-id="' . esc_attr( $report_id ) . '" href="">' . esc_html__( 'Send Now', 'user_activity_log_pro' ) . '</a>&nbsp;&nbsp;<a class="ualp_schedule_report_edit button" data-id="' . esc_attr( $report_id ) . '" href="">' . esc_html__( 'Edit', 'user_activity_log_pro' ) . '</a>&nbsp;&nbsp;<a class="ualp_schedule_report_delete button" data-id="' . esc_attr( $report_id ) . '" href="">' . esc_html__( 'Delete', 'user_activity_log_pro' ) . '</a></td>';
									echo '</tr>';
									$s++;
								}

								?>
								</tbody>
							</table>
						</div>
					<?php } ?>
					<?php wp_nonce_field( 'ualp_generate_reports_action', 'ualp_generate_reports_nonce' ); ?>
					</form>
				</div>
			</div>
		</div>
		<?php
	}
}
if ( ! function_exists( 'ualp_statistics_reports' ) ) {
	/**
	 * Statitstics
	 */
	function ualp_statistics_reports() {
		if ( is_network_admin() && ualp_multi_site_support_return() ) {
			$adminurl = network_admin_url( 'admin.php' );
		} else {
			$adminurl = admin_url( 'admin.php' );
		}
		global $wpdb, $externaldb;
		$args_kses = ualp_args_kses();
		$qry_str   = '';
		$req_page  = '';
		$users     = $externaldb->get_results( $externaldb->prepare( 'SELECT DISTINCT user_name FROM ' . UALP_TABLENAME . ' WHERE 1 = 1 AND user_name <> %s ORDER BY user_name', '""' ) );
		$user_id   = $externaldb->get_results(
			'SELECT DISTINCT user_id FROM ' . UALP_TABLENAME . ' WHERE 1 = 1 ORDER BY user_id
        '
		);
		if ( isset( $_REQUEST['ualp_generate_statistics_reports_nonce'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_REQUEST['ualp_generate_statistics_reports_nonce'] ) ), 'ualp_generate_statistics_reports_action' ) ) {
			$qry_str  = isset( $_SERVER['QUERY_STRING'] ) ? sanitize_text_field( wp_unslash( $_SERVER['QUERY_STRING'] ) ) : '';
			$req_page = isset( $_REQUEST['page'] ) ? sanitize_text_field( wp_unslash( $_REQUEST['page'] ) ) : '';
		}
		?>
		<form method="POST" class="ualpEmailSettingsForm" action="<?php echo esc_attr( $adminurl ) . '?' . esc_attr( $qry_str ); ?>">
			<input type="hidden" name="page" value="<?php echo esc_attr( $req_page ); ?>" />
				<div class="padding_left_right_15">
					<div class="generatereportcover">
						<h3 class="ualpHeaderTitle"><?php esc_html_e( 'Statistics Reports', 'user_activity_log_pro' ); ?></h3>
						<div class="generate_statistics_report_steps">
							<b><?php esc_html_e( 'Step 1', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;<?php esc_html_e( 'Select the type of report', 'user_activity_log_pro' ); ?></b>
							<div class="generate_report_type_cover">
								<div class="generate_report_statistics_report_section">
									<div class="generate_statistics_report_radio_wrap">
										<label><input type="radio" name="statistics_report_type" value="suser_login" checked><?php esc_html_e( 'Number of Logins for User', 'user_activity_log_pro' ); ?></label>
									</div>
									<div class="generate_statistics_report_select_wrap">
										<?php
										if ( $users ) {
											$output = array();
											foreach ( $users as $_user ) {
												if ( isset( $_user->user_name ) && '' != $_user->user_name ) {
													$output[] = sprintf( '<option value="%s">%s</option>', $_user->user_name, $_user->user_name );
												}
											}
											echo '<select class="js-example-basic-multiple report-multiple" name="susershowlogin" id="ualp-filter-login-usershow">';
											printf( '<option value="">' . esc_html__( 'All User', 'user_activity_log_pro' ) . '</option>' );
											echo wp_kses( implode( '', $output ), $args_kses );
											echo '</select>';
										}
										?>
									</div>
								</div>
							</div>
							<div class="generate_report_type_cover">
								<div class="generate_report_statistics_report_section">
									<div class="generate_statistics_report_radio_wrap">
										<label><input type="radio" name="statistics_report_type" value="suser_role_login"><?php esc_html_e( 'Number of Logins for Users with role of', 'user_activity_log_pro' ); ?></label>
									</div>
									<div class="generate_statistics_report_select_wrap">
										<?php
										if ( $user_id ) {
											$output = array();
											foreach ( $user_id as $alluserroleid ) {
												foreach ( $alluserroleid as $alluserrole ) {
													if ( '' != $alluserrole && 0 != $alluserrole ) {
														$userroles = get_user_by( 'id', $alluserrole );
														if ( isset( $userroles->roles ) ) {
															$user_roles = $userroles->roles;
														} else {
															$user_roles = '';
														}
													} else {
															$user_roles = '';
													}
													if ( '' == $user_roles ) {
														$user_roles = array();
													}
													foreach ( $user_roles as $user_id_role ) {
														$output[] = sprintf( '<option value="%s">%s</option>', $user_id_role, $user_id_role );
													}
												}
											}
											echo '<select class="js-example-basic-multiple report-multiple" name="scapshowlogin" id="ualp-filter-login-capshow">';
											printf( '<option value="">' . esc_html__( 'All Role', 'user_activity_log_pro' ) . '</option>' );
											echo wp_kses( implode( '', array_unique( $output ) ), $args_kses );
											echo '</select>';
										}
										?>
									</div>
								</div>
							</div>
							<div class="generate_report_type_cover">
								<div class="generate_report_statistics_report_section">
									<div class="generate_statistics_report_radio_wrap">
										<label><input type="radio" name="statistics_report_type" value="suser_view"><?php esc_html_e( 'Number of Views for User', 'user_activity_log_pro' ); ?></label>
									</div>
									<div class="generate_statistics_report_select_wrap">
										<?php
										if ( $users ) {
											$output = array();
											foreach ( $users as $_user ) {
												if ( isset( $_user->user_name ) && '' != $_user->user_name ) {
													$output[] = sprintf( '<option value="%s">%s</option>', $_user->user_name, $_user->user_name );
												}
											}
											echo '<select class="js-example-basic-multiple report-multiple" name="susershowview" id="ualp-filter-view-usershow">';
											printf( '<option value="">' . esc_html__( 'All User', 'user_activity_log_pro' ) . '</option>' );
											echo wp_kses( implode( '', $output ), $args_kses );
											echo '</select>';
										}
										?>
									</div>
								</div>
							</div>
							<div class="generate_report_type_cover">
								<div class="generate_report_statistics_report_section">
									<div class="generate_statistics_report_radio_wrap">
										<label><input type="radio" name="statistics_report_type" value="suser_role_view"><?php esc_html_e( 'Number of Views for Users with role of', 'user_activity_log_pro' ); ?></label>
									</div>
									<div class="generate_statistics_report_select_wrap">
										<?php
										if ( $user_id ) {
											$output = array();
											foreach ( $user_id as $alluserroleid ) {
												foreach ( $alluserroleid as $alluserrole ) {
													if ( '' != $alluserrole && 0 != $alluserrole ) {
														$userroles = get_user_by( 'id', $alluserrole );
														if ( isset( $userroles->roles ) ) {
															$user_roles = $userroles->roles;
														} else {
															$user_roles = '';
														}
													} else {
															$user_roles = '';
													}
													if ( '' == $user_roles ) {
														$user_roles = array();
													}
													foreach ( $user_roles as $user_id_role ) {
														$output[] = sprintf( '<option value="%s">%s</option>', $user_id_role, $user_id_role );
													}
												}
											}
											echo '<select class="js-example-basic-multiple report-multiple" name="scapshowview" id="ualp-filter-view-capshow">';
											printf( '<option value="">' . esc_html__( 'All Role', 'user_activity_log_pro' ) . '</option>' );
											echo wp_kses( implode( '', array_unique( $output ) ), $args_kses );
											echo '</select>';
										}
										?>
									</div>
								</div>
							</div>
							<div class="generate_report_type_cover">
								<div class="generate_report_statistics_report_section">
									<div class="generate_statistics_report_radio_wrap">
										<label><input type="radio" name="statistics_report_type" value="suser_publish_content"><?php esc_html_e( 'Number of published content for User', 'user_activity_log_pro' ); ?></label>
									</div>
									<div class="generate_statistics_report_select_wrap">
										<?php
										if ( $users ) {
											$output = array();
											foreach ( $users as $_user ) {
												if ( isset( $_user->user_name ) && '' != $_user->user_name ) {
													$output[] = sprintf( '<option value="%s">%s</option>', $_user->user_name, $_user->user_name );
												}
											}
											echo '<select class="js-example-basic-multiple report-multiple" name="susershowpublish" id="ualp-filter-publish-usershow">';
											printf( '<option value="">' . esc_html__( 'All User', 'user_activity_log_pro' ) . '</option>' );
											echo wp_kses( implode( '', $output ), $args_kses );
											echo '</select>';
										}
										?>
									</div>
								</div>
							</div>
							<div class="generate_report_type_cover">
								<div class="generate_report_statistics_report_section">
									<div class="generate_statistics_report_radio_wrap">
										<label><input type="radio" name="statistics_report_type" value="suser_role_publish_content"><?php esc_html_e( 'Number of published content for Users with role of', 'user_activity_log_pro' ); ?></label>
									</div>
									<div class="generate_statistics_report_select_wrap">
										<?php
										if ( $user_id ) {
											$output = array();
											foreach ( $user_id as $alluserroleid ) {
												foreach ( $alluserroleid as $alluserrole ) {
													if ( '' != $alluserrole && 0 != $alluserrole ) {
														$userroles = get_user_by( 'id', $alluserrole );
														if ( isset( $userroles->roles ) ) {
															$user_roles = $userroles->roles;
														} else {
															$user_roles = '';
														}
													} else {
															$user_roles = '';
													}
													if ( '' == $user_roles ) {
														$user_roles = array();
													}
													foreach ( $user_roles as $user_id_role ) {
														$output[] = sprintf( '<option value="%s">%s</option>', $user_id_role, $user_id_role );
													}
												}
											}
											echo '<select class="js-example-basic-multiple report-multiple" name="scapshowpublish" id="ualp-filter-publish-capshow">';
											printf( '<option value="">' . esc_html__( 'All Role', 'user_activity_log_pro' ) . '</option>' );
											echo wp_kses( implode( '', array_unique( $output ) ), $args_kses );
											echo '</select>';
										}
										?>
									</div>
								</div>
							</div>
						</div>
						<div class="generate_report_statistic_steps_2">
							<b><?php esc_html_e( 'Step 2', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;<?php esc_html_e( 'Select Date Range', 'user_activity_log_pro' ); ?></b>
							<div class="generate_report_type_cover">
								<div class="generate_report_type_label">From Date</div>
								<div class="generate_report_type_value">
									<input type="text" name="start_date" value="" class="datepicker report-start-date">&nbsp;(yyyy-mm-dd)
								</div>
							</div>
							<div class="generate_report_type_cover">
								<div class="generate_report_type_label">To Date</div>
								<div class="generate_report_type_value">
									<input type="text" name="end_date" value="" class="datepicker report-end-date">&nbsp;(yyyy-mm-dd)
								</div>
							</div>
						</div>
						<div class="generate_report_statistic_steps_3">
							<b><?php esc_html_e( 'Step 3', 'user_activity_log_pro' ); ?>&nbsp;:&nbsp;<?php esc_html_e( 'Select Report Format', 'user_activity_log_pro' ); ?></b>
							<div class="generate_report_type_cover">
								<span class="report_format_span">
									<input type="radio" name="sreport_format" value="html" id="srhtml" checked><label for="srhtml">HTML</label>
								</span>
								<span class="report_format_span">
									<input type="radio" name="sreport_format" value="csv" id="srcsv"><label for="srcsv">CSV</label>
								</span>
								<span class="report_format_span">
									<input type="radio" name="sreport_format" value="pdf" id="srpdf"><label for="srpdf">PDF</label>
								</span>
								<span class="report_format_span">
									<input type="radio" name="sreport_format" value="json" id="srjson"><label for="srjson">JSON</label>
								</span>
							</div>
						</div>
						<div class="generate-report-statistic-submit-wrap">
							<input type="submit" value="Generate Statistics Report" name="statistics_export" class="button button-primary">
						</div>
					</div>
				</div>
				<?php wp_nonce_field( 'ualp_generate_statistics_reports_action', 'ualp_generate_statistics_reports_nonce' ); ?>
		</form>
		<?php
	}
}
add_action( 'admin_init', 'ualp_export_report_log' );
if ( ! function_exists( 'ualp_export_report_log' ) ) {
	/**
	 * Export Report Log.
	 */
	function ualp_export_report_log() {
		$result_log1 = array();
		ualp_create_schedule_report();
		$current_time = gmdate( 'M,d,Y h:i:s A' );
		if ( isset( $_REQUEST['ualp_generate_reports_nonce'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_REQUEST['ualp_generate_reports_nonce'] ) ), 'ualp_generate_reports_action' ) ) {
			if ( isset( $_REQUEST['schedule_submit'] ) && 'Save Change' == $_REQUEST['schedule_submit'] ) {
				$schedule_email_id     = '';
				$ualp_report_name      = '';
				$ualp_report_frequency = '';
				if ( isset( $_REQUEST['ualp_schedule_email'] ) && ! empty( $_REQUEST['ualp_schedule_email'] ) ) {
					$schedule_email_id = sanitize_text_field( wp_unslash( $_REQUEST['ualp_schedule_email'] ) );
				}
				if ( isset( $_REQUEST['ualp_report_name'] ) && ! empty( $_REQUEST['ualp_report_name'] ) ) {
					$ualp_report_name = sanitize_text_field( wp_unslash( $_REQUEST['ualp_report_name'] ) );
				}
				if ( isset( $_REQUEST['ualp_report_frequency'] ) && ! empty( $_REQUEST['ualp_report_frequency'] ) ) {
					$ualp_report_frequency = sanitize_text_field( wp_unslash( $_REQUEST['ualp_report_frequency'] ) );
				}
				if ( isset( $_REQUEST['ualp_report_id'] ) && ! empty( $_REQUEST['ualp_report_id'] ) ) {
					$ualp_report_id = sanitize_text_field( wp_unslash( $_REQUEST['ualp_report_id'] ) );
					ualp_update_schedule_data( $schedule_email_id, $ualp_report_name, $ualp_report_frequency, $ualp_report_id );
				} else {
					ualp_insert_schedule_data( $schedule_email_id, $ualp_report_name, $ualp_report_frequency );
				}
				$message = esc_html__( 'Generate Reports updated successfully.', 'user_activity_log_pro' );

				ualp_admin_notice_message( 'updated', $message );
			}
		}
		$ualp_generated_end_date      = '';
		$ualp_generated_start_date    = '';
		$ualp_generated_report_format = '';
		$ualp_generated_username_list = array();
		$ualp_generated_userrole_list = array();
		$ualp_generated_ip_list       = array();
		$ualp_generated_logtype_list  = array();
		$ualp_generated_hook_list     = array();
		$ualp_generated_country_list  = array();
		$ualp_generated_posttype_list = array();
		$ualp_generated_all_post_list = array();
		if ( isset( $_REQUEST['export'] ) && 'Generate Report' == $_REQUEST['export'] ) {
			global $wpdb, $query, $externaldb;
			if ( isset( $_REQUEST['usershow'] ) && '' != $_REQUEST['usershow'] ) {
				$ualp_generated_username_list = array_map( 'sanitize_text_field', wp_unslash( $_REQUEST['usershow'] ) );
			}
			if ( isset( $_REQUEST['capshow'] ) && '' != $_REQUEST['capshow'] ) {
				$ualp_generated_userrole_list = array_map( 'sanitize_text_field', wp_unslash( $_REQUEST['capshow'] ) );
			}
			if ( isset( $_REQUEST['showip'] ) && '' != $_REQUEST['showip'] ) {
				$ualp_generated_ip_list = array_map( 'sanitize_text_field', wp_unslash( $_REQUEST['showip'] ) );
			}
			if ( isset( $_REQUEST['showcountry'] ) && '' != $_REQUEST['showcountry'] ) {
				$ualp_generated_country_list = array_map( 'sanitize_text_field', wp_unslash( $_REQUEST['showcountry'] ) );
			}
			if ( isset( $_REQUEST['showlogtype'] ) && '' != $_REQUEST['showlogtype'] ) {
				$ualp_generated_logtype_list = array_map( 'sanitize_text_field', wp_unslash( $_REQUEST['showlogtype'] ) );
			}
			if ( isset( $_REQUEST['showhook'] ) && '' != $_REQUEST['showhook'] ) {
				$ualp_generated_hook_list = array_map( 'sanitize_text_field', wp_unslash( $_REQUEST['showhook'] ) );
			}
			if ( isset( $_REQUEST['showposttype'] ) && '' != $_REQUEST['showposttype'] ) {
				$ualp_generated_posttype_list = array_map( 'sanitize_text_field', wp_unslash( $_REQUEST['showposttype'] ) );
			}
			if ( isset( $_REQUEST['showallpost'] ) && '' != $_REQUEST['showallpost'] ) {
				$ualp_generated_all_post_list = array_map( 'sanitize_text_field', wp_unslash( $_REQUEST['showallpost'] ) );
			}
			if ( isset( $_REQUEST['start_date'] ) && '' != $_REQUEST['start_date'] ) {
				$ualp_generated_start_date = sanitize_text_field( wp_unslash( $_REQUEST['start_date'] ) );
			}
			if ( isset( $_REQUEST['end_date'] ) && '' != $_REQUEST['end_date'] ) {
				$ualp_generated_end_date = sanitize_text_field( wp_unslash( $_REQUEST['end_date'] ) );
			}
			if ( isset( $_REQUEST['report_format'] ) && '' != $_REQUEST['report_format'] ) {
				$ualp_generated_report_format = sanitize_text_field( wp_unslash( $_REQUEST['report_format'] ) );
			}
			update_option( 'ualp_generate_report_username_list', $ualp_generated_username_list );
			update_option( 'ualp_generate_report_userrole_list', $ualp_generated_userrole_list );
			update_option( 'ualp_generate_report_country_list', $ualp_generated_country_list );
			update_option( 'ualp_generate_report_ipaddress_list', $ualp_generated_ip_list );
			update_option( 'ualp_generate_report_logtype_list', $ualp_generated_logtype_list );
			update_option( 'ualp_generate_report_hook_list', $ualp_generated_hook_list );
			update_option( 'ualp_generate_report_posttype_list', $ualp_generated_posttype_list );
			update_option( 'ualp_generate_report_allpost_list', $ualp_generated_all_post_list );
			update_option( 'ualp_generate_report_start_date', $ualp_generated_start_date );
			update_option( 'ualp_generate_report_end_date', $ualp_generated_end_date );
			update_option( 'ualp_generate_report_format', $ualp_generated_report_format );
			$header     = array();
			$userrole   = '';
			$username   = '';
			$type       = '';
			$ip         = '';
			$time       = '';
			$search     = '';
			$start_date = '';
			$end_date   = '';
			$user_agent = '';
			$t_session  = '';
			$site_id    = '';
			$country    = '';
			$hook       = '';
			$favorite   = '';
			$where      = ' where 1 = 1';
			if ( isset( $ualp_generated_username_list ) && ! empty( $ualp_generated_username_list ) ) {
				$all_username = "'" . implode( "','", $ualp_generated_username_list ) . "'";
				$where       .= " AND user_name IN ($all_username)";
			}
			if ( isset( $ualp_generated_userrole_list ) && ! empty( $ualp_generated_userrole_list ) ) {
				$all_userrole = '' . implode( "%' OR user_role like '%", $ualp_generated_userrole_list ) . '';
				$where       .= " AND (user_role like '%$all_userrole%')";
			}
			if ( isset( $ualp_generated_ip_list ) && ! empty( $ualp_generated_ip_list ) ) {
				$all_ipaddress = "'" . implode( "','", $ualp_generated_ip_list ) . "'";
				$where        .= " AND ip_address IN ($all_ipaddress)";

			}
			if ( isset( $ualp_generated_country_list ) && ! empty( $ualp_generated_country_list ) ) {
				$all_country = "'" . implode( "','", $ualp_generated_country_list ) . "'";
				$where      .= " AND country IN ($all_country)";
			}
			if ( isset( $ualp_generated_hook_list ) && ! empty( $ualp_generated_hook_list ) ) {
				$all_showhook = "'" . implode( "','", $ualp_generated_hook_list ) . "'";
				if ( isset( $ualp_generated_hook_list ) && in_array( 'transition_post_status', $ualp_generated_hook_list ) ) {
					if ( isset( $ualp_generated_posttype_list ) && '' != $ualp_generated_posttype_list ) {
						$where .= " AND object_type = '" . $ualp_generated_posttype_list . "'";
					}
					if ( isset( $ualp_generated_all_post_list ) && '' != $ualp_generated_all_post_list ) {
						$where .= " AND post_id = '" . $ualp_generated_all_post_list . "'";
					}
					if ( isset( $ualp_generated_all_post_list ) && '' == $ualp_generated_all_post_list && isset( $ualp_generated_posttype_list ) && '' == $ualp_generated_posttype_list ) {
						$where .= " AND hook IN ($all_showhook)";
					}
				} else {
					$where .= " AND hook IN ($all_showhook)";
				}
			}
			if ( isset( $ualp_generated_logtype_list ) && ! empty( $ualp_generated_logtype_list ) ) {
				$all_showlogtype = "'" . implode( "','", $ualp_generated_logtype_list ) . "'";
				$where          .= " AND object_type IN ($all_showlogtype)";
			}
			if ( isset( $ualp_generated_start_date ) && isset( $ualp_generated_start_date ) && $ualp_generated_start_date != $ualp_generated_end_date ) {
				if ( isset( $ualp_generated_start_date ) && '' != $ualp_generated_start_date ) {
					$start_time = strtotime( $ualp_generated_start_date );
					$start_time = strtotime( '-1 day', $start_time );
					if ( '' != $start_time ) {
						$start_time = gmdate( 'Y-m-d H:i:s', $start_time );
						$where     .= " AND modified_date > '$start_time' ";
					}
				}
				if ( isset( $ualp_generated_end_date ) && '' != $ualp_generated_end_date ) {
					$end_time = strtotime( $ualp_generated_end_date );
					$end_time = strtotime( '+1 day', $end_time );
					if ( '' != $end_time ) {
						$end_time = gmdate( 'Y-m-d H:i:s', $end_time );
						$where   .= " AND modified_date < '$end_time'";
					}
				}
			} elseif ( isset( $ualp_generated_start_date ) && isset( $ualp_generated_start_date ) && $ualp_generated_start_date == $ualp_generated_end_date ) {
				if ( isset( $ualp_generated_start_date ) && '' != $ualp_generated_start_date ) {
					$start_time = strtotime( $ualp_generated_start_date );
					if ( '' != $start_time ) {
						$start_time = gmdate( 'Y-m-d H:i:s', $start_time );
						$where     .= " AND modified_date >= '$start_time' ";
					}
				}
				if ( isset( $ualp_generated_end_date ) && '' != $ualp_generated_end_date ) {
					$end_time = strtotime( $ualp_generated_end_date );
					$end_time = strtotime( '+1 day', $end_time );
					if ( '' != $end_time ) {
						$end_time = gmdate( 'Y-m-d H:i:s', $end_time );
						$where   .= " AND modified_date < '$end_time'";
					}
				}
			}
			if ( ualp_multi_site_support_return() ) {
				$where .= " AND site_id = '" . get_current_blog_id() . "'";
			}
			$get_log_query    = 'SELECT * FROM ' . UALP_TABLENAME . " $where ORDER BY modified_date desc";
			$result_log_query = $externaldb->get_results( $get_log_query );
			$csv_content      = array();
			$c                = 0;
			$date_format      = get_option( 'date_format' );
			$time_format      = get_option( 'time_format' );
			$logged_head      = '';
			$export_delimiter = ',';
			$random_id        = wp_rand();
			if ( ! empty( $result_log_query ) ) {
				foreach ( $result_log_query as $result_log ) {
					$c++;
					$result_log = (array) $result_log;
					if ( ! ualp_allow_ip() ) {
						if ( isset( $result_log['ip_address'] ) ) {
							unset( $result_log['ip_address'] );
						}
					}
					if ( ! ualp_allow_country() ) {
						unset( $result_log['country'] );
					}
					unset( $result_log['user_agent'] );
					if ( isset( $result_log['uactid'] ) ) {
						$result_log['uactid'] = $c;
					}
					if ( isset( $result_log['favorite'] ) ) {
						if ( 1 == $result_log['favorite'] ) {
							$result_log['favorite'] = 'Yes';
						} elseif ( 0 == $result_log['favorite'] ) {
							$result_log['favorite'] = 'No';
						}
					}
					if ( isset( $result_log['modified_date'] ) ) {
						$get_date                    = strtotime( $result_log['modified_date'] );
						$date                        = gmdate( $date_format, $get_date );
						$time                        = gmdate( $time_format, $get_date );
						$result_log['modified_date'] = $date . ' ' . $time;
					}
					if ( isset( $result_log['description'] ) ) {
						if ( '' == $result_log['description'] ) {
							$action                    = '';
							$post_title                = '';
							$action                    = $result_log['action'];
							$post_title                = $result_log['post_title'];
							$result_log['description'] = $action . ' : ' . $post_title;
						} else {
							$result_log['description'] = html_entity_decode( $result_log['description'] );
						}
					}
					unset( $result_log['t_session'] );
					unset( $result_log['site_id'] );
					unset( $result_log['post_id'] );
					unset( $result_log['user_id'] );
					unset( $result_log['post_title'] );
					unset( $result_log['action'] );

					if ( 'yes' != $logged_head ) {
						foreach ( $result_log as $result_log_key => $result_log_val ) {
							if ( ! in_array( $result_log_key, $header ) ) {
								$header[] = $result_log_key;
							}
						}
						$result_log[ $result_log_key ] = html_entity_decode( $result_log_val );
					}
					$logged_head = 'yes';
					if ( isset( $_REQUEST['report_format'] ) && ( 'html' == $_REQUEST['report_format'] || 'pdf' == $_REQUEST['report_format'] ) ) {
						$htmlresult_log[] = $result_log;
					} else {
						$csv_content[] = $result_log;
					}
				}
			}
			if ( isset( $_REQUEST['report_format'] ) && 'html' == $_REQUEST['report_format'] ) {
				$csv_content  = '';
				$csv_content .= '<div class="ualp_generat_report_wrap">';
				$csv_content .= '<div class="report_header_title_wrap">';
				$csv_content .= '<p class="header_description">Report generated with</p>';
				$csv_content .= ' <h1>User Activity Log Pro</h1>';
				$csv_content .= '</div>';
				$csv_content .= '<div class="ualp_report_content_wrap">';
				$csv_content .= '<div class="report_details_cover">';
				$csv_content .= '<span class="report_details_title"><b>Report details:</b></span>';
				$csv_content .= '<span class="report_generated_span"><b>Generated On</b> : ' . $current_time . '</span>';
				$csv_content .= '</div>';
				$csv_content .= '<div>';
				$csv_content .= '<table>';
				$csv_content .= '<thead>';
				$csv_content .= '<tr>';
				$header       = array_values( $header );
				$header_count = count( $header );
				for ( $h = 0;$h < $header_count; $h++ ) {
					$csv_content .= '<th>';
					if ( 'uactid' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Sr No.', 'user_activity_log_pro' );
					}
					if ( 'user_name' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Author Name', 'user_activity_log_pro' );
					}
					if ( 'user_role' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Author Role', 'user_activity_log_pro' );
					}
					if ( 'user_email' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Author E-mail', 'user_activity_log_pro' );
					}
					if ( ualp_allow_ip() ) {
						if ( 'ip_address' == $header[ $h ] ) {
							$csv_content .= esc_html__( 'IP Address', 'user_activity_log_pro' );
						}
					}
					if ( ualp_allow_country() ) {
						if ( 'country' == $header[ $h ] ) {
							$csv_content .= esc_html__( 'Country', 'user_activity_log_pro' );
						}
					}
					if ( 'modified_date' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Date', 'user_activity_log_pro' );
					}
					if ( 'object_type' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Activity Type', 'user_activity_log_pro' );
					}
					if ( 'hook' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Activity Hook', 'user_activity_log_pro' );
					}
					if ( 'description' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Description', 'user_activity_log_pro' );
					}
					if ( 'favorite' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Favorite?', 'user_activity_log_pro' );
					}
					if ( 't_session' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'T Session', 'user_activity_log_pro' );
					}
					$csv_content .= '</th>';
				}
				$csv_content .= '</tr>';
				$csv_content .= '</thead>';
				$csv_content .= '<tbody>';
				$c            = 0;
				if ( ! empty( $htmlresult_log ) ) {
					foreach ( $htmlresult_log as $htmldatavalue ) {
						$csv_content .= '<tr>';
						foreach ( $htmldatavalue as $htmlcontent ) {
							$csv_content .= '<td>';
							$csv_content .= $htmlcontent;
							$csv_content .= '</td>';
						}
						$csv_content .= '</tr>';
						$c++;
					}
				}
				$csv_content .= '</tbody>';
				$csv_content .= '</table>';
				$csv_content .= '</div>';
				$csv_content .= '</div>';
				$csv_content .= '</div>';
			} elseif ( isset( $_REQUEST['report_format'] ) && 'pdf' == $_REQUEST['report_format'] ) {
				// $csv_content = '';.
				$csv_content  = '<table>';
				$csv_content .= '<tr>';
				$header       = array_values( $header );
				$header_count = count( $header );
				for ( $h = 0;$h < $header_count; $h++ ) {
					$csv_content .= '<td>';
					if ( 'uactid' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Sr No.', 'user_activity_log_pro' );
					}
					if ( 'user_name' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Author Name', 'user_activity_log_pro' );
					}
					if ( 'user_role' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Author Role', 'user_activity_log_pro' );
					}
					if ( 'user_email' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Author E-mail', 'user_activity_log_pro' );
					}
					if ( ualp_allow_ip() ) {
						if ( 'ip_address' == $header[ $h ] ) {
							$csv_content .= esc_html__( 'IP Address', 'user_activity_log_pro' );
						}
					}
					if ( ualp_allow_country() ) {
						if ( 'country' == $header[ $h ] ) {
							$csv_content .= esc_html__( 'Country', 'user_activity_log_pro' );
						}
					}
					if ( ualp_allow_user_agent() ) {
						if ( 'user_agent' == $header[ $h ] ) {
							$csv_content .= esc_html__( 'User Agent', 'user_activity_log_pro' );
						}
					}
					if ( 'modified_date' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Date', 'user_activity_log_pro' );
					}
					if ( 'object_type' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Activity Type', 'user_activity_log_pro' );
					}
					if ( 'hook' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Activity Hook', 'user_activity_log_pro' );
					}
					if ( 'description' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Description', 'user_activity_log_pro' );
					}
					if ( 'favorite' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'Favorite?', 'user_activity_log_pro' );
					}
					if ( 't_session' == $header[ $h ] ) {
						$csv_content .= esc_html__( 'T Session', 'user_activity_log_pro' );
					}
					$csv_content .= '</td>';
				}
				$csv_content .= '</tr>';
				$c            = 0;
				if ( ! empty( $htmlresult_log ) ) {
					foreach ( $htmlresult_log as $htmldatavalue ) {
						$csv_content .= '<tr>';
						foreach ( $htmldatavalue as $htmlcontent ) {
							$csv_content .= '<td>';
							$csv_content .= $htmlcontent;
							$csv_content .= '</td>';
						}
						$csv_content .= '</tr>';
						$c++;
					}
				}
				$csv_content .= '</table>';
			} else {
				$header       = array_values( $header );
				$header_count = count( $header );
				for ( $h = 0;$h < $header_count; $h++ ) {
					if ( 'uactid' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Sr No.', 'user_activity_log_pro' );
					}
					if ( 'user_name' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Author Name', 'user_activity_log_pro' );
					}
					if ( 'user_role' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Author Role', 'user_activity_log_pro' );
					}
					if ( 'user_email' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Author E-mail', 'user_activity_log_pro' );
					}
					if ( ualp_allow_ip() ) {
						if ( 'ip_address' == $header[ $h ] ) {
							$header[ $h ] = esc_html__( 'IP Address', 'user_activity_log_pro' );
						}
					}
					if ( ualp_allow_country() ) {
						if ( 'country' == $header[ $h ] ) {
							$header[ $h ] = esc_html__( 'Country', 'user_activity_log_pro' );
						}
					}
					if ( ualp_allow_user_agent() ) {
						if ( 'user_agent' == $header[ $h ] ) {
							$header[ $h ] = esc_html__( 'User Agent', 'user_activity_log_pro' );
						}
					}
					if ( 'modified_date' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Date', 'user_activity_log_pro' );
					}
					if ( 'object_type' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Activity Type', 'user_activity_log_pro' );
					}
					if ( 'hook' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Activity Hook', 'user_activity_log_pro' );
					}
					if ( 'description' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Description', 'user_activity_log_pro' );
					}
					if ( 'favorite' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Favorite?', 'user_activity_log_pro' );
					}
					if ( 't_session' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'T Session', 'user_activity_log_pro' );
					}
					if ( 'site_id' == $header[ $h ] ) {
						$header[ $h ] = esc_html__( 'Site Name', 'user_activity_log_pro' );
					}
				}
			}
			if ( isset( $_REQUEST['report_format'] ) && 'csv' == $_REQUEST['report_format'] ) {
				$csv_file_name = 'export_user_report_' . gmdate( 'Y-m-d_H-i-s', time() ) . '.csv';
				ualp_report_csv_output( $csv_file_name, $csv_content, $header, $export_delimiter );
			} elseif ( isset( $_REQUEST['report_format'] ) && 'json' == $_REQUEST['report_format'] ) {
				$json_file_name = 'export_user_report_' . gmdate( 'Y-m-d_H-i-s', time() ) . '.json';
				ualp_json_output( $json_file_name, $csv_content );
			} elseif ( isset( $_REQUEST['report_format'] ) && 'html' == $_REQUEST['report_format'] ) {
				$csv_file_name = 'export_user_report_' . gmdate( 'Y-m-d_H-i-s', time() ) . '.html';
				ualp_report_html_output( $csv_content, $header, $csv_file_name, $export_delimiter );
			} elseif ( isset( $_REQUEST['report_format'] ) && 'pdf' == $_REQUEST['report_format'] ) {
				ob_start();
				require 'html2pdf/html2pdf.php';
				$csv_file_name = 'export_user_report_' . gmdate( 'Y-m-d_H-i-s', time() ) . '.pdf';
				$pdf           = new PDF_HTML_Table();
				$pdf->AddPage();
				$pdf->SetFont( 'Arial', '', 10 );
				$pdf->WriteHTML( "User Activity Log Pro<br>$csv_content" );
				$pdf->Output( 'D', $csv_file_name );
				ob_end_flush();
			}
			do_action( 'ualp_export_activity_log' );
			exit();
		}
	}
}
add_action( 'admin_init', 'ualp_statistics_export_report_log' );
if ( ! function_exists( 'ualp_statistics_export_report_log' ) ) {
	/**
	 * Export Statistics Report Log.
	 */
	function ualp_statistics_export_report_log() {
		$current_time = gmdate( 'M,d,Y h:i:s A' );
		$result_log1  = array();
		if ( isset( $_REQUEST['ualp_generate_statistics_reports_nonce'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_REQUEST['ualp_generate_statistics_reports_nonce'] ) ), 'ualp_generate_statistics_reports_action' ) ) {
			if ( isset( $_REQUEST['statistics_export'] ) && 'Generate Statistics Report' == $_REQUEST['statistics_export'] ) {
				global $wpdb, $query, $externaldb;
				$header     = array();
				$userrole   = '';
				$username   = '';
				$type       = '';
				$ip         = '';
				$time       = '';
				$search     = '';
				$start_date = '';
				$end_date   = '';
				$user_agent = '';
				$t_session  = '';
				$site_id    = '';
				$country    = '';
				$hook       = '';
				$favorite   = '';
				ualp_create_schedule_report();
				$where = ' where 1 = 1';
				if ( isset( $_REQUEST['statistics_report_type'] ) ) {
					if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_login' == $_REQUEST['statistics_report_type'] ) {
						$where .= " AND hook like 'wp_login'";
						if ( isset( $_REQUEST['susershowlogin'] ) && 'all' != $_REQUEST['susershowlogin'] ) {
							$userlogin = sanitize_text_field( wp_unslash( $_REQUEST['susershowlogin'] ) );
							$where    .= " AND user_name like '$userlogin'";
						}
					}
					if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_role_login' == $_REQUEST['statistics_report_type'] ) {
						$where .= " AND hook like 'wp_login'";
						if ( isset( $_REQUEST['scapshowlogin'] ) && 'all' != $_REQUEST['scapshowlogin'] ) {
							$userrolelogin = sanitize_text_field( wp_unslash( $_REQUEST['scapshowlogin'] ) );
							$where        .= " AND user_role LIKE '%%" . $userrolelogin . "%%'";
						}
					}
					if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_view' == $_REQUEST['statistics_report_type'] ) {
						$where .= " AND hook IN ('admin_head','wp_head')";
						if ( isset( $_REQUEST['susershowview'] ) && 'all' != $_REQUEST['susershowview'] ) {
							$susershowview = sanitize_text_field( wp_unslash( $_REQUEST['susershowview'] ) );
							$where        .= " AND user_name like '$susershowview'";
						}
					}
					if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_role_view' == $_REQUEST['statistics_report_type'] ) {
						$where .= " AND hook IN ('admin_head','wp_head')";
						if ( isset( $_REQUEST['scapshowview'] ) && 'all' != $_REQUEST['scapshowview'] ) {
							$scapshowview = sanitize_text_field( wp_unslash( $_REQUEST['scapshowview'] ) );
							$where       .= " AND user_role LIKE '%%" . $scapshowview . "%%'";
						}
					}
					if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_publish_content' == $_REQUEST['statistics_report_type'] ) {
						global $wpdb;
						$post_types      = ualp_posttypes();
						$taxonomies      = ualp_taxonomies();
						$list_post_type  = array();
						$list_taxonomies = array();
						foreach ( $post_types as $post_type ) {
							if ( 'wpcf7_contact_form' != $post_type->name && 'custom_css' != $post_type->name && 'customize_changeset' != $post_type->name && 'attachment' != $post_type->name && 'oembed_cache' != $post_type->name && 'wp_block' != $post_type->name ) {
								array_push( $list_post_type, $post_type->name . '_create' );
								array_push( $list_post_type, $post_type->name . '_update' );
								array_push( $list_post_type, $post_type->name . '_delete' );
							}
							if ( 'attachment' == $post_type->name ) {
								array_push( $list_post_type, 'add_' . $post_type->name );
								array_push( $list_post_type, 'edit_' . $post_type->name );
								array_push( $list_post_type, 'delete_' . $post_type->name );
							}
						}
						foreach ( $taxonomies as $taxonomy ) {
							if ( 'wpcf7_contact_form' != $taxonomy->name && 'custom_css' != $taxonomy->name && 'customize_changeset' != $taxonomy->name && 'product_visibility' != $taxonomy->name ) {
								array_push( $list_taxonomies, $taxonomy->name . '_create' );
								array_push( $list_taxonomies, $taxonomy->name . '_update' );
								array_push( $list_taxonomies, $taxonomy->name . '_delete' );
							}
						}
						$final_publish_content = array_merge( $list_post_type, $list_taxonomies );
						$final_post_type       = "'" . implode( "','", $final_publish_content ) . "'";
						$where                .= " AND hook IN ($final_post_type)";
						if ( isset( $_REQUEST['susershowpublish'] ) && '' != $_REQUEST['susershowpublish'] ) {
							$susershowpublish = sanitize_text_field( wp_unslash( $_REQUEST['susershowpublish'] ) );
							$where           .= " AND user_name like '$susershowpublish'";
						}
					}
					if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_role_publish_content' == $_REQUEST['statistics_report_type'] ) {
						global $wpdb;
						$post_types      = ualp_posttypes();
						$taxonomies      = ualp_taxonomies();
						$list_post_type  = array();
						$list_taxonomies = array();
						foreach ( $post_types as $post_type ) {
							if ( 'wpcf7_contact_form' != $post_type->name && 'custom_css' != $post_type->name && 'customize_changeset' != $post_type->name && 'attachment' != $post_type->name && 'oembed_cache' != $post_type->name && 'wp_block' != $post_type->name ) {
								array_push( $list_post_type, $post_type->name . '_create' );
								array_push( $list_post_type, $post_type->name . '_update' );
								array_push( $list_post_type, $post_type->name . '_delete' );
							}
							if ( 'attachment' == $post_type->name ) {
								array_push( $list_post_type, 'add_' . $post_type->name );
								array_push( $list_post_type, 'edit_' . $post_type->name );
								array_push( $list_post_type, 'delete_' . $post_type->name );
							}
						}
						foreach ( $taxonomies as $taxonomy ) {
							if ( 'wpcf7_contact_form' != $taxonomy->name && 'custom_css' != $taxonomy->name && 'customize_changeset' != $taxonomy->name && 'product_visibility' != $taxonomy->name ) {
								array_push( $list_taxonomies, $taxonomy->name . '_create' );
								array_push( $list_taxonomies, $taxonomy->name . '_update' );
								array_push( $list_taxonomies, $taxonomy->name . '_delete' );
							}
						}
						$final_publish_content = array_merge( $list_post_type, $list_taxonomies );
						$final_post_type       = "'" . implode( "','", $final_publish_content ) . "'";
						$where                .= " AND hook IN ($final_post_type)";
						if ( isset( $_REQUEST['scapshowpublish'] ) && '' != $_REQUEST['scapshowpublish'] ) {
							$scapshowpublish = sanitize_text_field( wp_unslash( $_REQUEST['scapshowpublish'] ) );
							$where          .= " AND user_role LIKE '%%" . $scapshowpublish . "%%'";
						}
					}
				}
				if ( isset( $_REQUEST['start_date'] ) && isset( $_REQUEST['end_date'] ) && $_REQUEST['start_date'] != $_REQUEST['end_date'] ) {
					if ( isset( $_REQUEST['start_date'] ) && '' != $_REQUEST['start_date'] ) {
						$start_time = strtotime( sanitize_text_field( wp_unslash( $_REQUEST['start_date'] ) ) );
						$start_time = strtotime( '-1 day', $start_time );
						if ( '' != $start_time ) {
							$start_time = gmdate( 'Y-m-d H:i:s', $start_time );
							$where     .= " AND modified_date > '$start_time' ";
						}
					}
					if ( isset( $_REQUEST['end_date'] ) && '' != $_REQUEST['end_date'] ) {
						$end_time = strtotime( sanitize_text_field( wp_unslash( $_REQUEST['end_date'] ) ) );
						$end_time = strtotime( '+1 day', $end_time );
						if ( '' != $end_time ) {
							$end_time = gmdate( 'Y-m-d H:i:s', $end_time );
							$where   .= " AND modified_date < '$end_time'";
						}
					}
				} elseif ( isset( $_REQUEST['start_date'] ) && isset( $_REQUEST['start_date'] ) && $_REQUEST['start_date'] == $_REQUEST['end_date'] ) {
					if ( isset( $_REQUEST['start_date'] ) && '' != $_REQUEST['start_date'] ) {
						$start_time = strtotime( sanitize_text_field( wp_unslash( $_REQUEST['start_date'] ) ) );
						if ( '' != $start_time ) {
							$start_time = gmdate( 'Y-m-d H:i:s', $start_time );
							$where     .= " AND modified_date >= '$start_time' ";
						}
					}
					if ( isset( $_REQUEST['end_date'] ) && '' != $_REQUEST['end_date'] ) {
						$end_time = strtotime( sanitize_text_field( wp_unslash( $_REQUEST['end_date'] ) ) );
						$end_time = strtotime( '+1 day', $end_time );
						if ( '' != $end_time ) {
							$end_time = gmdate( 'Y-m-d H:i:s', $end_time );
							$where   .= " AND modified_date < '$end_time'";
						}
					}
				}
				if ( ualp_multi_site_support_return() ) {
					$where .= " AND site_id = '" . get_current_blog_id() . "'";
				}
				$get_log_query    = 'SELECT * FROM ' . UALP_TABLENAME . " $where ORDER BY modified_date desc";
				$result_log_query = $externaldb->get_results( $get_log_query );
				$header           = array();
				$csv_content      = array();
				$content_name     = 'all';
				$content_value    = '';
				if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_login' == $_REQUEST['statistics_report_type'] ) {
					$header_name  = 'User Name';
					$header_value = 'No. of logins';
					if ( isset( $_REQUEST['susershowlogin'] ) && '' != $_REQUEST['susershowlogin'] ) {
						$content_name = sanitize_text_field( wp_unslash( $_REQUEST['susershowlogin'] ) );
					}
					$content_value = count( $result_log_query ) . ' times';
				}
				if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_role_login' == $_REQUEST['statistics_report_type'] ) {
					$header_name  = 'Role Name';
					$header_value = 'No. of logins';
					if ( isset( $_REQUEST['scapshowlogin'] ) && '' != $_REQUEST['scapshowlogin'] ) {
						$content_name = sanitize_text_field( wp_unslash( $_REQUEST['scapshowlogin'] ) );
					}
					$content_value = count( $result_log_query ) . ' times';
				}
				if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_view' == $_REQUEST['statistics_report_type'] ) {
					$header_name  = 'User Name';
					$header_value = 'No. of Page views';
					if ( isset( $_REQUEST['susershowview'] ) && '' != $_REQUEST['susershowview'] ) {
						$content_name = sanitize_text_field( wp_unslash( $_REQUEST['susershowview'] ) );
					}
					$content_value = count( $result_log_query ) . ' times';
				}
				if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_role_view' == $_REQUEST['statistics_report_type'] ) {
					$header_name  = 'Role Name';
					$header_value = 'No. of Page views';
					if ( isset( $_REQUEST['scapshowview'] ) && '' != $_REQUEST['scapshowview'] ) {
						$content_name = sanitize_text_field( wp_unslash( $_REQUEST['scapshowview'] ) );
					}
					$content_value = count( $result_log_query ) . ' times';
				}
				if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_publish_content' == $_REQUEST['statistics_report_type'] ) {
					$header_name  = 'User Name';
					$header_value = 'No. of Publish Content';
					if ( isset( $_REQUEST['susershowpublish'] ) && '' != $_REQUEST['susershowpublish'] ) {
						$content_name = sanitize_text_field( wp_unslash( $_REQUEST['susershowpublish'] ) );
					}
					$content_value = count( $result_log_query ) . ' times';
				}
				if ( isset( $_REQUEST['statistics_report_type'] ) && 'suser_role_publish_content' == $_REQUEST['statistics_report_type'] ) {
					$header_name  = 'Role Name';
					$header_value = 'No. of Publish Content';
					if ( isset( $_REQUEST['scapshowpublish'] ) && '' != $_REQUEST['scapshowpublish'] ) {
						$content_name = sanitize_text_field( wp_unslash( $_REQUEST['scapshowpublish'] ) );
					}
					$content_value = count( $result_log_query ) . ' times';
				}
				if ( isset( $_REQUEST['sreport_format'] ) && 'csv' == $_REQUEST['sreport_format'] ) {
					$data          = '';
					$data         .= $header_name . ',' . $header_value . "\n";
					$data         .= $content_name . ',' . $content_value . "\n";
					$csv_file_name = 'export_user_report_' . gmdate( 'Y-m-d_H-i-s', time() ) . '.csv';
					header( 'Content-Type: application/csv' );
					header( 'Content-Disposition: attachment; filename="' . $csv_file_name . '"' );
					echo $data;
				}
				if ( isset( $_REQUEST['sreport_format'] ) && 'json' == $_REQUEST['sreport_format'] ) {
					$data = wp_json_encode(
						array(
							$header_name  => $content_name,
							$header_value => $content_value,
						)
					);

					$csv_file_name = 'export_user_report_' . gmdate( 'Y-m-d_H-i-s', time() ) . '.json';
					header( 'Content-Type: application/json' );
					header( 'Content-Disposition: attachment; filename="' . $csv_file_name . '"' );
					echo $data;
				}
				if ( isset( $_REQUEST['sreport_format'] ) && 'html' == $_REQUEST['sreport_format'] ) {
					$data     = '';
					$data    .= "<div class='statictic_report_Wrapper'><div class='statistic_report_title'><h1>Statistics Report</h1></div><span class='report_generated_span'><b>Created On:&nbsp;</b>" . $current_time . "</span><div class='statistics_report_content'><table><thead><tr><th>" . $header_name . '</th><th>' . $header_value . '</th></tr></thead><tbody><tr><td>' . $content_name . '</td><td>' . $content_value . '</td></tr></tbody></tbody></table></div></div>';
					$data    .= '
					<style>
					table thead tr {
						background: #000;
						color: #fff;
						opacity: 0.6;
					}
					.tr:nth-child(even) {
						background-color: #f1f1f1;
					}
					.statistics_report_content table {
						width: 50%;
						border: 2px solid #000;
						text-align: center;
						margin: 0 auto;
					}
					table tbody tr td,
					table thead tr th {
						padding: 20px;
					}
					table tbody tr td {
						padding: 20px;
						border: 1px solid #000;
					}
					.statistic_report_title {
						display: inline-block;
						width: 100%;
						text-align: center;
					}
					.statistic_report_title h1 {
						border-bottom: 2px solid red;
						display: inline-block;
						padding-bottom: 20px;
						margin-bottom: 30px;
					}
					.report_generated_span {
						display: inline-block;
						width: 100%;
						text-align: center;
						margin-bottom: 50px;
					}
					</style>
					';
					$filename = 'export_user_report_' . gmdate( 'Y-m-d_H-i-s', time() ) . '.html';
					if ( $filename ) {
						header( 'Content-type: text/html; charset=utf-8' );
						header( 'Content-Disposition: attachment; filename="' . $filename . '"' );
						header( 'Pragma: no-cache' );
						header( 'Expires: 0' );
						echo $data;
					}
				}
				if ( isset( $_REQUEST['sreport_format'] ) && 'pdf' == $_REQUEST['sreport_format'] ) {
					ob_start();
					$data = $header_name . ' : ' . $content_name . '<br>' . $header_value . ' : ' . $content_value;
					require 'html2pdf/html2pdf.php';
					$filename = 'export_user_report_' . gmdate( 'Y-m-d_H-i-s', time() ) . '.pdf';
					$pdf      = new PDF_HTML_Table();
					$pdf->AddPage();
					$pdf->SetFont( 'Arial', '', 10 );
					$pdf->WriteHTML( "User Activity Log Pro<br>$data" );
					$pdf->Output( 'D', $filename );
					ob_end_flush();
				}
				do_action( 'ualp_export_activity_log' );
				exit();
			}
		}
	}
}
