<?php
/**
 * Hook Details.
 *
 * @package User Activity Log PRO
 */

/**
 * Exit if accessed directly
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
global $wpdb;
$post_types = ualp_posttypes();
$taxonomies = ualp_taxonomies();
?>
<div class="wrap">
	<h1><?php esc_html_e( 'All Activities Description', 'user_activity_log_pro' ); ?></h1>
	<div class="ualpHookDescriptionWrapper">
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'Page Views', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<tr>
					<td><?php esc_html_e( 'admin_head', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When a user can view any pages on the admin side area.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_head', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'User can view pages on the front side area.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( '404 page', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When the user views any 404 pages on the front side area.', 'user_activity_log_pro' ); ?></td>
				</tr>
			</table>
		</div>
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'Menu', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_create_nav_menu', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When a navigation menu is successfully created.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_update_nav_menu', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When a navigation menu item is successfully updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'delete_nav_menu', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When a navigation menu is successfully deleted.', 'user_activity_log_pro' ); ?></td>
				</tr>
			</table>
		</div>
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'Post type', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<?php
				foreach ( $post_types as $posttype ) {
					if ( 'wpcf7_contact_form' != $posttype->name && 'custom_css' != $posttype->name && 'customize_changeset' != $posttype->name ) {
						?>
				<tr>
					<td><?php echo esc_html( $posttype->label ); ?> Create <?php echo '( ' . esc_html( $posttype->name ) . '_create )'; ?></td>
					<td>
						<?php
						esc_html_e( 'When', 'user_activity_log_pro' );
						echo ' ' . esc_html( $posttype->name ) . ' ';
						esc_html_e( 'is created.', 'user_activity_log_pro' );
						?>
					</td>
				</tr>
				<tr>
					<td><?php echo esc_html( $posttype->label ); ?> Update <?php echo '( ' . esc_html( $posttype->name ) . '_update )'; ?></td>
					<td>
						<?php
						esc_html_e( 'When', 'user_activity_log_pro' );
						echo ' ' . esc_html( $posttype->name ) . ' ';
						esc_html_e( 'is updated.', 'user_activity_log_pro' );
						?>
					</td>
				</tr>
				<tr>
					<td><?php echo esc_html( $posttype->label ); ?> Delete <?php echo '( ' . esc_html( $posttype->name ) . '_delete )'; ?></td>
					<td>
						<?php
						esc_html_e( 'When', 'user_activity_log_pro' );
						echo ' ' . esc_html( $posttype->name ) . ' ';
						esc_html_e( 'is deleted.', 'user_activity_log_pro' );
						?>
					</td>
				</tr>
						<?php
					}
				}
				?>
			</table>
		</div>
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'Taxonomy', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<?php
				foreach ( $taxonomies as $taxonomy_data ) {
					if ( 'wpcf7_contact_form' != $taxonomy_data->name && 'custom_css' != $taxonomy_data->name && 'customize_changeset' != $taxonomy_data->name && 'product_visibility' != $taxonomy_data->name ) {
						?>
				<tr>
					<td>
						<?php
						echo esc_html( $taxonomy_data->label ) . ' Create';
						echo ' ( ' . esc_html( $taxonomy_data->name ) . '_create )';
						?>
					</td>
					<td>
						<?php
						echo esc_html( $taxonomy_data->label ) . ' : ';
						esc_html_e( 'When', 'user_activity_log_pro' );
						echo ' ' . esc_html( $taxonomy_data->name ) . ' ';
						esc_html_e( 'is created.', 'user_activity_log_pro' );
						?>
					</td>
				</tr>
				<tr>
					<td>
						<?php
						echo esc_html( $taxonomy_data->label ) . ' Update';
						echo ' ( ' . esc_html( $taxonomy_data->name ) . '_update )';
						?>
					</td>
					<td>
						<?php
						echo esc_html( $taxonomy_data->label ) . ' : ';
						esc_html_e( 'When', 'user_activity_log_pro' );
						echo ' ' . esc_html( $taxonomy_data->name ) . ' ';
						esc_html_e( 'is updated.', 'user_activity_log_pro' );
						?>
					</td>
				</tr>
				<tr>
					<td>
						<?php
						echo esc_html( $taxonomy_data->label ) . ' Delete';
						echo ' ( ' . esc_html( $taxonomy_data->name ) . '_delete )';
						?>
					</td>
					<td>
						<?php
						echo esc_html( $taxonomy_data->label ) . ' : ';
						esc_html_e( 'When', 'user_activity_log_pro' );
						echo ' ' . esc_html( $taxonomy_data->name ) . ' ';
						esc_html_e( 'is deleted.', 'user_activity_log_pro' );
						?>
					</td>
				</tr>
						<?php
					}
				}
				?>
			</table>
		</div>
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'Plugins', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<tr>
					<td><?php esc_html_e( 'activated_plugin', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when any plugin is activated on the site.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'deactivated_plugin', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when any plugin is deactivated on the site.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'delete_plugin', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when any plugin is delete on the site.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_redirect', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when any plugin file change in plugin-editor.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'plugin_installed', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when any plugin install on the site.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'plugin_updated', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when any plugin update on the site.', 'user_activity_log_pro' ); ?></td>
				</tr>
			</table>
		</div>
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'User Activity Log Settings', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<tr>
					<td><?php esc_html_e( 'ualp_export_activity_log', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Export User Activity log data in your site.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'ualp_general_settings_updated', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When an option to change in the General Setting tab.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'ualp_hook_log_settings_updated', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When any option to change in Hook tab.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'ualp_manage_role', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When any option to change in Role Mangenger tab.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'ualp_set_password', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Set password in User Activity Log menu inside Password Setting tab.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'ualp_change_password', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When user change password on User Activity Log menu inside Password Setting tab.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'ualp_email_settings_updated', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When user can change option on Email setting page.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'ualp_custom_event_log_updated', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When add, update and delete Custom Event tab.', 'user_activity_log_pro' ); ?></td>
				</tr>
			</table>
		</div>
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'User', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_login', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When user has sucessfull logged. ', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_login_failed', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When users has not sucessfully login.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_logout', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Log the current user out, by destroying the current user session.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'delete_user', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When user is delete for users list page.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'user_register', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When new user is registered in Users List Page.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'insert_user_meta', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When Update Details for user.', 'user_activity_log_pro' ); ?></td>
				</tr>
			</table>
		</div>
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'Theme', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_redirect', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when any theme file change in theme-editor page.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'switch_theme', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Switches current theme to new theme', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'customize_save', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When theme customize is update.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'theme_updated', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when theme update in you site.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'theme_installed', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when any theme install in you site.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'delete_themes', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'when any theme delete in you site.', 'user_activity_log_pro' ); ?></td>
				</tr>
			</table>
		</div>
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'Theme', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_insert_comment', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Inserts a comment into the database.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'edit_comment', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Update a comment data.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'delete_comment', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Delete comment into the database.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'trash_comment', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Moves a comment into the Trash.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'spam_comment', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'The comment to be marked as spam.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'restore_comment', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Comment is successfully restore.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'comment_approve', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Sets the status of a comment is approve.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'comment_unapprove', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Sets the status of a comment is unapprove.', 'user_activity_log_pro' ); ?></td>
				</tr>
			</table>
		</div>
		<div Class="ualp_hook_details_wrap">
			<div class="ualp_hook_detail_title"><h3><?php esc_html_e( 'Other', 'user_activity_log_pro' ); ?><h3></div>
			<table class="widefat post">
				<tr>
					<th><?php esc_html_e( 'Hook Name', 'user_activity_log_pro' ); ?></th>
					<th><?php esc_html_e( 'Hook Description', 'user_activity_log_pro' ); ?></th>
				</tr>
				<tr>
					<td><?php esc_html_e( '_core_updated_successfully', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When WordPress core has been successfully updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'import_end', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When import WordPress data in site.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'export_wp', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When Export WordPress data in site.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'widget_update_callback', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Add, Update and delete Widget into the widget area section.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'updated_option', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Settings option updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'dbdelta_queries', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Table create, update or delete from the database by plugin or theme.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_privacy_personal_data_exporters', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Export the Personal Data in ZIP file.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'wp_privacy_personal_data_erasers', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Erase the Personal Data.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php if ( is_plugin_active( 'woocommerce/woocommerce.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'updated_option (Woocommerce)', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When Woocommerce settings option is updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<tr>
					<td><?php esc_html_e( 'Woocommerce product variation', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Woocommerce variation created, updated, deleted', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'buddypress/bp-loader.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'BuddyPress', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'BuddyPress group created, updated, deleted,ban,unband,promoted,demoted.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'gravityforms/gravityforms.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'Gravity forms', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Gravity forms settings options are updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'wordfence/wordfence.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'Wordfence', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Wordfence settings options are updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'wordpress-seo/wp-seo.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'Yoast SEO', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Yoast SEO settings options are updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'blog-designer-pro/blog-designer-pro.php' ) ) { ?>
					<tr>
						<td><?php esc_html_e( 'Blog Designer Pro', 'user_activity_log_pro' ); ?></td>
						<td><?php esc_html_e( 'Blog Designer Pro layout created, updated, deleted. Import, export, duplicate layouts.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'portfolio-designer/portfolio-designer.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'Portfolio Designer', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Portfolio Designer layout and Post type created, updated, deleted. Import, export, duplicate layouts.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'easy-digital-downloads/easy-digital-downloads.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'Easy Digital Download', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Easy Digital Download settings options are updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'bbpress/bbpress.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'bbPress', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'bbPress Forum settings options are updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'autoptimize/autoptimize.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'Autoptimize', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'Autoptimize settings options are updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'users-ultra/xoousers.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'User ultra membership', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'User ultra membership settings options are updated.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
				<?php if ( is_plugin_active( 'user-switching/user-switching.php' ) ) { ?>
				<tr>
					<td><?php esc_html_e( 'User switching', 'user_activity_log_pro' ); ?></td>
					<td><?php esc_html_e( 'When switch user, switch back user and switch off user.', 'user_activity_log_pro' ); ?></td>
				</tr>
				<?php } ?>
			</table>
		</div>
	</div>
</div>
