<?php
/**
 * BBPress Hook.
 *
 * @package User Activity Log PRO
 */

/**
 * Exit if accessed directly.
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! function_exists( 'ualp_bbpress_options' ) ) {
	/**
	 * Filter to add bbPress options.
	 *
	 * @param array $ualp_options_array options array.
	 */
	function ualp_bbpress_options( $ualp_options_array ) {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'bbpress_settings', $log_hook_list ) ) {
			$whitelist_options_array = array( '_bbp_edit_lock', '_bbp_throttle_time', '_bbp_allow_anonymous', '_bbp_allow_global_access', '_bbp_default_role', '_bbp_allow_revisions', '_bbp_enable_favorites', '_bbp_enable_subscriptions', '_bbp_allow_topic_tags', '_bbp_allow_search', '_bbp_use_wp_editor', '_bbp_use_autoembed', '_bbp_allow_threaded_replies', '_bbp_thread_replies_depth', '_bbp_topics_per_page', '_bbp_replies_per_page', '_bbp_topics_per_rss_page', '_bbp_replies_per_rss_page', '_bbp_root_slug', '_bbp_include_root', '_bbp_show_on_root', '_bbp_forum_slug', '_bbp_topic_slug', '_bbp_topic_tag_slug', '_bbp_view_slug', '_bbp_reply_slug', '_bbp_search_slug', '_bbp_user_slug', '_bbp_topic_archive_slug', '_bbp_reply_archive_slug', '_bbp_user_favs_slug', '_bbp_user_subs_slug' );
			$ualp_options_array      = array_merge( $ualp_options_array, $whitelist_options_array );
			$user                    = wp_get_current_user();
			ualp_send_email_notification( 'bbpress_settings', $user->user_login, 'bbPress Settings updated' );
			ualp_send_sms_notification( 'bbpress_settings', $user->user_login, 'bbPress Settings updated' );
		}
		return $ualp_options_array;
	}
}

add_filter( 'ualp_options_array', 'ualp_bbpress_options', 10 );
