<?php
/**
 * Contact 7 Hook.
 *
 * @package User Activity Log PRO
 */

/**
 * Exit if accessed directly
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


if ( ! function_exists( 'ualp_hookwpcf7_create' ) ) {
	/**
	 * Get activity for wpcf7 Create.
	 *
	 * @param int $cf7 Contact Form.
	 */
	function ualp_hookwpcf7_create( $cf7 ) {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'wpcf7_after_create', $log_hook_list ) ) {
			$action      = 'Form Created';
			$obj_type    = 'Contact Form 7';
			$post_id     = '';
			$cf7         = current( (array) $cf7 );
			$cf7         = get_the_title( $cf7 );
			$post_title  = $cf7;
			$hook        = 'wpcf7_after_create';
			$description = "$obj_type : '$post_title' $action";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );

		}
	}
}

add_action( 'wpcf7_after_create', 'ualp_hookwpcf7_create', 10, 1 ); // new.

if ( ! function_exists( 'ualp_hookwpcf7_update' ) ) {
	/**
	 * Get activity for wpcf7 Update.
	 *
	 * @param int $cf7 Contact Form.
	 */
	function ualp_hookwpcf7_update( $cf7 ) {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'wpcf7_after_update', $log_hook_list ) ) {
			$action      = 'Form Updated';
			$obj_type    = 'Contact Form 7';
			$post_id     = '';
			$cf7         = current( (array) $cf7 );
			$cf7         = get_the_title( $cf7 );
			$post_title  = $cf7;
			$hook        = 'wpcf7_after_update';
			$description = "$obj_type : '$post_title' $action";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'wpcf7_after_update', 'ualp_hookwpcf7_update', 10, 1 ); // new.

if ( ! function_exists( 'ualp_hookwpcf7_delete' ) ) {
	/**
	 * Get activity for wpcf7 Delete.
	 */
	function ualp_hookwpcf7_delete() {
		if ( empty( $_REQUEST['message'] ) ) {
			return;
		}
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'wpcf7_admin_notices', $log_hook_list ) ) {
			if ( 'deleted' == $_REQUEST['message'] ) {
				$action      = 'Form Deleted';
				$obj_type    = 'Contact Form 7';
				$post_id     = '';
				$post_title  = $obj_type;
				$hook        = 'wpcf7_admin_notices';
				$description = "$obj_type : $post_title $action";
				ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
			}
		}
	}
}
add_action( 'wpcf7_admin_notices', 'ualp_hookwpcf7_delete' ); // new.

if ( ! function_exists( 'ualp_hook_contact_form7_settings' ) ) {
	/**
	 * Fires when contact form 7 integration updated.
	 *
	 * @param string $action Action Name.
	 */
	function ualp_hook_contact_form7_settings( $action ) {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'wpcf7-recaptcha-setup', $log_hook_list ) ) {
			if ( 'wpcf7-recaptcha-setup' == $action ) {
				$post_title  = 'Recaptcha Settings Updated';
				$obj_type    = 'Contact Form 7';
				$post_id     = '';
				$hook        = 'wpcf7-recaptcha-setup';
				$description = "$obj_type : $post_title";
				ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
			}
		}
	}
}

add_action( 'check_admin_referer', 'ualp_hook_contact_form7_settings', 10 );
