<?php
/**
 * User Activity Log PRO Hook.
 *
 * @package User Activity Log PRO
 */

/**
 * Exit if accessed directly
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}


if ( ! function_exists( 'ualp_hook_ualp_export_log' ) ) {
	/**
	 * Add log for export user activities log.
	 */
	function ualp_hook_ualp_export_log() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_export_activity_log', $log_hook_list ) ) {
			$action      = 'Export';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Export Activity Log';
			$hook        = 'ualp_export_activity_log';
			$description = "$obj_type : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_export_activity_log', 'ualp_hook_ualp_export_log' ); // new.

if ( ! function_exists( 'ualp_hook_ualp_general_settings' ) ) {
	/**
	 * Add log for general settings.
	 */
	function ualp_hook_ualp_general_settings() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_general_settings_updated', $log_hook_list ) ) {
			$action      = 'Settings';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'General Settings updated';
			$hook        = 'ualp_general_settings_updated';
			$description = "$obj_type : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_general_settings_updated', 'ualp_hook_ualp_general_settings' ); // new.

if ( ! function_exists( 'ualp_hook_ualp_log_hook_settings' ) ) {
	/**
	 * Add log for hook settings.
	 */
	function ualp_hook_ualp_log_hook_settings() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_hook_log_settings_updated', $log_hook_list ) ) {
			$action      = 'Settings';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Log Hook Settings updated';
			$hook        = 'ualp_hook_log_settings_updated';
			$description = "$obj_type : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_hook_log_settings_updated', 'ualp_hook_ualp_log_hook_settings' ); // new.

if ( ! function_exists( 'ualp_hook_ualp_role_settings' ) ) {
	/**
	 * Add log for hook settings.
	 */
	function ualp_hook_ualp_role_settings() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_manage_role', $log_hook_list ) ) {
			$action      = 'Settings';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Role settings updated';
			$hook        = 'ualp_manage_role';
			$description = "$obj_type : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_manage_role', 'ualp_hook_ualp_role_settings' ); // new.

if ( ! function_exists( 'ualp_hook_ualp_password_set' ) ) {
	/**
	 * Add log for set password.
	 */
	function ualp_hook_ualp_password_set() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_set_password', $log_hook_list ) ) {
			$action      = 'Settings';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Password Set';
			$hook        = 'ualp_set_password';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_set_password', 'ualp_hook_ualp_password_set' ); // new.

if ( ! function_exists( 'ualp_hook_ualp_password_change' ) ) {
	/**
	 * Add log for change password.
	 */
	function ualp_hook_ualp_password_change() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_change_password', $log_hook_list ) ) {
			$action      = 'Settings';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Password Updated';
			$hook        = 'ualp_change_password';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_change_password', 'ualp_hook_ualp_password_change' ); // new.

if ( ! function_exists( 'ualp_hook_ualp_custom_event' ) ) {
	/**
	 * Add log for update custom event.
	 */
	function ualp_hook_ualp_custom_event() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_custom_event_log_updated', $log_hook_list ) ) {
			$action      = 'Settings Updated';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Custom Event Updated';
			$hook        = 'ualp_custom_event_log_updated';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_custom_event_log_updated', 'ualp_hook_ualp_custom_event' ); // new.

if ( ! function_exists( 'ualp_hook_ualp_exclude_log' ) ) {
	/**
	 * Add log for excluding some options.
	 */
	function ualp_hook_ualp_exclude_log() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_exclude_log_updated', $log_hook_list ) ) {
			$action      = 'Settings Updated';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Exclude Log Setting Update';
			$hook        = 'ualp_exclude_log_updated';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_exclude_log_updated', 'ualp_hook_ualp_exclude_log' ); // new.


/* [1] --------- EMAIL__UALP ------------------------*/
if ( ! function_exists( 'ualp_hook_email_settings_updated' ) ) {
	/**
	 * Add log for email settings update.
	 */
	function ualp_hook_email_settings_updated() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_email_settings_updated', $log_hook_list ) ) {
			$action      = 'Settings';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Email Settings Updated';
			$hook        = 'ualp_email_settings_updated';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_email_settings_updated', 'ualp_hook_email_settings_updated' ); // new.
/* [2] --------- EMAIL__UALP ------------------------*/
if ( ! function_exists( 'ualp_hook_ualp_insert_email_notification' ) ) {
	/**
	 * Add log for inserting the email notifiication.
	 */
	function ualp_hook_ualp_insert_email_notification() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_insert_email_notification', $log_hook_list ) ) {
			$action      = 'Trigger notification created';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Email Trigger Notification Create';
			$hook        = 'ualp_insert_email_notification';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_insert_email_notification', 'ualp_hook_ualp_insert_email_notification' ); // new.
/* [3] --------- EMAIL__UALP ------------------------*/
if ( ! function_exists( 'ualp_hook_ualp_update_email_notification' ) ) {
	/**
	 * Add log for email notification update.
	 */
	function ualp_hook_ualp_update_email_notification() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_update_email_notification', $log_hook_list ) ) {
			$action      = 'Trigger notification updated';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Email Trigger Notification Update';
			$hook        = 'ualp_update_email_notification';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_update_email_notification', 'ualp_hook_ualp_update_email_notification' ); // new.



/* [1] --------- SMS__UALP ------------------------*/
if ( ! function_exists( 'ualp_hook_sms_settings_updated' ) ) {
	/**
	 * Add log for sms settings update.
	 */
	function ualp_hook_sms_settings_updated() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_sms_settings_updated', $log_hook_list ) ) {
			$action      = 'Settings';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Sms Settings Updated';
			$hook        = 'ualp_sms_settings_updated';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_sms_settings_updated', 'ualp_hook_sms_settings_updated' ); // new.
/* [2] --------- SMS__UALP ------------------------*/
if ( ! function_exists( 'ualp_hook_ualp_insert_sms_notification' ) ) {
	/**
	 * Add log for inserting the sms notification.
	 */
	function ualp_hook_ualp_insert_sms_notification() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_insert_sms_notification', $log_hook_list ) ) {
			$action      = 'Trigger notification created';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'SMS Trigger Notification Create';
			$hook        = 'ualp_insert_sms_notification';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_insert_sms_notification', 'ualp_hook_ualp_insert_sms_notification' ); // new.

/* [3] --------- EMAIL__UALP ------------------------*/
if ( ! function_exists( 'ualp_hook_ualp_update_sms_notification' ) ) {
	/**
	 * Add log for sms notification update.
	 */
	function ualp_hook_ualp_update_sms_notification() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'ualp_update_sms_notification', $log_hook_list ) ) {
			$action      = 'SMS Trigger notification updated';
			$obj_type    = 'User Activity Log';
			$post_id     = '';
			$post_title  = 'Sms Trigger Notification Update';
			$hook        = 'ualp_update_email_notification';
			$description = "$obj_type $action : $post_title";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'ualp_update_email_notification', 'ualp_hook_ualp_update_sms_notification' ); // new.


/* [???] --------- SMS__UALP ------------------------*/
if ( ! function_exists( 'ualp_sms_api_settings' ) ) {
	/**
	 * Twilio SMS API Settings.
	 */
	function ualp_sms_api_settings() {
		if ( isset( $_POST['btntwillioAPI'] ) && isset( $_POST['_wp_sms_api_setting_nonce'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['_wp_sms_api_setting_nonce'] ) ), '_wp_sms_api_setting_action' ) ) {
			$ualp_twilio_api_sid        = isset( $_POST['ualp_twilio_api_sid'] ) ? sanitize_text_field( wp_unslash( $_POST['ualp_twilio_api_sid'] ) ) : '';
			$ualp_twilio_api_auth_token = isset( $_POST['ualp_twilio_api_auth_token'] ) ? sanitize_text_field( wp_unslash( $_POST['ualp_twilio_api_auth_token'] ) ) : '';
			$ualp_twilio_from           = isset( $_POST['ualp_twilio_from'] ) ? sanitize_text_field( wp_unslash( $_POST['ualp_twilio_from'] ) ) : '';
			$ualp_twilio_to             = isset( $_POST['ualp_twilio_to'] ) ? sanitize_text_field( wp_unslash( $_POST['ualp_twilio_to'] ) ) : '';

			if ( ! $ualp_twilio_api_sid || ! $ualp_twilio_api_auth_token ) {
				$message = esc_html__( 'Both SID and AUTH Token required to connect SMS provider.', 'user_activity_log_pro' );
				ualp_admin_notice_message( 'error', $message );
			} else {
				update_option( 'ualp_twilio_api_sid', $ualp_twilio_api_sid );
				update_option( 'ualp_twilio_api_auth_token', $ualp_twilio_api_auth_token );
				update_option( 'ualp_twilio_from', $ualp_twilio_from );
				update_option( 'ualp_twilio_to', $ualp_twilio_to );

				$message = esc_html__( 'Twilio SMS API updated successfully.', 'user_activity_log_pro' );
				ualp_admin_notice_message( 'updated', $message );
			}
		}
		$ualp_twilio_api_sid        = get_option( 'ualp_twilio_api_sid' );
		$ualp_twilio_api_auth_token = get_option( 'ualp_twilio_api_auth_token' );
		$ualp_twilio_from           = get_option( 'ualp_twilio_from' );
		$ualp_twilio_to             = get_option( 'ualp_twilio_to' );
		// Ualp_Twilio_SMS::send_message('Another test message from solwin.');.
		?>
		<form class="ualpSettingsForm" method="post">
			<div class="padding_left_right_15">
				<h3 class="ualpHeaderTitle"><?php echo esc_html__( 'Add SMS API Details (twilio)', 'user_activity_log_pro' ); ?></h3>
				<table class="widefat" cellspacing="0">
					<tbody>
						<tr>
							<th><?php echo esc_html__( 'Account SID (API SID)', 'user_activity_log_pro' ); ?></th>
							<td>
							<input type="text" name="ualp_twilio_api_sid" value="<?php echo esc_attr( $ualp_twilio_api_sid ); ?>">
							<p class="description"> </p>
							</td>
						</tr>
						<tr>
							<th><?php echo esc_html__( 'AUTH TOKEN  (API AUTH TOKEN)', 'user_activity_log_pro' ); ?></th>
							<td>
								<input type="text" name="ualp_twilio_api_auth_token" value="<?php echo esc_attr( $ualp_twilio_api_auth_token ); ?>">
								<p class="description"></p>
							</td>
						</tr>
					</tbody>
				</table>
				<h2><?php echo esc_html__( 'SMS Notification Settings', 'user_activity_log_pro' ); ?></h2>
				<table class="widefat" cellspacing="0">
					<tbody>
						<tr>
							<th><?php echo esc_html__( 'Twilio Sender ID (Number)', 'user_activity_log_pro' ); ?></th>
							<td>
							<input type="text" name="ualp_twilio_from" value="<?php echo esc_attr( $ualp_twilio_from ); ?>">
							<p class="description"> </p>
							</td>
						</tr>
						<tr>
							<th><?php echo esc_html__( 'Your Mobile Number', 'user_activity_log_pro' ); ?></th>
							<td>
								<input type="text" name="ualp_twilio_to" value="<?php echo esc_attr( $ualp_twilio_to ); ?>">
								<p class="description"></p>
							</td>
						</tr>
					</tbody>
				</table>
				<?php
				wp_nonce_field( '_wp_sms_api_setting_action', '_wp_sms_api_setting_nonce' );
				?>
				<p class="submit">
					<input class="button button-primary" type="submit" value="Save Changes" name="btntwillioAPI">
				</p>
			</div>
		</form>
		<?php
	}
}

if ( ! function_exists( 'ualp_google_sheets_settings' ) ) {
	/**
	 * Google Sheets API Settings.
	 */
	function ualp_google_sheets_settings() {
		if ( isset( $_POST['btngooglesheetsAPI'] ) && isset( $_POST['_wp_google_sheets_api_setting_nonce'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['_wp_google_sheets_api_setting_nonce'] ) ), '_wp_google_sheets_api_setting_action' ) ) {
			$ualp_add_json_credentials = isset( $_POST['ualpAddJsonCredentials'] ) ? sanitize_text_field( wp_unslash( $_POST['ualpAddJsonCredentials'] ) ) : '';
			update_option( 'ualpAddJsonCredentials', $ualp_add_json_credentials );

			$json_credentials = json_decode( $ualp_add_json_credentials );
			if ( null != $json_credentials && isset( $json_credentials->private_key ) && isset( $json_credentials->client_email ) ) {
				$message = esc_html__( 'Google Sheets API updated successfully.', 'user_activity_log_pro' );
				ualp_admin_notice_message( 'updated', $message );
				$private_key  = $json_credentials->private_key;
				$client_email = $json_credentials->client_email;
			} else {
				$message = esc_html__( 'Please enter the credentials in JSON format!', 'user_activity_log_pro' );
				ualp_admin_notice_message( 'error', $message );
			}
			if ( isset( $private_key ) && isset( $client_email ) ) {
				$token = Ualp_Google_Sheets_API::ualp_generating_token_credential( $private_key, $client_email );
				if ( isset( $token->access_token ) ) {
					update_option( 'ualp_google_token', $token );
				} else {
					$message = esc_html__( 'Please enter the credentials in JSON format!', 'user_activity_log_pro' );
					ualp_admin_notice_message( 'error', $message );
				}
			}
		}
		if ( isset( $_POST['btnresetCredentials'] ) && isset( $_POST['_wp_google_sheets_api_setting_nonce'] ) && wp_verify_nonce( sanitize_text_field( wp_unslash( $_POST['_wp_google_sheets_api_setting_nonce'] ) ), '_wp_google_sheets_api_setting_action' ) ) {
			update_option( 'ualpAddJsonCredentials', '' );
			$message = esc_html__( 'Credentials are removed successfully.', 'user_activity_log_pro' );
			ualp_admin_notice_message( 'updated', $message );
		}
		$ualp_add_json_credentials = get_option( 'ualpAddJsonCredentials' );
		$json_credentials          = json_decode( $ualp_add_json_credentials );
		?>
		<form class="ualpSettingsForm" method="post">
			<div class="padding_left_right_15">
				<h3 class="ualpHeaderTitle"><?php echo esc_html__( 'Integrate Spreadsheet (Google Sheets)', 'user_activity_log_pro' ); ?></h3>
				<table class="widefat" cellspacing="0">
					<tbody>
						<tr>
						<?php if ( isset( $json_credentials->client_email ) ) { ?>
							<th><?php esc_html_e( 'Service Account Email Address', 'user_activity_log_pro' ); ?></th>
							<td>
								<textarea id="ualpAddJsonCredentials" name="ualpAddJsonCredentials" cols="80" rows="8"  class="large-text" disabled ><?php echo 'Share your Google spreadsheet with this service account email address :  ' . esc_html( $json_credentials->client_email ); ?></textarea>
							</td>
						<?php } else { ?>
							<th><?php esc_html_e( 'Add JSON Credenials', 'user_activity_log_pro' ); ?></th>
							<td>
								<textarea id="ualpAddJsonCredentials" name="ualpAddJsonCredentials" cols="80" rows="8" class="large-text" spellcheck="false"><?php echo esc_textarea( $ualp_add_json_credentials ); ?></textarea>
								<?php esc_html_e( 'Exactly copy the downloaded file Credentials, and Paste it here ', 'user_activity_log_pro' ); ?></label>
							</td>
						<?php } ?>
						</tr>
					</tbody>
				</table>
				<?php
				wp_nonce_field( '_wp_google_sheets_api_setting_action', '_wp_google_sheets_api_setting_nonce' );
				?>
				<a class="google_link" href="https://console.developers.google.com/apis/dashboard" target="_blank"><?php echo esc_html_e( "Don't have Google Service account! Click here to create new one." ); ?></a>
				<p class="submit">
					<?php if ( isset( $json_credentials->client_email ) ) { ?>
						<input class="button button-primary" type="submit" value="Remove Credentials" name="btnresetCredentials">
					<?php } else { ?>
						<input class="button button-primary" type="submit" value="Save Changes" name="btngooglesheetsAPI">
					<?php } ?>
				</p>
				<a class="ualp_document" href="https://www.solwininfotech.com/documents/wordpress/user-activity-log-pro/#integrate_google_sheets" target="_blank"><?php echo esc_html_e( 'Are still stuck to use Google Sheets API? Click here you will find detailed documentation for it!' ); ?></a>
			</div>
		</form>
		<?php
	}
}
