<?php
/**
 * WC Checkout Fields Editor Hook.
 *
 * @package User Activity Log PRO
 */

/**
 * Exit if accessed directly
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! function_exists( 'ualp_hook_save_wcfe_settings' ) ) {
	/**
	 * Add log for update reservation settings.
	 *
	 * @param string $old_settings Old Settings.
	 * @param string $new_settings New Settings.
	 */
	function ualp_hook_save_wcfe_settings( $old_settings, $new_settings ) {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'save_wcfe_settings', $log_hook_list ) ) {
			$action      = 'updated successfully';
			$post_title  = 'WC checkout fields editor';
			$obj_type    = 'Settings';
			$post_id     = '';
			$hook        = 'save_wcfe_settings';
			$description = "$post_title : $obj_type $action";
			$uactid      = ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
			if ( 0 != $uactid ) {
				ualp_add_reservation_settings_log_detail( $uactid, $old_settings, $new_settings );
			}
		}
	}
}
add_action( 'save_wcfe_settings', 'ualp_hook_save_wcfe_settings', 20, 2 ); // new.

if ( ! function_exists( 'ualp_hook_reset_wcfe_settings' ) ) {
	/**
	 * Add log for reset reservation settings.
	 */
	function ualp_hook_reset_wcfe_settings() {
		$log_hook_list = get_option( 'enableLogHookList' );
		if ( in_array( 'wp_ajax_wcfe_get_checkout_required_fields', $log_hook_list ) ) {
			$action      = 'Default settings restored';
			$post_title  = 'WC checkout fields editor';
			$obj_type    = 'settings';
			$post_id     = '';
			$hook        = 'wp_ajax_wcfe_get_checkout_required_fields';
			$description = "$post_title : $action $obj_type";
			ualp_get_activity_log( $action, $obj_type, $post_id, $post_title, $hook, $description );
		}
	}
}
add_action( 'wp_ajax_wcfe_get_checkout_required_fields', 'ualp_hook_reset_wcfe_settings', 50 ); // new.
