<?php
/**
 * User Activity Settings Menu.
 *
 * @package User Activity Log PRO
 */

/**
 * Exit if accessed directly
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! function_exists( 'ualp_settings_panel' ) ) {
	/**
	 * General settings.
	 */
	function ualp_settings_panel() {
		?>
		<div class="wrap">
			<h1><?php esc_html_e( 'Settings', 'user_activity_log_pro' ); ?></h1>
			<?php
			if ( isset( $_SESSION['success_msg'] ) ) {
				?>
				<div class="success_msg">
				<?php
					ualp_admin_notice_message( 'updated', $_SESSION['success_msg'] );
					unset( $_SESSION['success_msg'] );
				?>
				</div>
				<?php
			}
			?>
			<div class="tab_parent_parent ualpParentTabs">
				<h2 class="nav-tab-wrapper nav-tab-wrapper">
					<a class="nav-tab nav-tab-active ualpGeneralSettings" data-href="ualpGeneralSettings" href="javascript:void(0)" >
						<?php esc_html_e( 'General Settings', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab ualpHookSettings" data-href="ualpHookSettings" href="javascript:void(0)">
						<?php esc_html_e( 'Hook Settings', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab ualpPwdSettings" data-href="ualpPwdSettings" href="javascript:void(0)">
						<?php esc_html_e( 'Password Settings', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab ualpUsersSettings" data-href="ualpUsersSettings" href="javascript:void(0)">
						<?php esc_html_e( 'Role Manager', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab ualpCustomEventSettings" data-href="ualpCustomEventSettings" href="javascript:void(0)">
						<?php esc_html_e( 'Custom Event Settings', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab ualpExcludeLog" data-href="ualpExcludeLog" href="javascript:void(0)">
						<?php esc_html_e( 'Exclude Log', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab ualpGoogleSheets" data-href="ualpGoogleSheets" href="javascript:void(0)">
						<?php esc_html_e( 'Integrate Google Sheets', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab ualpSMSAPISettings" data-href="ualpSMSAPISettings" href="javascript:void(0)">
						<?php
						esc_html_e( 'SMS Notification', 'user_activity_log_pro' );
						?>
					</a>
				</h2>
			</div>
			<div class="ualpTabContentWrap">
				<div id="ualpGeneralSettings" style="display: none" class="ualpContentDiv"><?php ualp_general_settings(); ?></div>
				<div id="ualpHookSettings" style="display: none" class="ualpContentDiv"><?php ualp_log_settings(); ?></div>
				<div id="ualpUsersSettings" style="display: none" class="ualpContentDiv"><?php ualp_role_setting(); ?></div>
				<div id="ualpPwdSettings" style="display: none" class="ualpContentDiv"><?php ualp_pwd_settings(); ?></div>
				<div id="ualpCustomEventSettings" style="display: none" class="ualpContentDiv"><?php ualp_custom_event_settings(); ?></div>
				<div id="ualpExcludeLog" style="display: none" class="ualpContentDiv"><?php ualp_exclude_log(); ?></div>
				<div id="ualpSMSAPISettings" style="display: none" class="ualpContentDiv"><?php ualp_sms_api_settings(); ?></div>
				<div id="ualpGoogleSheets" style="display: none" class="ualpContentDiv"><?php ualp_google_sheets_settings(); ?></div>
			</div>
		</div>
		<?php
	}
}
