<?php
/**
 * SMS Notification.
 *
 * @package User Activity Log PRO
 */

if ( ! function_exists( 'ualp_send_sms_notification' ) ) {
	/**
	 * Send SMS when selected user login.
	 *
	 * @param string $hook Hook.
	 * @param string $login Current username when login.
	 * @param string $activity Activity.
	 */
	function ualp_send_sms_notification( $hook, $login, $activity ) {
		global $wpdb;
		$get_ip_type = get_option( 'ualpIPtypes', 'REMOTE_ADDR' );
		if ( $get_ip_type ) {
			if ( 'REMOTE_ADDR' == $get_ip_type ) {
				$ips = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ) : '';
			} elseif ( 'HTTP_X_FORWARDED_FOR' == $get_ip_type ) {
				$ips = isset( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ) : '';
			} elseif ( 'HTTP_X_REAL_IP' == $get_ip_type ) {
				$ips = isset( $_SERVER['HTTP_X_REAL_IP'] ) ? sanitize_text_field( wp_unslash( $_SERVER['HTTP_X_REAL_IP'] ) ) : '';
			} else {
				$ips = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ) : '';
			}
		} else {
			$ips = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ) : '';
		}
		if ( ualp_allow_ip() ) {
			$ip = $ips;
		}
		$currenr_role              = array();
		$exclude_current_user_name = '';
		if ( '' != $login ) {
			$exclude_current_user      = get_user_by( 'login', $login );
			$exclude_current_user_name = $login;
			if ( ! empty( $exclude_current_user->roles ) && is_array( $exclude_current_user->roles ) ) {
				foreach ( $exclude_current_user->roles as $role ) {
						$currenr_role[] = $role;
				}
			}
		}

		$excludelogdata = get_option( 'exclude_log_data' );
		$i              = 0;
		$flag           = 0;
		if ( is_array( $excludelogdata ) && ! empty( $excludelogdata ) ) {
			$users1 = get_users();
			foreach ( $users1 as $user_id ) {
				$all_user_id[] = $user_id->user_login;
			}
			foreach ( $excludelogdata as $exclude_log_data_single ) {
				$row_count         = count( $exclude_log_data_single );
				$exclude_logs_hook = $exclude_log_data_single['exclude_logs_hook'];
				$exclude_log_users = $exclude_log_data_single['exclude_log_users'];
				$exclude_logs_ips  = $exclude_log_data_single['exclude_logs_ips'];
				if ( empty( $exclude_logs_ips ) ) {
					$exclude_logs_ips = array();}
				if ( '' != $exclude_log_users ) {
					if ( in_array( $exclude_log_users, $all_user_id ) ) {
						$exclude_log_user     = get_user_by( 'login', $exclude_log_users );
						$exclude_user         = $exclude_log_user->user_login;
						$exclude_current_user = $exclude_current_user_name;
					} elseif ( '0' == $exclude_log_users ) {
						$exclude_user = 'guest';
						if ( '' != $login ) {
							$exclude_current_user = $exclude_current_user_name;
						} else {
							$exclude_current_user = 'guest';
						}
					} else {
						$exclude_current_user = isset( $currenr_role[0] ) ? $currenr_role[0] : '';
						$exclude_user         = $exclude_log_users;
					}
				}
				if ( 'all' != $exclude_log_users && 'all' != $exclude_logs_hook ) {
					if ( 1 == $row_count && 0 == $i ) {
						if ( ! empty( $exclude_logs_ips ) && $hook == $exclude_logs_hook && $exclude_current_user == $exclude_user && in_array( $ip, $exclude_logs_ips ) ) {
							$flag = 1;
						} elseif ( empty( $exclude_logs_ips ) && $hook == $exclude_logs_hook && $exclude_current_user == $exclude_user ) {
							$flag = 1;
						}
					} elseif ( $row_count > 1 && 1 != $flag ) {
						if ( ! empty( $exclude_logs_ips ) && $hook == $exclude_logs_hook && $exclude_current_user == $exclude_user && in_array( $ip, $exclude_logs_ips ) ) {
							$flag = 1;
						} elseif ( empty( $exclude_logs_ips ) && $hook == $exclude_logs_hook && $exclude_current_user == $exclude_user ) {
							$flag = 1;
						}
					}
				} elseif ( 'all' == $exclude_log_users && 'all' != $exclude_logs_hook ) {
					if ( 1 == $row_count && 0 == $i ) {
						if ( ! empty( $exclude_logs_ips ) && $hook == $exclude_logs_hook && in_array( $ip, $exclude_logs_ips ) ) {
							$flag = 1;
						} elseif ( empty( $exclude_logs_ips ) && $hook == $exclude_logs_hook ) {
							$flag = 1;
						}
					} elseif ( $row_count > 1 && 1 != $flag ) {
						if ( ! empty( $exclude_logs_ips ) && $hook == $exclude_logs_hook && in_array( $ip, $exclude_logs_ips ) ) {
							$flag = 1;
						} elseif ( empty( $exclude_logs_ips ) && $hook == $exclude_logs_hook ) {
							$flag = 1;
						}
					}
				} elseif ( 'all' != $exclude_log_users && 'all' == $exclude_logs_hook ) {
					if ( 1 == $row_count && 0 == $i ) {
						if ( ! empty( $exclude_logs_ips ) && $exclude_current_user == $exclude_user && in_array( $ip, $exclude_logs_ips ) ) {
							$flag = 1;
						} elseif ( empty( $exclude_logs_ips ) && $exclude_current_user == $exclude_user ) {
							$flag = 1;
						}
					} elseif ( $row_count > 1 && 1 != $flag ) {
						if ( ! empty( $exclude_logs_ips ) && $exclude_current_user == $exclude_user && in_array( $ip, $exclude_logs_ips ) ) {
							$flag = 1;
						} elseif ( empty( $exclude_logs_ips ) && $exclude_current_user == $exclude_user ) {
							$flag = 1;
						}
					}
				} elseif ( 'all' == $exclude_log_users && 'all' == $exclude_logs_hook ) {
					if ( ! empty( $exclude_logs_ips ) && 1 != $flag && in_array( $ip, $exclude_logs_ips ) ) {
						$flag = 1;
					} elseif ( empty( $exclude_logs_ips ) ) {
						$flag = 1;
					}
				}
				$i++;
			}
		}
		if ( '0' == $flag ) {
			$user_role = '';
			if ( '' != $login ) {
				$current_user1 = get_user_by( 'login', $login );
				$current_user  = ! empty( $current_user1->user_login ) ? $current_user1->user_login : 'Guest';
				if ( ! empty( $current_user1->roles ) && is_array( $current_user1->roles ) ) {
					$current_user_roles_count = count( $current_user1->roles );
					if ( 1 == $current_user_roles_count ) {
						$user_role = $current_user1->roles[0];
					} else {
						$user_role = $current_user1->roles;
						foreach ( $user_role as $all_rols ) {
							$user_role .= $all_rols . ' ,';
						}
					}
				}
				$firstname    = ucfirst( $current_user1->user_firstname );
				$lastname     = ucfirst( $current_user1->user_lastname );
				$user_firstnm = ! empty( $firstname ) ? ucfirst( $firstname ) : '-';
				$user_lastnm  = ! empty( $lastname ) ? $lastname : '-';
				$user_mobile  = get_option( 'ualp_twilio_to' );
				ualp_sms_body( $current_user, $user_firstnm, $user_lastnm, $user_mobile, $activity );
				$ualp_user_mobile_notify       = get_option( 'ualpMobileNotification' );
				$ualp_fail_login_not_user_name = array();
				if ( is_array( $ualp_user_mobile_notify ) && in_array( 'ualpFailLoginNotUserMobile', $ualp_user_mobile_notify ) ) {
					if ( isset( $_REQUEST['log'] ) && '' != $_REQUEST['log'] ) {
						$current_user  = sanitize_text_field( wp_unslash( $_REQUEST['log'] ) );
						$get_all_users = get_users();
						foreach ( $get_all_users as $get_all_user ) {
							$ualp_fail_login_not_user_name[] = $get_all_user->user_login;
						}
						if ( is_array( $ualp_fail_login_not_user_name ) && ! in_array( $current_user, $ualp_fail_login_not_user_name ) ) {
							ualp_sms_body( $login, '', '', '', $activity );
						}
					}
				}
			} else {
				ualp_sms_body( 'Guest', '', '', '', $activity );
			}
		}
	}
}

if ( ! function_exists( 'ualp_sms_body' ) ) {
	/**
	 * Sent SMS content.
	 *
	 * @param string $current_user Current User.
	 * @param string $user_firstnm First name of user.
	 * @param string $user_lastnm Last name of user.
	 * @param string $user_mobile Mobile no. of User.
	 * @param string $activity Activity.
	 */
	function ualp_sms_body( $current_user, $user_firstnm, $user_lastnm, $user_mobile, $activity ) {
		if ( ualp_allow_ip() ) {
			$get_ip_type = get_option( 'ualpIPtypes', 'REMOTE_ADDR' );
			if ( $get_ip_type ) {
				if ( 'REMOTE_ADDR' == $get_ip_type ) {
					$ip = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ) : '';
				} elseif ( 'HTTP_X_FORWARDED_FOR' == $get_ip_type ) {
					$ip = isset( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ) : '';
				} elseif ( 'HTTP_X_REAL_IP' == $get_ip_type ) {
					$ip = isset( $_SERVER['HTTP_X_REAL_IP'] ) ? sanitize_text_field( wp_unslash( $_SERVER['HTTP_X_REAL_IP'] ) ) : '';
				} else {
					$ip = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ) : '';
				}
			} else {
				$ip = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ) : '';
			}
		} else {
			$ip = '';
		}
		$modified_date = current_time( 'mysql' );
		$modified_date = strtotime( $modified_date );
		$date_format   = get_option( 'date_format' );
		$time_format   = get_option( 'time_format' );
		$date          = gmdate( $date_format, $modified_date );
		$time          = gmdate( $time_format, $modified_date );
		$user_reg      = $date . ' ' . $time;
		$user_details  = '';
		$user_details .= '( ' . $current_user . ' )';
		$user_details .= '( ' . $user_reg . ' )';
		if ( ualp_allow_ip() ) {
			$user_details .= '( ' . $ip . ' )';
		}
		$user_details .= '( ' . wp_strip_all_tags( $activity ) . ' )';
		$to_mobile     = $user_mobile;
		$mail_msg      = get_option( 'ualpMobileMessage' );
		if ( empty( $mail_msg ) ) {
			$user_details_shortcode = '[user_details]';
			$mail_msg               = esc_html__( 'Hi', 'user_activity_log_pro' ) . ' ';
			$mail_msg              .= isset( $current_user->display_name ) ? $current_user->display_name . ',' : '';
			$mail_msg              .= "\n\n" . __( 'Following user has done some activity in your site', 'user_activity_log_pro' ) . " \n$user_details_shortcode";
			$mail_msg              .= "\n\n" . __( 'Thanks,', 'user_activity_log_pro' ) . " \n";
			$mail_msg              .= home_url();
		}
		$ualp_to_faild_login_mobile         = get_option( 'ualpToFaildLoginMobile' );
		$ualp_to_fail_login_not_user_mobile = get_option( 'ualpFailLoginNotUserMobile' );
		$ualp404_login_mobile               = get_option( 'ualp404LoginMobile' );

		$ualp_fail_login_not_user_number = get_option( 'ualpFailLoginNotUserNumberAtt' );
		$ualp404_page_access_number      = get_option( 'ualp404PageAccessNumberAtt' );
		$ualp_fail_login_number          = get_option( 'ualpFailLoginNumberAtt' );

		if ( empty( $ualp404_login_mobile ) ) {
			$ualp404_login_mobile = $to_mobile;
		} else {
			$to_mobile = $ualp404_login_mobile;
		}
		if ( empty( $ualp_to_faild_login_mobile ) ) {
			$ualp_to_faild_login_mobile = $to_mobile;
		} else {
			$to_mobile = $ualp_to_faild_login_mobile;
		}
		if ( empty( $ualp_to_fail_login_not_user_mobile ) ) {
			$ualp_to_fail_login_not_user_mobile = $to_mobile;
		} else {
			$to_mobile = $ualp_to_fail_login_not_user_mobile;
		}

		global  $wpdb;
		$get_all_users                 = get_users();
		$ualp_fail_login_not_user_name = array();
		$post_title                    = '404 Page';
		if ( is_multisite() ) {
			$count404page = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(`uactid`) FROM {$wpdb->base_prefix}ualp_user_activity where hook='wp_head' AND object_type=%s", $post_title ) );
		} else {
			$count404page = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(`uactid`) FROM {$wpdb->prefix}ualp_user_activity where hook='wp_head' AND object_type=%s", $post_title ) );
		}
		if ( $count404page >= $ualp404_page_access_number ) {
			$to_mobile = $ualp404_login_mobile;
		}

		if ( isset( $_REQUEST['log'] ) && '' != $_REQUEST['log'] ) {
			$request_log = sanitize_text_field( wp_unslash( $_REQUEST['log'] ) );
			foreach ( $get_all_users as $get_all_user ) {
				$ualp_fail_login_not_user_name[] = $get_all_user->user_login;
			}
			if ( is_array( $ualp_fail_login_not_user_name ) && ! in_array( $request_log, $ualp_fail_login_not_user_name ) ) {
				if ( is_multisite() ) {
					$countwploginfailed = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(`uactid`) FROM {$wpdb->base_prefix}ualp_user_activity where hook='wp_login_failed' AND post_title=%s", $request_log ) );
				} else {
					$countwploginfailed = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(`uactid`) FROM {$wpdb->prefix}ualp_user_activity where hook='wp_login_failed' AND post_title=%s", $request_log ) );
				}
				if ( $countwploginfailed >= $ualp_fail_login_not_user_number ) {
					$to_mobile = $ualp_to_fail_login_not_user_mobile;
				}
			}
			if ( is_array( $ualp_fail_login_not_user_name ) && in_array( $request_log, $ualp_fail_login_not_user_name ) ) {
				$post_title = $current_user;
				if ( is_multisite() ) {
					$countwploginfailed = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(`uactid`) FROM {$wpdb->base_prefix}ualp_user_activity where hook='wp_login_failed' AND user_name=%s", $post_title ) );
				} else {
					$countwploginfailed = $wpdb->get_var( $wpdb->prepare( "SELECT COUNT(`uactid`) FROM {$wpdb->prefix}ualp_user_activity where hook='wp_login_failed' AND user_name=%s", $post_title ) );
				}
				if ( $countwploginfailed >= $ualp_fail_login_number ) {
					$to_mobile = $ualp_to_faild_login_mobile;
				}
			}
		}
		$mail_msg = str_replace( '[user_details]', $user_details, $mail_msg );
		if ( isset( $to_mobile ) && '' != $to_mobile && '' != $mail_msg ) {
			$to_mobile_array       = explode( ',', $to_mobile );
			$to_mobile_array_count = count( $to_mobile_array );
			for ( $i = 0; $i < $to_mobile_array_count;$i++ ) {
				$to_sms = trim( $to_mobile_array[ $i ], ' ' );
				Ualp_Twilio_SMS::send_message_bulk( $to_sms, $mail_msg );
			}
		}
	}
}
