<?php
/**
 * User SMS Notification Tab.
 *
 * @package User Activity Log PRO
 */

if ( ! function_exists( 'ualp_add_sms_settings' ) ) {
    /**
     * User activity SMS Settings
     */
	function ualp_add_sms_settings() {
		$all_sms_notification = $email_title = $email_address = '';
		$email_template       = 0;
		$custom_trigger_data  = array();
		if ( isset( $_GET['snotification'] ) ) {
			global $wpdb, $externaldb;
			$snotification              = $_GET['snotification'];
			$sms_query                  = 'SELECT * FROM ' . UALP_SMS_TABLENAME . ' where site_id = ' . get_current_blog_id() . ' AND uacteid =' . $snotification;
			$email_notification_content = $externaldb->get_results( $sms_query );
			foreach ( $email_notification_content as $all_trigger_notification ) {
				$all_sms_notification = $all_trigger_notification->sms_content;
				$email_title          = $all_trigger_notification->sms_title;
				$email_address        = $all_trigger_notification->sms_address;
				$email_template       = $all_trigger_notification->sms_template;
				$custom_trigger_data  = unserialize( $all_trigger_notification->custom_trigger_data );
			}
		}
		if ( isset( $_POST['saveTrigger'] ) && isset( $_POST['_wp_trigger_notify_nonce'] ) && wp_verify_nonce( $_POST['_wp_trigger_notify_nonce'], '_wp_trigger_notify_action' ) ) {
			$custom_trigger_operator_with = '';
			$custom_trigger_data          = array();
			$i                            = $emptyCount = $j = 0;
			if ( ( isset( $_POST['custom_trigger_operator_with'] ) && $_POST['custom_trigger_operator_with'] != '' ) || ( isset( $_POST['custom_trigger_name'] ) && $_POST['custom_trigger_name'] != '' ) || ( isset( $_POST['custom_trigger_with'] ) && $_POST['custom_trigger_with'] != '' ) ) {
				$custom_trigger_operator_with = $_POST['custom_trigger_operator_with'];
				$custom_trigger_name          = $_POST['custom_trigger_name'];
				$custom_trigger_with          = $_POST['custom_trigger_with'];
				foreach ( $custom_trigger_name as $custom_trigger_name_single ) {
					$j++;
					$custom_trigger_value[] = isset( $_POST[ 'custom_trigger_value_' . $j ] ) ? $_POST[ 'custom_trigger_value_' . $j ] : '';
				}
			}
			if ( is_array( $custom_trigger_operator_with ) && ! empty( $custom_trigger_operator_with ) ) {
				if ( sizeof( $custom_trigger_operator_with ) > 0 ) {
					foreach ( $custom_trigger_operator_with as $custom_trigger_operator_with_single ) {
						if ( $custom_trigger_operator_with_single != '' ) {
							$custom_trigger_data[] = array(
								'custom_trigger_operator_with' => $custom_trigger_operator_with_single,
								'custom_trigger_name'  => $custom_trigger_name[ $i ],
								'custom_trigger_with'  => $custom_trigger_with[ $i ],
								'custom_trigger_value' => $custom_trigger_value[ $i ],
							);
							$i++;
						}
					}
				}
				if ( is_array( $custom_trigger_data ) && ! empty( $custom_trigger_data ) ) {
					if ( sizeof( $custom_trigger_data ) >= 1 ) {
						foreach ( $custom_trigger_data as $custom_trigger_single_data ) {
							$triggeropratorwith = $custom_trigger_single_data['custom_trigger_operator_with'];
							$triggerName        = $custom_trigger_single_data['custom_trigger_name'];
							$triggerWith        = $custom_trigger_single_data['custom_trigger_with'];
							$triggerValue       = $custom_trigger_single_data['custom_trigger_value'];
							if ( $triggerName == '' || $triggerWith == '' || $triggeropratorwith == '' || $triggerValue == '' ) {
								$emptyCount++;
							}
						}
					}
				}
			}
			if ( $emptyCount == '0' && $custom_trigger_data != '' ) {
				$class   = 'updated';
				$message = esc_html__( 'Trigger Notification  is save successfully.', 'user_activity_log_pro' );
				do_action( 'ualp_custom_trigger_log_updated' );
			} elseif ( $emptyCount == '0' && sizeof( $custom_trigger_operator_with ) > 0 ) {
				$class   = 'updated';
				$message = esc_html__( 'Trigger Notification deleted successfully.', 'user_activity_log_pro' );
				do_action( 'ualp_custom_trigger_log_updated' );
			} else {
				$class   = 'error';
				$message = esc_html__( 'Trigger Notification is not save. Fill the empty field.', 'user_activity_log_pro' );
			}
			ualp_admin_notice_message( $class, $message );
			$all_sms_notification = ( isset( $_POST['txtualpAddEmailMsg'] ) && $_POST['txtualpAddEmailMsg'] != '' ) ? $_POST['txtualpAddEmailMsg'] : '';
			$trigger_title        = ( isset( $_POST['trigger_title'] ) && $_POST['trigger_title'] != '' ) ? $_POST['trigger_title'] : '';
			$trigger_emailid      = ( isset( $_POST['trigger_emailid'] ) && $_POST['trigger_emailid'] != '' ) ? $_POST['trigger_emailid'] : '';
			$email_template       = ( isset( $_POST['email_template'] ) && $_POST['email_template'] != '' ) ? $_POST['email_template'] : 0;

			$current_user_id   = get_current_user_id();
			$current_user      = wp_get_current_user();
			$current_user_name = $current_user->user_login;

			if ( isset( $_GET['snotification'] ) ) {
				$snotification = $_GET['snotification'];
				ualpSmsUpdateNotification( $snotification, $all_sms_notification, $custom_trigger_data, $trigger_title, $trigger_emailid, $email_template );
			} else {
				ualp_insert_sms_notification( $current_user_name, $all_sms_notification, $custom_trigger_data, $trigger_title, $trigger_emailid, $email_template );
			}
		}
		if ( is_network_admin() && ualp_multi_site_support_return() ) {
			$adminurl = network_admin_url( 'admin.php' );
		} else {
			$adminurl = admin_url( 'admin.php' );
		}
		if ( ! isset( $_GET['snotification'] ) ) {
			$current_user = wp_get_current_user();
			$user_details = '[user_details]';
			// $all_sms_notification = esc_html__('Hi', 'user_activity_log_pro').' ';
			$all_sms_notification = '';
			// $all_sms_notification .= $current_user->user_login.',';
			$all_sms_notification .= "\n\n" . __( 'Following user has done some activity in your site', 'user_activity_log_pro' ) . " \n$user_details";
			// $all_sms_notification .= "\n\n".__("Thanks,", 'user_activity_log_pro')." \n";
			// $all_sms_notification .= home_url();
		}
		$all_users = get_users();
		?>
		<div class="add_new_email_notification_wrapper">
			<form class="ualpAddEmailNotication" action="<?php echo $adminurl . '?' . $_SERVER['QUERY_STRING']; ?>" method="POST">
				<div class="title"><h1><?php echo __( 'Add New SMS Notification', 'user_activity_log_pro' ); ?></h1></div>
				<div class="add_multiple_email_notification">
					<input type="text" name="trigger_title" class="trigger_title" value="<?php echo $email_title; ?>" placeholder="Enter title here" required />
					<div class="display_note"><span><?php echo __( 'Trigger notification should be matched for a sms notification to be sent in this section. sms notifications rules by using the AND and OR operands', 'user_activity_log_pro' ); ?></span></div>
					<div class="add_custom_trigger_table">
						<div class="add-new-trigger-main-wrapp">
							<div class="add-new-trigger-title">
							<h3><?php echo __( 'Trigger', 'user_activity_log_pro' ); ?></h3>
							</div>
							<div class="add-new-trigger-wrapper">
								<div title="<?php esc_html_e( 'Add New Trigger', 'user_activity_log_pro' ); ?>" class="ualp_add_new_trigger_btn dashicons dashicons-plus-alt"></div>
							</div>
						</div>
						<table class="widefat custom_trigger_table" cellspacing="0">
							<?php
							$j                  = 1;
							$i                  = 0;
							$style              = '';
							$trigger_data_count = count( $custom_trigger_data );
							if ( is_array( $custom_trigger_data ) && ! empty( $custom_trigger_data ) && isset( $_GET['snotification'] ) ) {
								foreach ( $custom_trigger_data as $custom_trigger_data_single ) {
									$i++;
									?>
									<tr class="ualp_custom_trigger_tr">
										<td style="
										<?php
										if ( $j == 1 ) {
											?>
											display : none;<?php } ?>">
											<span class="trigger-lable"><?php esc_html_e( 'Trigger operator with', 'user_activity_log_pro' ); ?></span><br/>
											<select name="custom_trigger_operator_with[]" class="chosen-filter">
												<option value="AND" <?php selected( $custom_trigger_data_single['custom_trigger_operator_with'], 'AND' ); ?>>AND</option>
												<option value="OR" <?php selected( $custom_trigger_data_single['custom_trigger_operator_with'], 'OR' ); ?>  >OR</option>
											</select>
										</td>
										<td>
											<span class="trigger-lable">
											<?php
											esc_html_e( 'Trigger Name', 'user_activity_log_pro' );
											echo ' : ';
											?>
											</span><br/>
											<select name="custom_trigger_name[]" class="chosen-filter custom_trigger_name">
												<option value="user_id" <?php selected( $custom_trigger_data_single['custom_trigger_name'], 'user_id' ); ?>>User ID</option>
												<option value="user_name" <?php selected( $custom_trigger_data_single['custom_trigger_name'], 'user_name' ); ?>  >User Name</option>
												<?php if ( ualp_allow_ip() ) { ?>
													<option value="ip_address" <?php selected( $custom_trigger_data_single['custom_trigger_name'], 'ip_address' ); ?>  >Ip Address</option>
												 <?php } ?>
												<option value="user_role" <?php selected( $custom_trigger_data_single['custom_trigger_name'], 'user_role' ); ?>  >User Role</option>
												<option value="hook" <?php selected( $custom_trigger_data_single['custom_trigger_name'], 'hook' ); ?>>Activity</option>
											</select>
										</td>
										<td>
											<span class="trigger-lable">
											<?php
											esc_html_e( 'Trigger with', 'user_activity_log_pro' );
											echo ' : ';
											?>
											</span><br/>
											<select name="custom_trigger_with[]" class="chosen-filter">
												<option value="equal" <?php selected( $custom_trigger_data_single['custom_trigger_with'], 'equal' ); ?>>Is Equal</option>
												<option value="not_equal" <?php selected( $custom_trigger_data_single['custom_trigger_with'], 'not_equal' ); ?>  >Not Equal</option>
											</select>
										</td>
										<td class="custom_trigger_value_tr">
											<span class="trigger-lable">
											<?php
											esc_html_e( 'Trigger Value', 'user_activity_log_pro' );
											echo ' : ';
											?>
											</span><br/>
											<div class="ualp_custom_trigger_value">
												<?php
												if ( $custom_trigger_data_single['custom_trigger_name'] == 'user_id' ) {
													?>
													<select name="custom_trigger_value_<?php echo $i; ?>[]" class="chosen-filter" multiple>
														<?php
														if ( isset( $all_users ) && ! empty( $all_users ) ) {
															foreach ( $all_users as $get_all_users ) {
																$userid   = $get_all_users->ID;
																$selected = in_array( $userid, $custom_trigger_data_single['custom_trigger_value'] ) ? 'selected="selected"' : '';
																echo '<option value="' . $userid . '" ' . $selected . '>' . $userid . '</option>';
															}
														}
														?>
													</select>
													<?php
												}
												if ( $custom_trigger_data_single['custom_trigger_name'] == 'user_name' ) {
													?>
													<select name="custom_trigger_value_<?php echo $i; ?>[]" class="chosen-filter" multiple>
														<?php
														if ( isset( $all_users ) && ! empty( $all_users ) ) {
															foreach ( $all_users as $get_all_users ) {
																$user_name = $get_all_users->user_login;
																$selected  = in_array( $user_name, $custom_trigger_data_single['custom_trigger_value'] ) ? 'selected="selected"' : '';
																echo '<option value="' . $user_name . '" ' . $selected . '>' . $user_name . '</option>';
															}
														}
														?>
													</select>
													<?php
												}
												if ( $custom_trigger_data_single['custom_trigger_name'] == 'user_role' ) {
													?>
													<select name="custom_trigger_value_<?php echo $i; ?>[]" class="chosen-filter" multiple>
															<?php
															$editable_roles = get_editable_roles();
															foreach ( $editable_roles as $role => $details ) {
																$name       = translate_user_role( $details['name'] );
																$role_label = esc_attr( $role );
																$selected   = in_array( $role_label, $custom_trigger_data_single['custom_trigger_value'] ) ? 'selected="selected"' : '';
																echo '<option value="' . $role_label . '" ' . $selected . '>' . $role_label . '</option>';
															}
															?>
														</select>
													<?php
												}
												if ( $custom_trigger_data_single['custom_trigger_name'] == 'hook' ) {
													global $allhookdetails;
														$post_types = ualp_posttypes();
														$taxonomies = ualp_taxonomies();
														$all_hook   = array(
															'activated_plugin',
															'deactivated_plugin',
															'delete_plugin',
															'plugin_modify',
															'plugin_installed',
															'plugin_updated',
															'ualp_export_activity_log',
															'ualp_general_settings_updated',
															'ualp_hook_log_settings_updated',
															'ualp_manage_role',
															'ualp_set_password',
															'ualp_change_password',
															'ualp_sms_settings_updated',
															'ualp_custom_event_log_updated',
															'ualp_exclude_log_updated',
															'ualp_insert_sms_notification',
															'ualp_update_email_notification',
															'wp_login',
															'wp_login_failed',
															'wp_logout',
															'delete_user',
															'user_register',
															'insert_user_meta',
															'password_reset',
															'theme_file_modify',
															'switch_theme',
															'customize_save',
															'theme_updated',
															'theme_installed',
															'delete_site_transient_update_themes',
															'wp_insert_comment',
															'edit_comment',
															'delete_comment',
															'trash_comment',
															'spam_comment',
															'restore_comment',
															'comment_approve',
															'comment_unapprove',
															'wp_create_nav_menu',
															'delete_nav_menu',
															'admin_head',
															'wp_head',
															'404_page',
															'_core_updated_successfully',
															'import_end',
															'export_wp',
															'widget_update_callback',
															'updated_option',
															'dbdelta_queries',
															'wp_privacy_personal_data_exporters',
															'wp_privacy_personal_data_erasers',
															'wp_update_nav_menu',
															'pre_insert_term',
															'wp_update_term_parent',
															'delete_themes',
															'before_delete_post',
															'ualpSettingsUpdated',
															'pre_delete_term',
															'sidebar_admin_setup',
															'updated_post_meta',
														);
														foreach ( $post_types as $post_type ) {
															if ( $post_type->name != 'wpcf7_contact_form' && $post_type->name != 'custom_css' && $post_type->name != 'customize_changeset' && $post_type->name != 'attachment' && $post_type->name != 'oembed_cache' && $post_type->name != 'wp_block' ) {
																array_push( $all_hook, $post_type->name . '_create', $post_type->name . '_update', $post_type->name . '_delete' );
															}
															if ( $post_type->name == 'attachment' ) {
																array_push( $all_hook, 'add_' . $post_type->name, 'edit_' . $post_type->name, 'delete_' . $post_type->name );
															}
														}
														foreach ( $taxonomies as $taxonomy ) {
															if ( $taxonomy->name != 'wpcf7_contact_form' && $taxonomy->name != 'custom_css' && $taxonomy->name != 'customize_changeset' && $taxonomy->name != 'product_visibility' ) {
																array_push( $all_hook, $taxonomy->name . '_create', $taxonomy->name . '_update', $taxonomy->name . '_delete' );
															}
														}

														if ( class_exists( 'Woocommerce' ) ) {
															array_push( $all_hook, 'woocommerce_updated_option', 'woocommerce_new_product_variation', 'wp_ajax_woocommerce_remove_variations', 'woocommerce_save_product_variation' );
														}
														if ( is_plugin_active( 'buddypress/bp-loader.php' ) ) {
															array_push( $all_hook, 'groups_create_group', 'groups_update_group', 'groups_before_delete_group', 'groups_leave_group', 'groups_join_group', 'groups_promote_member', 'groups_demote_member', 'groups_ban_member', 'groups_unban_member', 'groups_remove_member', 'xprofile_field_after_save', 'xprofile_fields_deleted_field', 'xprofile_group_after_save', 'xprofile_groups_deleted_group' );
														}
														if ( is_plugin_active( 'easy-digital-downloads/easy-digital-downloads.php' ) ) {
															array_push( $all_hook, 'edd_activate_discount', 'edd_deactivate_discount', 'edd_add_discount', 'edd_delete_discount', 'transition_post_status' );
														}
														if ( is_plugin_active( 'gravityforms/gravityforms.php' ) ) {
															array_push( $all_hook, 'gf_export_forms', 'notification_duplicated', 'gform_entry_created', 'gf_resend_notifications', 'gform_pre_note_deleted', 'gform_post_export_entries', 'gform_post_note_added', 'gform_delete_entries', 'gform_post_form_views_deleted', 'gform_post_form_activated', 'gform_post_form_deactivated', 'gform_before_delete_form', 'gform_post_form_trashed', 'gform_post_form_restored', 'gform_post_form_duplicated', 'gform_after_save_form', 'gform_forms_post_import', 'gform_pre_notification_deleted', 'gform_pre_confirmation_deleted', 'wp_ajax_rg_update_notification_active', 'wp_ajax_rg_update_confirmation_active', 'gform_pre_confirmation_save', 'gform_pre_notification_save', 'gform_delete_lead', 'gform_update_status', 'gform_update_is_read', 'gform_update_is_starred' );
														}
														if ( is_plugin_active( 'wordfence/wordfence.php' ) ) {
															array_push( $all_hook, 'wordfence_updateIssueStatus', 'wordfence_saveWAFConfig', 'wordfence_wafConfigureAutoPrepend', 'wordfence_whitelistBulkEnable', 'wordfence_whitelistBulkDisable', 'wordfence_whitelistBulkDelete', 'wordfence_updateConfig', 'wordfence_loadLiveTraffic', 'wordfence_loadCacheExclusions', 'wordfence_saveCacheConfig', 'wordfence_cache_clear', 'wordfence_reverseLookup', 'wordfence_whois', 'wordfence_clearPageCache', 'wordfence_saveConfig', 'wordfence_blockIP', 'wordfence_addTwoFactor', 'wordfence_exportSettings', 'wordfence_clearAllBlocked', 'wordfence_blockIPUARange', 'wordfence_unblockRange', 'wordfence_saveCountryBlocking', 'wordfence_saveDebuggingConfig', 'wordfence_startPasswdAudit', 'wordfence_saveScanSchedule', 'wordfence_updateWAFRules', 'wordfence_sendTestEmail', 'wordfence_sendDiagnostic', 'wordfence_updateAllIssues', 'wordfence_sendActivityLog', 'wordfence_addCacheExclusion', 'wordfence_daily_autoUpdate', 'wordfence_update_blocked_IPs', 'wordfence_start_scheduled_scan', 'wordfence_doScan', 'wordfence_daily_cron', 'wordfence_hourly_cron', 'wordfence_email_activity_report', 'wordfence_scan', 'wordfence_updateAlertEmail', 'wordfence_restoreFile', 'wordfence_deletePasswdAudit', 'wordfence_weakPasswordsFix', 'wordfence_killPasswdAudit', 'wordfence_importSettings', 'wordfence_bulkOperation', 'wordfence_deleteFile', 'wordfence_deleteDatabaseOption', 'wordfence_removeExclusion', 'wordfence_deleteIssue', 'wordfence_unlockOutIP', 'wordfence_unblockIP', 'wordfence_permBlockIP', 'wordfence_downloadHtaccess', 'wordfence_checkFalconHtaccess', 'wordfence_removeFromCache', 'wordfence_autoUpdateChoice', 'wordfence_saveCacheOptions', 'wordfence_adminEmailChoice', 'wordfence_getCacheStats', 'wordfence_killScan', 'wordfence_tourClosed', 'wordfence_removeCacheExclusion', 'wordfence_unblockNetwork', 'wordfence_permanentlyBlockAllIPs', 'wordfence_deleteAdminUser', 'wordfence_revokeAdminUser', 'wordfence_hideFileHtaccess', 'wordfence_loadBlockRanges' );
														}
														if ( is_plugin_active( 'wordpress-seo/wp-seo.php' ) ) {
															array_push( $all_hook, 'wpseo_handle_import', 'wpseo_import', 'wpseo_save_auth_code', 'seo_check_admin_referer', 'updated_post_meta' );
														}
														if ( is_plugin_active( 'contact-form-7/wp-contact-form-7.php' ) ) {
															array_push( $all_hook, 'wpcf7_after_create' );
															array_push( $all_hook, 'wpcf7_after_update' );
															array_push( $all_hook, 'wpcf7_admin_notices' );
															array_push( $all_hook, 'wpcf7-recaptcha-setup' );
														}
														if ( is_plugin_active( 'blog-designer-pro/blog-designer-pro.php' ) ) {
															array_push( $all_hook, 'bdp_update_shortcode', 'bdp_reset_shortcode', 'bdp_reset_archive_page', 'bdp_add_shortcode', 'bdp_update_single_file', 'bdp_add_archive_layout', 'bdp_delete_shortcode', 'bdp_delete_single_template', 'bdp_copy_single_template', 'bdp_duplicate_layout_settings', 'bdp_import_blog_layout_settings', 'bdp_import_archive_layout_settings', 'bdp_export_blog_layout_settings', 'bdp_export_archive_layout_settings', 'bdp_update_archive_page', 'bdp_import_single_layout_settings', 'bdp_export_single_layout_settings', 'bdp_delete_archive', 'bdp_delete_single_layout', 'bdp_update_single_page', 'bdp_reset_single_page', 'bdp_add_single_layout', 'bdp_duplicate_single_layout_settings' );
														}
														if ( is_plugin_active( 'portfolio-designer/portfolio-designer.php' ) ) {
															array_push( $all_hook, 'import_sample_portfolio_data', 'create_portfolio_layout', 'duplicate_portfolio_layout', 'delete_portfolio_layout', 'update_portfolio_layout', 'reset_portfolio_layout', 'create_post_type', 'update_post_type', 'export_portfolio_layout', 'delete_post_type' );
														}
														if ( is_plugin_active( 'all-in-one-reservation/all-in-one-reservation.php' ) ) {
															array_push( $all_hook, 'save_reservation_settings', 'rest_update_reservation_status', 'reset_reservation_settings' );
														}
														if ( is_plugin_active( 'wc-checkout-fields-editor/wc-checkout-fields-editor.php' ) ) {
															array_push( $all_hook, 'save_wcfe_settings', 'wp_ajax_wcfe_get_checkout_required_fields' );
														}
														if ( is_plugin_active( 'easy-digital-downloads/easy-digital-downloads.php' ) ) {
															array_push( $all_hook, 'edd_activate_discount', 'edd_settings', 'edd_deactivate_discount', 'edd_add_discount', 'edd_delete_discount' );
														}
														if ( is_plugin_active( 'bbpress/bbpress.php' ) ) {
															array_push( $all_hook, 'bbpress_settings' );
														}
														if ( is_plugin_active( 'autoptimize/autoptimize.php' ) ) {
															array_push( $all_hook, 'wp_ajax_autoptimize_delete_cache', 'autoptimizer_settings' );
														}
														if ( is_plugin_active( 'users-ultra/xoousers.php' ) ) {
															array_push( $all_hook, 'wp_ajax_save_fields_settings', 'wp_ajax_delete_profile_field', 'wp_ajax_sort_fileds_list', 'wp_ajax_custom_fields_reset', 'wp_ajax_create_uploader_folder', 'wp_ajax_package_add_new', 'wp_ajax_package_delete', 'wp_ajax_package_edit_confirm', 'wp_ajax_sync_users', 'wp_ajax_user_resend_activation_link', 'wp_ajax_delete_uultra_transtient', 'wp_ajax_delete_uultra_stats', 'wp_ajax_delete_uultra_reviews', 'wp_ajax_edit_photo_cate_conf', 'wp_ajax_edit_photo_cate_del', 'wp_ajax_edit_photo_cate', 'userultra_admin_menu_hook' );
														}
														if ( is_plugin_active( 'user-switching/user-switching.php' ) ) {
															array_push( $all_hook, 'switch_to_user', 'switch_back_user', 'switch_off_user' );
														}
														if ( is_plugin_active( 'advanced-custom-fields/acf.php' ) ) {
															array_push( $all_hook, 'export_acf' );
														}
														?>
														<select name="custom_trigger_value_<?php echo $i; ?>[]" class="chosen-filter" multiple>
															<?php
															foreach ( $all_hook as $hook ) {
																$label = $hook;
																foreach ( $allhookdetails as $key => $val ) {
																	if ( $hook == $key ) {
																		$label = $val;
																	}
																}
																$selected = in_array( $hook, $custom_trigger_data_single['custom_trigger_value'] ) ? 'selected="selected"' : '';
																echo '<option value="' . $hook . '" ' . $selected . '>' . $label . '</option>';
															}
															?>
															</select>
														<?php
												}
												// print_R($custom_trigger_data_single);
												if ( $custom_trigger_data_single['custom_trigger_name'] == 'ip_address' ) {
													?>
													 <input class="ualp_event_medium" type="text" name="custom_trigger_value_<?php echo $i; ?>[]" placeholder="" value="<?php echo $custom_trigger_data_single['custom_trigger_value'][0]; ?>" required /> 
													<?php
												}
												?>
											</div>
										</td>
										<?php if ( $j != 1 ) { ?>
										<td class="ulap_last_column">
											<span title="<?php esc_html_e( 'Remove', 'user_activity_log_pro' ); ?>" class="ualp_remove_trigger_btn dashicons dashicons-trash"></span>
										</td>
										<?php } ?>
									</tr>
									<?php
									$j++;
								}
							} else {
								?>
								<tr class="ualp_custom_trigger_tr">
									<td style="display: none;">
										<span class="trigger-lable"><?php esc_html_e( 'Trigger With', 'user_activity_log_pro' ); ?></span><br/>
											<select name="custom_trigger_operator_with[]" class="chosen-filter">
												<option value="AND">AND</option>
												<option value="OR">OR</option>
											</select>
									</td>
									<td>
										<span class="trigger-lable">
										<?php
										esc_html_e( 'Trigger Name', 'user_activity_log_pro' );
										echo ' : ';
										?>
										</span><br/>
										<select name="custom_trigger_name[]" class="chosen-filter custom_trigger_name">
											<option value="user_id">User ID</option>
											<option value="user_name">User Name</option>
											<?php if ( ualp_allow_ip() ) { ?>
											<option value="ip_address">IP address</option>
											<?php } ?>
											<option value="user_role">User Role</option>
											<option value="hook">Activity</option>
										</select>
									</td>
									<td>
										<span class="trigger-lable">
										<?php
										esc_html_e( 'Trigger with', 'user_activity_log_pro' );
										echo ' : ';
										?>
										</span><br/>
										<select name="custom_trigger_with[]" class="chosen-filter">
											<option value="equal">IS Equal</option>
											<option value="not_equal">Not Equal</option>
										</select>
									</td>
									<td class="custom_trigger_value_tr">
										<span class="trigger-lable">
										<?php
										esc_html_e( 'Trigger Value', 'user_activity_log_pro' );
										echo ' : ';
										?>
										</span><br/>
										<div class="ualp_custom_trigger_value">
											<select name="custom_trigger_value_1[]" class="chosen-filter" multiple>
												<?php
												if ( isset( $all_users ) && ! empty( $all_users ) ) {
													foreach ( $all_users as $get_all_users ) {
														$userid    = $get_all_users->ID;
														$user_name = $get_all_users->user_login;
														echo '<option value="' . $userid . '">' . $userid . '</option>';
													}
												}
												?>
											</select>
										</div>
									</td>
								</tr>
							<?php } ?>
						</table>
					</div>
					<div class="add-trigger-email-wrapper">
						<span class="trigger-lable">
						<?php
						esc_html_e( 'Mobile Number', 'user_activity_log_pro' );
						echo ' : ';
						?>
						</span><input type="name" name="trigger_emailid" value="<?php echo $email_address; ?>" class="trigger_emailid" placeholder="Ex: +11234567890">
						<div class="email_display_note"><b><?php echo __( 'Note', 'user_activity_log_pro' ); ?></b>&nbsp;:&nbsp;<?php echo __( 'The Mobile number notifications will be sent to. For multiple mobile number  separate them with a comma. Ex. +11234567890,+21234567890', 'user_activity_log_pro' ); ?></div>
					</div>
					<div class="add-trigger-email-template">
						<div class="email-template-lable">
							<span class="trigger-lable">
							<?php
							esc_html_e( 'SMS Template', 'user_activity_log_pro' );
							echo ' : ';
							?>
							</span>
						</div>
						<div class="email-template-value">   
							<div class="email_template_wrap">
							<input type="radio" name="email_template" value="0"  
							<?php
							if ( $email_template == 0 ) {
								echo 'checked'; }
							?>
							 ><label><?php echo __( 'Use default SMS template', 'user_activity_log_pro' ); ?></label><br>
							</div>
							<div class="email_template_wrap">
							<input type="radio" name="email_template" value="1" 
							<?php
							if ( $email_template == 1 ) {
								echo 'checked'; }
							?>
							><label><?php echo __( 'Use event specific SMS template', 'user_activity_log_pro' ); ?></label><br>
							</div>
						</div>
					</div>
				<div class="event-spacific-wrapp">
				<?php
					// wp_editor($all_sms_notification, 'txtualpAddEmailMsg', array('editor_height' => 250));
				?>
				<textarea style="height:150px;width:350px" autocomplete="off" cols="10" name="txtualpAddEmailMsg" id="txtualpAddEmailMsg" maxlength="153"><?php echo $all_sms_notification; ?></textarea>
					<!--     Hi admin,
					Following user has done some activity in your site 
					[user_details]
					Thanks, 
					http://localhost/wptimeline -->
				</div>
				<?php
					wp_nonce_field( '_wp_trigger_notify_action', '_wp_trigger_notify_nonce' );
				?>
				<p class="submit">
					<input id="submit2" class="button button-primary" type="submit" value="
					<?php
					if ( isset( $_GET['snotification'] ) ) {
						esc_attr_e( 'Update Notification', 'user_activity_log_pro' );
					} else {
						esc_attr_e( 'Add Notification', 'user_activity_log_pro' ); }
					?>
					" name="saveTrigger">
				</p>
				<script>
					jQuery(document).ready(function () {
						jQuery('.ualp_add_new_trigger_btn').click(function () {
							var rows= jQuery('.ualp_custom_trigger_tr').length;
							var selectrow= rows+1;
							jQuery( '.ualp_custom_trigger_tr' ).removeClass( "selected" );
							var new_row = '<tr class="ualp_custom_trigger_tr">';
							new_row += '<td><span><?php esc_html_e( 'Trigger With', 'user_activity_log_pro' ); ?></span><br/><select name="custom_trigger_operator_with[]" class="chosen-filter"><option value="AND">AND</option><option value="OR">OR</option></select></td>';
							new_row += '<td><span>
							<?php
							esc_html_e( 'Trigger Name', 'user_activity_log_pro' );
							echo ' : ';
							?>
							</span><br/><select name="custom_trigger_name[]" class="chosen-filter custom_trigger_name"><option value="user_id">User ID</option><option value="user_name">User Name</option>
		<?php
		if ( ualp_allow_ip() ) {
			?>
							<option value="ip_address">Ip Address</option><?php } ?><option value="user_role">User Role</option><option value="hook">Activity</option></select></td>';
							new_row += '<td><span>
							<?php
							esc_html_e( 'Trigger with', 'user_activity_log_pro' );
							echo ' : ';
							?>
							</span><br/><select name="custom_trigger_with[]" class="chosen-filter"><option value="equal">Is Equal</option><option value="not_equal">Not Equal</option></select></td>';
							new_row +='<td class="custom_trigger_value_tr"><span>
							<?php
							esc_html_e( 'Trigger Value', 'user_activity_log_pro' );
							echo ' : ';
							?>
							</span><br/><div class="ualp_custom_trigger_value"><select name="custom_trigger_value_'+selectrow+'[]" class="chosen-filter" multiple>
		<?php
		foreach ( $all_users as $get_all_users ) {
			$userid                    = $get_all_users->ID;
							$user_name = $get_all_users->user_login;
							echo '<option value="' . $userid . '">' . $userid . '</option>'; }
		?>
</select></div></td>';
							new_row += '<td class="ulap_last_column"><span title="<?php esc_html_e( 'Remove', 'user_activity_log_pro' ); ?>" class="ualp_remove_trigger_btn dashicons dashicons-trash"></span></td>';
							new_row += '</tr>';
							jQuery('.custom_trigger_table').append(new_row);
							jQuery(".chosen-filter").select2();
							jQuery('.ualp_remove_trigger_btn').attr('style','padding-top: 12px !important');
							jQuery('.ualp_remove_trigger_btn').click(function () {
								jQuery(this).closest('tr').remove();
							});
						});
					});
				</script>
				</div>
			</form>
		</div>
		<?php
	}
}
/**
 * SMS Trigger Notificaton List
 */
if ( ! function_exists( 'ualpSmsTriggerNotificationSettings' ) ) {
	function ualpSmsTriggerNotificationSettings() {
		?>
		<div class="all_email_notification_wrapp">
			<div class="all_trigger_notification_title">
				<h3 class="ualpHeaderTitle"><?php esc_html_e( 'List Of Trigger Notification', 'user_activity_log_pro' ); ?></h3>
				<div class="add_new_trigger_wrapp">
				<?php
				if ( is_network_admin() && ualp_multi_site_support_return() ) {
					$adminurl = network_admin_url( 'admin.php?page=ualp_add_sms_notification' );
				} else {
					$adminurl = admin_url( 'admin.php?page=ualp_add_sms_notification' );
				}
				?>
					<a class="add_new_trigger" href="<?php echo $adminurl; ?>"><?php esc_attr_e( 'ADD TRIGGER', 'user_activity_log_pro' ); ?></a>
				</div>
			</div>
			<?php
				$table = new Ualp_Sms_Notification_List_Table();
				$table->prepare_items();
				$message = '';
			if ( isset( $_REQUEST['action'] ) == 'delete' || isset( $_REQUEST['bulk_action'] ) == 'Apply' ) {
				$message = '<div class="updated below-h2" id="message"><p>' . __( 'Trigger Notification deleted successfully', 'user_activity_log_pro' ) . '</p></div>';
				echo $message;
			}
				$current_url = ( isset( $_SERVER['HTTPS'] ) ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
			?>
			<form class="ualploginSettingsForm" method="get">
			<input type="hidden" name="page" value="<?php echo esc_attr( $_REQUEST['page'] ); ?>" />
			<div class="padding_right_15">
				<?php $table->display(); ?>
				<p class="margin_bottom_30"></p>
			</div>
		</form>
		</div>
		<?php
	}
}

/**
 * User activity email Settings
 */
if ( ! function_exists( 'ualpSmsSettings' ) ) {
	function ualpSmsSettings() {
		?>
		<div class="wrap">
			<h1><?php esc_html_e( 'SMS Settings', 'user_activity_log_pro' ); ?></h1>
			<?php
			if ( isset( $_SESSION['success_msg'] ) ) {
				?>
				<div class="success_msg">
				<?php
					ualp_admin_notice_message( 'updated', $_SESSION['success_msg'] );
					unset( $_SESSION['success_msg'] );
				?>
				</div>
				<?php
			}
			?>
			<div class="tab_parent_parent ualpParentTabs">
				<h2 class="nav-tab-wrapper nav-tab-wrapper">
					<a class="nav-tab nav-tab-active ualpTriggerSettings nav-tab-active-sms" data-href="ualpTriggerSettings" href="javascript:void(0)">
						<?php esc_html_e( 'Trigger Notification Settings', 'user_activity_log_pro' ); ?>
					</a>
					<a class="nav-tab ualpSmsNotificationSettings" data-href="ualpSmsNotificationSettings" href="javascript:void(0)" >
						<?php esc_html_e( 'SMS Notification Settings', 'user_activity_log_pro' ); ?>
					</a>
				</h2>
			</div>
			<div class="ualpTabContentWrap">
				<div id="ualpTriggerSettings" style="" class="ualpContentDiv"><?php ualpSmsTriggerNotificationSettings(); ?></div>
				<div id="ualpSmsNotificationSettings" style="display: none" class="ualpContentDiv"><?php ualpSmsNotificationSettings(); ?></div>
			</div>
		</div>
		<?php
	}
}

if ( ! function_exists( 'ualpSmsNotificationSettings' ) ) {
	function ualpSmsNotificationSettings() {
		global $wpdb, $current_user;
			$search        = $get_user_data = $get_role_data = '';
			$paged         = $total_pages = 1;
			$srno          = 0;
			$recordperpage = 10;
			$where         = 'where 1=1';
			$display       = 'roles';
			$user_details  = '[user_details]';
			wp_get_current_user();
		if ( isset( $_POST['saveLogin'] ) && isset( $_POST['_wp_email_notify_nonce'] ) && wp_verify_nonce( $_POST['_wp_email_notify_nonce'], '_wp_email_notify_action' ) ) {
			// $from_mobile                  = ( isset( $_POST['txtualpFromMobile'] ) && $_POST['txtualpFromMobile'] != '') ? $_POST['txtualpFromMobile'] : '';
			$ualpToFaildLoginMobile       = ( isset( $_POST['ualpToFaildLoginMobile'] ) && $_POST['ualpToFaildLoginMobile'] != '' ) ? $_POST['ualpToFaildLoginMobile'] : '';
			$ualpToFailLoginNotUserEmail  = ( isset( $_POST['ualpFailLoginNotUserMobile'] ) && $_POST['ualpFailLoginNotUserMobile'] != '' ) ? $_POST['ualpFailLoginNotUserMobile'] : '';
			$ualpFailLoginNumberAtt       = ( isset( $_POST['ualpFailLoginNumberAtt'] ) && $_POST['ualpFailLoginNumberAtt'] != '' ) ? $_POST['ualpFailLoginNumberAtt'] : '';
			$ualpToFailLoginNotUserNumber = ( isset( $_POST['ualpFailLoginNotUserNumberAtt'] ) && $_POST['ualpFailLoginNotUserNumberAtt'] != '' ) ? $_POST['ualpFailLoginNotUserNumberAtt'] : '';
			$ualp404PageAccessNumberAtt   = ( isset( $_POST['ualp404PageAccessNumberAtt'] ) && $_POST['ualp404PageAccessNumberAtt'] != '' ) ? $_POST['ualp404PageAccessNumberAtt'] : '';
			$ualpTo404LoginEmail          = ( isset( $_POST['ualp404LoginMobile'] ) && $_POST['ualp404LoginMobile'] != '' ) ? $_POST['ualp404LoginMobile'] : '';
			$mail_msg                     = ( isset( $_POST['txtualpMobileMsg'] ) && $_POST['txtualpMobileMsg'] != '' ) ? $_POST['txtualpMobileMsg'] : '';
			$ualpUserMobileNotify         = ( isset( $_POST['ualpUserMobileNotify'] ) && $_POST['ualpUserMobileNotify'] != '' ) ? $_POST['ualpUserMobileNotify'] : array();
			if ( $mail_msg == '' ) {
				$message = esc_html__( 'Please enter message', 'user_activity_log_pro' );
				ualp_admin_notice_message( 'error', $message );
			} /*
			else if ($from_mobile == "") {
				$message = esc_html__("Please enter the mobile number.", "user_activity_log_pro");
				ualp_admin_notice_message("error", $message);
			} */
			else {
				// update_option('ualp_twilio_from', $from_mobile);

				update_option( 'ualpToFaildLoginMobile', $ualpToFaildLoginMobile );
				update_option( 'ualpFailLoginNotUserMobile', $ualpToFailLoginNotUserEmail );
				update_option( 'ualpFailLoginNumberAtt', $ualpFailLoginNumberAtt );

				update_option( 'ualpFailLoginNotUserNumberAtt', $ualpToFailLoginNotUserNumber );
				update_option( 'ualp404PageAccessNumberAtt', $ualp404PageAccessNumberAtt );
				update_option( 'ualp404LoginMobile', $ualpTo404LoginEmail );

				update_option( 'ualpMobileMessage', $mail_msg );
				update_option( 'ualpMobileNotification', $ualpUserMobileNotify );
				$message = esc_html__( 'SMS Settings saved successfully.', 'user_activity_log_pro' );
				ualp_admin_notice_message( 'updated', $message );
				do_action( 'ualp_sms_settings_updated' );
			}
		}

		if ( isset( $_POST['btnResetEmailData'] ) ) {
			$ualpToFaildLoginMobile = $ualpToFailLoginNotUserEmail = $ualpFailLoginNumberAtt = $ualpToFailLoginNotUserNumber = $ualp404PageAccessNumberAtt = $ualpTo404LoginEmail = $ualpUserMobileNotify = $enable_user_login = '';
			$mail_msg               = esc_html__( 'Hi', 'user_activity_log_pro' ) . ' ';
			$mail_msg              .= $current_user->display_name . ',';
			$mail_msg              .= "\n\n" . __( 'Following user has done some activity in your site', 'user_activity_log_pro' ) . " \n$user_details";
			$mail_msg              .= "\n\n" . __( 'Thanks,', 'user_activity_log_pro' ) . " \n";
			$mail_msg              .= home_url();

			update_option( 'ualpToFaildLoginMobile', $ualpToFaildLoginMobile );
			update_option( 'ualpFailLoginNotUserMobile', $ualpToFailLoginNotUserEmail );
			update_option( 'ualpFailLoginNumberAtt', $ualpFailLoginNumberAtt );
			update_option( 'ualpFailLoginNotUserNumberAtt', $ualpToFailLoginNotUserNumber );
			update_option( 'ualp404PageAccessNumberAtt', $ualp404PageAccessNumberAtt );
			update_option( 'ualp404LoginMobile', $ualpTo404LoginEmail );
			// update_option('ualp_twilio_from', '');
			update_option( 'ualpMobileMessage', $mail_msg );
			update_option( 'ualpMobileNotification', $ualpUserMobileNotify );
			$message = esc_html__( 'SMS settings reset successfully.', 'user_activity_log_pro' );
			ualp_admin_notice_message( 'updated', $message );
		}
		if ( isset( $_GET['paged'] ) ) {
			$paged = $_GET['paged'];
		}
			$offset = ( $paged - 1 ) * $recordperpage;
		if ( isset( $_GET['display'] ) ) {
			$display = $_GET['display'];
		}
		if ( isset( $_GET['txtsearch'] ) && $_GET['txtsearch'] != '' && $display == 'users' ) {
			$search = $_GET['txtsearch'] ? sanitize_text_field( $_GET['txtsearch'] ) : '';
			$where .= " and user_login like '%$search%' or user_email like '%$search%' or display_name like '%$search%'";
		}
			$ualpFromEmail                 = get_option( 'ualp_twilio_from' );
			$ualpToFaildLoginMobile        = get_option( 'ualpToFaildLoginMobile' );
			$ualpToFailLoginNotUserEmail   = get_option( 'ualpFailLoginNotUserMobile' );
			$ualpFailLoginNumberAtt        = get_option( 'ualpFailLoginNumberAtt' );
			$ualpFailLoginNotUserNumberAtt = get_option( 'ualpFailLoginNotUserNumberAtt' );
			$ualp404PageAccessNumberAtt    = get_option( 'ualp404PageAccessNumberAtt' );
			$ualp404LoginMobile            = get_option( 'ualp404LoginMobile' );
			$ualpEmailMsg                  = get_option( 'ualpMobileMessage' );
			$ualpUserMobileNotify          = get_option( 'ualpMobileNotification' );

			$mail_message  = esc_html__( 'Hi', 'user_activity_log_pro' ) . ' ';
			$mail_message .= $current_user->display_name . ',';
			$mail_message .= "\n\n" . __( 'Following user has done some activity in your site', 'user_activity_log_pro' ) . " \n$user_details";
			$mail_message .= "\n\n" . __( 'Thanks,', 'user_activity_log_pro' ) . " \n";
			$mail_message .= home_url();

		if ( ! isset( $ualpUserMobileNotify ) || ! is_array( $ualpUserMobileNotify ) || empty( $ualpUserMobileNotify ) ) {
			$ualpUserMobileNotify = array();
		}
			// $from_mobile                = ( isset($ualpFromEmail) && $ualpFromEmail != "") ? $ualpFromEmail : '';
			$ualpFaildLoginEmail           = ( isset( $ualpToFaildLoginMobile ) && $ualpToFaildLoginMobile != '' ) ? $ualpToFaildLoginMobile : '';
			$ualpFailLoginNotUserMobile    = ( isset( $ualpToFailLoginNotUserEmail ) && $ualpToFailLoginNotUserEmail != '' ) ? $ualpToFailLoginNotUserEmail : '';
			$ualpFailLoginNumberAtt        = ( isset( $ualpFailLoginNumberAtt ) && $ualpFailLoginNumberAtt != '' ) ? $ualpFailLoginNumberAtt : '';
			$ualpFailLoginNotUserNumberAtt = ( isset( $ualpFailLoginNotUserNumberAtt ) && $ualpFailLoginNotUserNumberAtt != '' ) ? $ualpFailLoginNotUserNumberAtt : '';
			$ualp404PageAccessNumberAtt    = ( isset( $ualp404PageAccessNumberAtt ) && $ualp404PageAccessNumberAtt != '' ) ? $ualp404PageAccessNumberAtt : '';
			$ualp404LoginMobile            = ( isset( $ualp404LoginMobile ) && $ualp404LoginMobile != '' ) ? $ualp404LoginMobile : '';
			$mail_msg                      = ( isset( $ualpEmailMsg ) && $ualpEmailMsg != '' ) ? $ualpEmailMsg : $mail_message;
		if ( is_network_admin() && ualp_multi_site_support_return() ) {
			$adminurl = network_admin_url( 'admin.php' );
		} else {
			$adminurl = admin_url( 'admin.php' );
		}
		?>
			<div class="wrap">
				<?php
				if ( isset( $_SESSION['success_msg'] ) ) {
					?>
					<div class="success_msg">
					<?php
						ualp_admin_notice_message( 'updated', $_SESSION['success_msg'] );
						unset( $_SESSION['success_msg'] );
					?>
					</div>
					<?php
				}
				?>
				<form method="POST" class="ualpEmailSettingsForm" action="<?php echo $adminurl . '?' . $_SERVER['QUERY_STRING']; ?>">
					<input type="hidden" name="page" value="<?php echo esc_attr( $_REQUEST['page'] ); ?>" />
					<div class="padding_left_right_15">
						<div class="emailNotificationCover">
							<h3 class="ualpHeaderTitle"><?php esc_html_e( 'SMS Settings', 'user_activity_log_pro' ); ?></h3>
							<table class="widefat" cellspacing="0">
								<tr class="fromEmailTr" style="display: none;">
									<th><?php esc_html_e( 'From Mobile', 'user_activity_log_pro' ); ?></th>
									<td>
										<input type="text" name="txtualpFromMobile" placeholder="+11234567890" value="<?php // echo $from_mobile; ?>">
										<p class="description"><?php esc_html_e( 'The source mobile number', 'user_activity_log_pro' ); ?></p>
									</td>
								</tr>
								<tr class="toEmailnotification">
									<th><?php esc_html_e( 'Alert Me', 'user_activity_log_pro' ); ?></th>
									<td class="suspicious_tr">
									<p>
										<input type="checkbox" id="ualpFailLogin" <?php checked( in_array( 'ualpFailLogin', $ualpUserMobileNotify ), 1 ); ?> value="ualpFailLogin" name="ualpUserMobileNotify[]" title="User Fail Login for a WordPress User" class="ualpFailLogin">
										<label for="ualpFailLogin"><?php esc_html_e( 'Alert me on mobile', 'user_activity_log_pro' ); ?></label>
										<input type="text" name="ualpToFaildLoginMobile" placeholder="+11234567890" value="<?php echo $ualpFaildLoginEmail; ?>">
										<label for="ualpFailLogin"><?php esc_html_e( 'when WordPress user failed logins more than', 'user_activity_log_pro' ); ?></label> 
										<input type="number" value="<?php echo $ualpFailLoginNumberAtt; ?>" name="ualpFailLoginNumberAtt" placeholder="10" min="1">
										<label for="ualpFailLogin"><?php esc_html_e( 'times.', 'user_activity_log_pro' ); ?></label>
									</p>
									<p>
										<input type="checkbox" id="ualpFailLoginNotUser" <?php checked( in_array( 'ualpFailLoginNotUser', $ualpUserMobileNotify ), 1 ); ?> value="ualpFailLoginNotUser" name="ualpUserMobileNotify[]" title="User Fail user Login of Not Existing user" class="ualpFailLoginNotUser">
										<label for="ualpFailLoginNotUser"><?php esc_html_e( 'Alert me on mobile', 'user_activity_log_pro' ); ?></label>
										<input type="text" name="ualpFailLoginNotUserMobile" placeholder="+11234567890" value="<?php echo $ualpFailLoginNotUserMobile; ?>">
										<label for="ualpFailLoginNotUser"><?php esc_html_e( 'when non existing users failed logins more than', 'user_activity_log_pro' ); ?></label>
										<input type="number" value="<?php echo $ualpFailLoginNotUserNumberAtt; ?>" name="ualpFailLoginNotUserNumberAtt" placeholder="10" min="1">
										<label for="ualpFailLoginNotUser"><?php esc_html_e( 'times.', 'user_activity_log_pro' ); ?></label>
									</p>
									<p>
										<input type="checkbox" id="ualpUser404PageAccess" <?php checked( in_array( 'ualpUser404PageAccess', $ualpUserMobileNotify ), 1 ); ?> value="ualpUser404PageAccess" name="ualpUserMobileNotify[]" title="User Generates 404 Page" class="ualpUser404PageAccess">
										<label for="ualpUser404PageAccess"><?php esc_html_e( 'Alert me on mobile', 'user_activity_log_pro' ); ?></label>
										<input type="text" name="ualp404LoginMobile" placeholder="+11234567890" value="<?php echo $ualp404LoginMobile; ?>">
										<label class="ualpUser404PageAccess"><?php esc_html_e( 'when a user generates 404 HTTP errors more than', 'user_activity_log_pro' ); ?></label>
										<input type="number" value="<?php echo $ualp404PageAccessNumberAtt; ?>" name="ualp404PageAccessNumberAtt" placeholder="10" min="1"> 
										<label class="ualpUser404PageAccess"><?php esc_html_e( 'times.', 'user_activity_log_pro' ); ?></label>
									</p>
									<p class="description"><?php esc_html_e( 'The Mobile notifications will be sent to. For multiple mobile address separate them with a comma.', 'user_activity_log_pro' ); ?>&nbsp;<small><?php echo 'Ex. +11234567890,+10123456789'; ?></small></p>
									</td>
								</tr>
								<tr class="messageTr">
									<th><?php esc_html_e( 'Message', 'user_activity_log_pro' ); ?></th>
									<td>
										<textarea name="txtualpMobileMsg" rows="10" cols="100"><?php echo esc_html( $mail_msg ); ?></textarea>
										<?php
										// wp_editor($all_sms_notification, 'txtualpAddEmailMsg', array('editor_height' => 250));
										?>
										<!-- <textarea style="height:150px;width:350px" autocomplete="off" cols="10" name="txtualpMobileMsg" id="txtualpAddEmailMsg" maxlength="153">
										<?php
											// echo $mail_msg;
										?>
										</textarea> -->
										<?php
										// wp_editor($mail_msg, 'txtualpMobileMsg', array('editor_height' => 250));
										?>
										<p class="description"><?php // esc_html_e('COOKIEHASHustomize the message as per your requirement', 'user_activity_log_pro'); ?></p>
									</td>
								</tr>
							</table>
						</div>
						<?php
						wp_nonce_field( '_wp_email_notify_action', '_wp_email_notify_nonce' );
						?>
						<p class="submit">
							<input id="submit2" class="button button-primary" type="submit" value="<?php esc_attr_e( 'Save Changes', 'user_activity_log_pro' ); ?>" name="saveLogin">
							<input class="button button-secondary" type="submit" value="<?php esc_attr_e( 'Reset Changes', 'user_activity_log_pro' ); ?>" name="btnResetEmailData" onclick="return confirm('<?php esc_js( _e( 'Are you sure to reset data?', 'user_activity_log_pro' ) ); ?>')">
						</p>
					</div>
				</form>
			</div>
		<?php
	}
}

/*
 * Insert record into wp_email_notifictaion table
 *
 * @param $current_user_name current user name.
 * @param $description
 * @param $trigger_data
 * @param $title
 * @param $emailid
 * @param $email_template
 *
 */

if ( ! function_exists( 'ualp_insert_sms_notification' ) ) {
	function ualp_insert_sms_notification( $current_user_name, $description, $trigger_data, $title, $emailid, $email_template ) {
		global $wpdb, $externaldb;
		$username  = get_user_by( 'login', $current_user_name );
		$user_mail = $current_user_id = $user_role = '';
		if ( isset( $username ) && ! empty( $username ) ) {
			$current_user_name = $username->data->display_name;
			$user_mail         = $username->data->user_email;
			$current_user_id   = $username->data->ID;
			if ( ! empty( $username->roles ) && is_array( $username->roles ) ) {
				if ( sizeof( $username->roles ) == 1 ) {
					$user_role = $username->roles[0];
				} else {
					$userRole = $username->roles;
					foreach ( $userRole as $all_rols ) {
						$user_role .= $all_rols . ' ,';
					}
				}
			}
		} else {
			$current_user_name = 'Guest';
			$user_mail         = '';
			$current_user_id   = '';
			$user_role         = '';
		}
		$site_id = get_current_blog_id();
		ualp_create_table();
		ualp_create_detail_table();
		ualp_create_external_table();
		ualp_create_detail_external_table();
		ualp_create_login_external_table();
		ualp_create_sms_notification_table();
		ualp_create_sms_notification_external_table();
		ualp_create_schedule_report();
		ualp_create_schedule_external_report();
		/**
		 * ualpBeforeInsertEmailNotification hook.
		 */
		do_action( 'ualpBeforeInsertSmsNotification' );
		$insert_query = $externaldb->insert(
			UALP_SMS_TABLENAME,
			array(
				'sms_title'           => $title,
				'sms_content'         => $description,
				'user_id'             => $current_user_id,
				'user_name'           => $current_user_name,
				'user_role'           => $user_role,
				'user_email'          => $user_mail,
				'site_id'             => $site_id,
				'sms_address'         => $emailid,
				'sms_template'        => $email_template,
				'custom_trigger_data' => serialize( $trigger_data ),
			)
		);
		/**
		 * ualpAfterInsertSmsNotification hook.
		 */
		do_action( 'ualp_insert_sms_notification' );
		// wp_redirect(admin_url('admin.php?page=ualp_sms_setting'));.
		// exit();
	}
}
/*
 * Insert record when user logout
 */
if ( ! function_exists( 'ualpSmsUpdateNotification' ) ) {
	function ualpSmsUpdateNotification( $enotification, $all_email_notification, $trigger_data, $title, $emailid, $email_template ) {
		global $wpdb, $externaldb;
		do_action( 'ualp_before_update_notification' );
		$table_names = UALP_SMS_TABLENAME;
		$externaldb->update(
			UALP_SMS_TABLENAME,
			array(
				'sms_content'         => $all_email_notification,
				'custom_trigger_data' => serialize( $trigger_data ),
				'sms_title'           => $title,
				'sms_address'         => $emailid,
				'sms_template'        => $email_template,
			),
			array( 'uacteid' => $enotification )
		);
		do_action( 'ualp_update_sms_notification' );
		// wp_redirect( admin_url( 'admin.php?page=ualp_sms_setting' ) );
		// exit();
	}
}


/*
 * send email notification content
 *
 * @return $current_user
 * @param $user_firstnm
 * @param $user_lastnm
 * @param $user_email
 * @param $activity
 * @param $to_email_address
 * @param $email_template
 *
 */
if ( ! function_exists( 'ualpSmsTriggerBody' ) ) {
	function ualpSmsTriggerBody( $current_user, $user_firstnm, $user_lastnm, $user_email, $activity, $to_email_address, $email_content ) {
		if ( ualp_allow_ip() ) {
			$get_ip_type = get_option( 'ualpIPtypes', 'REMOTE_ADDR' );
			if ( $get_ip_type ) {
				if ( 'REMOTE_ADDR' == $get_ip_type ) {
					$ip = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ) : '';
				} elseif ( 'HTTP_X_FORWARDED_FOR' == $get_ip_type ) {
					$ip = isset( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['HTTP_X_FORWARDED_FOR'] ) ) : '';
				} elseif ( 'HTTP_X_REAL_IP' == $get_ip_type ) {
					$ip = isset( $_SERVER['HTTP_X_REAL_IP'] ) ? sanitize_text_field( wp_unslash( $_SERVER['HTTP_X_REAL_IP'] ) ) : '';
				} else {
					$ip = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ) : '';
				}
			} else {
				$ip = isset( $_SERVER['REMOTE_ADDR'] ) ? sanitize_text_field( wp_unslash( $_SERVER['REMOTE_ADDR'] ) ) : '';
			}
		} else {
			$ip = '';
		}
		$modified_date = current_time( 'mysql' );
		$modified_date = strtotime( $modified_date );
		$date_format   = get_option( 'date_format' );
		$time_format   = get_option( 'time_format' );
		$date          = date( $date_format, $modified_date );
		$time          = date( $time_format, $modified_date );
		$user_reg      = $date . ' ' . $time;

		$mail_msg = $email_content;
		if ( empty( $mail_msg ) ) {
			$user_details_shortcode = '[user_details]';
			$mail_msg               = esc_html__( 'Hi', 'user_activity_log_pro' ) . ' ';
			$mail_msg              .= $current_user . ',';
			$mail_msg              .= "\n\n" . __( 'Following user has done some activity in your site', 'user_activity_log_pro' ) . " \n$user_details_shortcode";
			$mail_msg              .= "\n\n" . __( 'Thanks,', 'user_activity_log_pro' ) . " \n";
			$mail_msg              .= home_url();
		}
		if ( ! empty( $to_email_address ) ) {
			$to_email = $to_email_address;
		}
		$user_details  = '';
		$user_details .= '( ' . $current_user . ' )';
		$user_details .= '( ' . $user_reg . ' )';
		if ( ualp_allow_ip() ) {
			$user_details .= '( ' . $ip . ' )';
		}
		$user_details .= '( ' . $activity . ' )';
		$mail_msg      = str_replace( '[user_details]', $user_details, $mail_msg );

		if ( isset( $to_email ) && $to_email != '' && $mail_msg != '' ) {
			$to_email_array = explode( ',', $to_email );
			for ( $i = 0; $i < sizeof( $to_email_array );$i++ ) {
				$to_mail = trim( $to_email_array[ $i ], ' ' );
				Ualp_Twilio_SMS::send_message_bulk( $to_mail, $mail_msg );
			}
		}
	}
}

require_once 'ualp-sms-notification-2.php';
