<?php
/**
 * Fired when the plugin is uninstalled.
 *
 * @package User Activity Log PRO
 */

// If uninstall not called from WordPress, then exit.
if ( ! defined( 'WP_UNINSTALL_PLUGIN' ) ) {
	exit;
}
$ualp_delete_all_data = get_option( 'ualpDeleteAllData', 0 );

if ( 1 == $ualp_delete_all_data ) {
	delete_option( 'ualp_last_delete_log_date' );
	delete_option( 'ualp_version' );
	delete_option( 'enableLogHookList' );
	delete_option( 'exclude_log_data' );
	delete_option( 'ual_version' );
	delete_option( 'ualp_run_updater' );
	delete_option( 'ualpEmailMessage' );
	delete_option( 'table_prefix' );
	delete_option( 'database_name' );
	delete_option( 'database_hostname' );
	delete_option( 'database_username' );
	delete_option( 'database_password' );
	delete_option( 'ualpRoleAccessList' );
	delete_option( 'ualpUserAccessList' );
	delete_option( 'ualp_generate_report_username_list' );
	delete_option( 'ualp_generate_report_userrole_list' );
	delete_option( 'ualp_generate_report_country_list' );
	delete_option( 'ualp_generate_report_ipaddress_list' );
	delete_option( 'ualp_generate_report_logtype_list' );
	delete_option( 'ualp_generate_report_hook_list' );
	delete_option( 'ualp_generate_report_posttype_list' );
	delete_option( 'ualp_generate_report_allpost_list' );
	delete_option( 'ualp_generate_report_start_date' );
	delete_option( 'ualp_generate_report_end_date' );
	delete_option( 'ualp_generate_report_format' );
	delete_option( 'ualpKeepLogsDay' );
	delete_option( 'ualp_allow_ip' );
	delete_option( 'ualpAllowDashbordWidget' );
	delete_option( 'ualp_allow_country' );
	delete_option( 'ualp_allow_user_agent' );
	delete_option( 'ualpFromEmail' );
	delete_option( 'ualpToFaildLoginEmail' );
	delete_option( 'ualpFailLoginNotUserEmail' );
	delete_option( 'ualpFailLoginNumber' );
	delete_option( 'ualpFailLoginNotUserNumber' );
	delete_option( 'ualp404PageAccessNumber' );
	delete_option( 'ualp404LoginEmail' );
	delete_option( 'ualpEmailMessage' );
	delete_option( 'ualpEmailNotification' );
	delete_option( 'ualp_delete_log_pwd' );
	delete_option( 'custom_event_data' );
	delete_option( 'ualp_username' );
	delete_option( 'ualp_purchase_code' );
	delete_option( 'ualpAddJsonCredentials' );
	delete_site_option( 'ualpMultisiteMenu' );

	// delete database table.
	global $wpdb;

	/** Delete ualp_user_activity table */
	$ualp_user_activity = $wpdb->prefix . 'ualp_user_activity';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_user_activity" );

	/** Delete ualp_user_activity_detail table */
	$ualp_user_activity_detail = $wpdb->prefix . 'ualp_user_activity_detail';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_user_activity_detail" );

	/** Delete ualp_user_activity_login table */
	$ualp_user_activity_login = $wpdb->prefix . 'ualp_user_activity_login';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_user_activity_login" );

	/** Delete ualp_email_notification table */
	$ualp_email_notification = $wpdb->prefix . 'ualp_email_notification';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_email_notification" );

	/** Delete ualp_schedule_report table */
	$ualp_schedule_report = $wpdb->prefix . 'ualp_schedule_report';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_schedule_report" );

	$tableprefix = get_option( 'table_prefix' );

	/** Delete ualp_user_activity table */
	$ualp_user_activity_table = $tableprefix . 'ualp_user_activity';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_user_activity}" );

	/** Delete ualp_user_activity_detail table */
	$ualp_user_activity_detail_table = $tableprefix . 'ualp_user_activity_detail';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_user_activity_detail" );

	/** Delete ualp_user_activity_login table */
	$ualp_user_activity_login_table = $tableprefix . 'ualp_user_activity_login';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_user_activity_login" );

	/** Delete ualp_email_notification table */
	$ualp_email_notification_table = $tableprefix . 'ualp_email_notification';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_email_notification" );

	/** Delete ualp_schedule_report table */
	$ualp_schedule_report_table = $tableprefix . 'ualp_schedule_report';
	$wpdb->query( "DROP TABLE IF EXISTS {$wpdb->prefix}ualp_schedule_report" );

	delete_option( 'ualpDeleteAllData' );
}

