<?php
/**
 * Plugin Name: User Activity Log Pro
 * Plugin URI: https://www.persianscript.ir
 * Description: Log the activity of users to monitor your site with actions
 * Author: پرشین اسکریپت
 * Author URI: https://www.persianscript.ir
 * Version: 2.3.4
 * Requires at least: 5.4
 * Tested up to: 6.4.2
 * Copyright: Solwin Infotech
 *
 * @package User Activity Log PRO
 */

/**
 * Exit if accessed directly
 */
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! defined( 'COOKIEHASH' ) ) {
	$siteurl = get_site_option( 'siteurl' );
	if ( $siteurl ) {
		define( 'COOKIEHASH', md5( $siteurl ) );
	} else {
		define( 'COOKIEHASH', '' );
	}
}
if ( ! defined( 'AUTH_COOKIE' ) ) {
	define( 'AUTH_COOKIE', 'wordpress_' . COOKIEHASH );
}
/**
* If multisite active plugin then include plugin.php file.
*/
if ( is_multisite() ) {
	if ( ! function_exists( 'is_plugin_active_for_network' ) ) {
		require_once ABSPATH . '/wp-admin/includes/plugin.php';
	}
}
add_action( 'init', 'ualp_multi_site_support_return' );


if ( ! function_exists( 'ualp_multi_site_support_return' ) ) {
	/**
	 * Check plugin active mutisite or not
	 */
	function ualp_multi_site_support_return() {
		if ( is_multisite() && is_plugin_active_for_network( 'user-activity-log-pro/user_activity_log_pro.php' ) ) {
			return true;
		} else {
			return false;
		}
	}
}

/**
 * Define variables.
 */
global $externaldb,$wpdb;

$tableprefix = '';
$dbuser      = '';
$dbpassword  = '';
$dbname      = '';
$dbhost      = '';
$tableprefix = get_option( 'table_prefix' );
$dbuser      = get_option( 'database_username' );
$dbpassword  = get_option( 'database_password' );
$dbname      = get_option( 'database_name' );
$dbhost      = get_option( 'database_hostname' );
define( 'UALP_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
define( 'UALP_PLUGIN_URL', plugin_dir_url( __FILE__ ) );

if ( '' == $tableprefix && '' == $dbname && '' == $dbhost && '' == $dbuser && '' == $dbpassword ) {
	if ( ualp_multi_site_support_return() ) {
		$db_table_prefix = $wpdb->base_prefix;
	} else {
		$db_table_prefix = $wpdb->prefix;
	}
	define( 'UALP_TABLENAME', $db_table_prefix . 'ualp_user_activity' );
	define( 'UALP_DETAIL_TABLENAME', $db_table_prefix . 'ualp_user_activity_detail' );
	define( 'UALP_LOGIN_TABLENAME', $db_table_prefix . 'ualp_user_activity_login' );
	define( 'UALP_EMAIL_TABLENAME', $db_table_prefix . 'ualp_email_notification' );
	define( 'UALP_SMS_TABLENAME', $db_table_prefix . 'ualp_sms_notification' );
	define( 'UALP_SCHEDULE_TABLENAME', $db_table_prefix . 'ualp_schedule_report' );
} else {
	$db = new wpdb( $dbuser, $dbpassword, $dbname, $dbhost );
	if ( mysqli_connect_errno() ) {
		if ( ualp_multi_site_support_return() ) {
			$db_table_prefix = $wpdb->base_prefix;
		} else {
			$db_table_prefix = $wpdb->prefix;
		}
		define( 'UALP_TABLENAME', $db_table_prefix . 'ualp_user_activity' );
		define( 'UALP_DETAIL_TABLENAME', $db_table_prefix . 'ualp_user_activity_detail' );
		define( 'UALP_LOGIN_TABLENAME', $db_table_prefix . 'ualp_user_activity_login' );
		define( 'UALP_EMAIL_TABLENAME', $db_table_prefix . 'ualp_email_notification' );
		define( 'UALP_SMS_TABLENAME', $db_table_prefix . 'ualp_sms_notification' );
		define( 'UALP_SCHEDULE_TABLENAME', $db_table_prefix . 'ualp_schedule_report' );
	} else {
		define( 'UALP_TABLENAME', $tableprefix . 'ualp_user_activity' );
		define( 'UALP_DETAIL_TABLENAME', $tableprefix . 'ualp_user_activity_detail' );
		define( 'UALP_LOGIN_TABLENAME', $tableprefix . 'ualp_user_activity_login' );
		define( 'UALP_EMAIL_TABLENAME', $tableprefix . 'ualp_email_notification' );
		define( 'UALP_SMS_TABLENAME', $tableprefix . 'ualp_sms_notification' );
		define( 'UALP_SCHEDULE_TABLENAME', $tableprefix . 'ualp_schedule_report' );
	}
}
require_once ABSPATH . 'wp-admin/includes/plugin.php';
if ( ! function_exists( 'is_plugin_active' ) || ! function_exists( 'wp_verify_nonce' ) ) {
	require_once ABSPATH . WPINC . '/pluggable.php';
}
require UALP_PLUGIN_DIR . 'includes/ualp-common-functions.php';
require UALP_PLUGIN_DIR . 'includes/ualp-list-table.php';
require UALP_PLUGIN_DIR . 'includes/ualp-hooks.php';
require UALP_PLUGIN_DIR . 'includes/ualp-log-detail.php';
require UALP_PLUGIN_DIR . 'includes/ualp-settings-menu.php';
require UALP_PLUGIN_DIR . 'includes/ualp-settings-tab.php';
require UALP_PLUGIN_DIR . 'includes/ualp-email-notification.php';
require UALP_PLUGIN_DIR . 'includes/ualp-sms-notification.php';
require UALP_PLUGIN_DIR . 'includes/ualp-hooks-user-activity-log-pro.php';
require UALP_PLUGIN_DIR . 'includes/ualp-export-logs.php';
require UALP_PLUGIN_DIR . 'includes/ualp-db-integration.php';
require UALP_PLUGIN_DIR . 'includes/ualp-generate-reports.php';
require UALP_PLUGIN_DIR . 'includes/class-ualp-twilio-sms.php';
require UALP_PLUGIN_DIR . 'includes/class-ualp-google-sheets-api.php';


if ( is_plugin_active( 'blog-designer-pro/blog-designer-pro.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-blog-designer-pro.php';
}
if ( is_plugin_active( 'all-in-one-reservation/all-in-one-reservation.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-allinone-reservation.php';
}
if ( is_plugin_active( 'portfolio-designer/portfolio-designer.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-portfolio-designer.php';
}
if ( is_plugin_active( 'wc-checkout-fields-editor/wc-checkout-fields-editor.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-wc-checkout-fields-editor.php';
}
if ( is_plugin_active( 'woocommerce/woocommerce.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-woocommerce.php';
}
if ( is_plugin_active( 'gravityforms/gravityforms.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-gravityform.php';
}
if ( is_plugin_active( 'autoptimize/autoptimize.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-autoptimizer.php';
}
if ( is_plugin_active( 'bbpress/bbpress.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-bbpress.php';
}
if ( is_plugin_active( 'wordfence/wordfence.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-wordfence.php';
}
if ( is_plugin_active( 'wordpress-seo/wp-seo.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-wordpress-seo.php';
}
if ( is_plugin_active( 'easy-digital-downloads/easy-digital-downloads.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-easy-digital-download.php';
}
if ( is_plugin_active( 'contact-form-7/wp-contact-form-7.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-contact-form-7.php';
}
if ( is_plugin_active( 'users-ultra/xoousers.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-userultra.php';
}
if ( is_plugin_active( 'user-switching/user-switching.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hooks-user-switching.php';
}
if ( is_plugin_active( 'buddypress/bp-loader.php' ) ) {
	include UALP_PLUGIN_DIR . 'includes/ualp-hook-bubbypress.php';
}
if ( is_plugin_active( 'advanced-custom-fields/acf.php' ) || is_plugin_active( 'advanced-custom-fields-pro/acf.php' ) ) {
	add_filter( 'ualp_post_meta_array', 'sol_ualp_post_meta_array', 10, 2 );
	/**
	 * Post Meta Array.
	 *
	 * @param array  $get_default_metakey_array Get Default Meta Key.
	 * @param string $post_type Post Type.
	 */
	function sol_ualp_post_meta_array( $get_default_metakey_array, $post_type ) {
		$post_id = get_posts(
			array(
				'fields'         => 'ids',
				'posts_per_page' => -1,
			)
		);
		$groups  = acf_get_field_groups(
			array(
				'post_id'   => $post_id,
				'post_type' => $post_type,
			)
		);
		if ( ! empty( $groups ) ) {
			$field_label = array();
			foreach ( $groups as $group ) {
				$group_id                                 = $group['ID'];
				$group_title                              = $group['title'];
				$all_acf_data[ $group_id ]                = array();
				$all_acf_data[ $group_id ]['group_id']    = $group_id;
				$all_acf_data[ $group_id ]['group_title'] = $group_title;
				$fields                                   = acf_get_fields( $group_id );
				if ( $fields ) {
					$all_acf_data[ $group_id ]['fields'] = array();
					$val_fields                          = 0;
					foreach ( $fields as $field ) {
						$field_label[] = $field['label'];

					}
				}
			}
		}
		if ( ! empty( $field_label ) ) {
			$get_default_metakey_array = array_merge( $get_default_metakey_array, $field_label );
		}
		return $get_default_metakey_array;
	}
}

if ( ! function_exists( 'ualp_hookdetails' ) ) {
	/**
	 * Hook Details Page file include.
	 */
	function ualp_hookdetails() {
		// include_once UALP_PLUGIN_DIR . 'includes/ualp-hook-details.php';.
	}
}

$externaldb = ualp_external();
register_activation_hook( __FILE__, 'ualp_deactivate_ual' );
add_action( 'current_screen', 'ualp_footer_adv' );
$pluginurl = plugin_basename( __FILE__ );
add_filter( "plugin_action_links_$pluginurl", 'ualp_add_settings_link' );
add_action( 'plugins_loaded', 'ualp_load_text_domain' );
add_action( 'plugins_loaded', 'latest_news_solwin_feed' );
add_action( 'init', 'ualp_set_role_manager', 6 );
add_action( 'init', 'ualp_filter_user_role' );
add_action( 'init', 'ualp_session_start' );
add_action( 'admin_init', 'ualp_delete_log_once' );

if ( ! function_exists( 'ualp_delete_log_once' ) ) {
	/**
	 * Delete Log Once.
	 */
	function ualp_delete_log_once() {
		$yesterday_date            = gmdate( 'Y-m-d', strtotime( 'yesterday' ) );
		$today_date                = gmdate( 'Y-m-d' );
		$ualp_last_delete_log_date = get_option( 'ualp_last_delete_log_date' );
		if ( ! isset( $ualp_last_delete_log_date ) || '' == $ualp_last_delete_log_date ) {
			update_option( 'ualp_last_delete_log_date', $yesterday_date );
		}
		$ualp_last_delete_log_date = get_option( 'ualp_last_delete_log_date' );
		if ( $ualp_last_delete_log_date != $today_date ) {
			ualp_delete_log();
			update_option( 'ualp_last_delete_log_date', $today_date );
		}
	}
}

add_action( 'activate_plugin', 'ualp_create_table', 2 );
add_action( 'activate_plugin', 'ualp_create_detail_table', 4 );
add_action( 'activate_plugin', 'ualp_set_default_log_hook', 8 );
add_action( 'wp_insert_site', 'ualp_set_default_log_hook', 8 );
add_action( 'admin_init', 'ualp_set_default_log_hook', 8 );
add_action( 'activated_plugin', 'ualp_redirect', 10, 2 );

add_action( 'admin_notices', 'ualp_database_upgrade' );

add_action( 'admin_head', 'ualp_dialogbox_content' );
add_action( 'admin_head', 'ulap_get_admin_pwd' );
add_action( 'admin_init', 'ualp_activate' );
add_action( 'admin_init', 'ualp_reset_database_settings' );
add_action( 'admin_enqueue_scripts', 'ualp_admin_styles' );
add_action( 'admin_enqueue_scripts', 'ualp_admin_scripts' );

add_action( 'wp_ajax_compareLogPassword', 'ualp_compare_log_password' );
add_action( 'wp_ajax_nopriv_terminateallsessions', 'ualp_terminate_all_sessions' );
add_action( 'wp_ajax_terminateallsessions', 'ualp_terminate_all_sessions' );
add_action( 'wp_ajax_downloadLogFile', 'ualp_delete_ualp_table' );
add_action( 'wp_ajax_downloadSingleLog', 'ualp_delete_single_log' );
add_action( 'wp_ajax_downloadBulkLog', 'ualp_delete_bulk_log' );
add_action( 'wp_ajax_viewDetailLog', 'ualp_view_update_detail' );
add_action( 'wp_ajax_nopriv_viewDetailLog', 'ualp_view_update_detail' );
add_action( 'wp_ajax_getDetails', 'ualp_dashboard_log_stats' );
add_action( 'wp_ajax_nopriv_getDetails', 'ualp_dashboard_log_stats' );
add_action( 'wp_ajax_ualpFavoriteLog', 'ualp_ajax_favorite_log' );
add_action( 'wp_ajax_ualp_session_expire', 'ualp_session_expire' );
add_action( 'init', 'ualp_shortcodes_init' );



/**
 * Create shortcode for particular user.
 */
function ualp_shortcodes_init() {
	add_shortcode( 'ualp_userhistory', 'ualp_shortcode' );
}
ualp_create_table();

if ( ! function_exists( 'ualp_load_text_domain' ) ) {
	/**
	 * Load plugin text domain (user_activity_log_pro).
	 */
	function ualp_load_text_domain() {
		load_plugin_textdomain( 'user_activity_log_pro', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' );
	}
}

if ( ! function_exists( 'ualp_licensekey' ) ) {
	/**
	 * License Key.
	 */
	function ualp_licensekey() {
		include_once UALP_PLUGIN_DIR . 'includes/version-and-api.php';
	}
}

if ( ! function_exists( 'ualp_activate' ) ) {
	/**
	 * Auto-Update Plugin.
	 */
	function ualp_activate() {
		include_once UALP_PLUGIN_DIR . 'includes/wp-autoupdate.php';
		new Ualp_Wp_Auto_Update();
	}
}

if ( ! function_exists( 'ualp_shortcode' ) ) {
	/**
	 * Display Log data using [ualp_userhistory] shortcode.
	 *
	 * @param array  $atts Display log by this user id.
	 * @param string $content Content.
	 * @param string $tag Tags.
	 */
	function ualp_shortcode( $atts = array(), $content = null, $tag = '' ) {
		ob_start();
		$atts      = array_change_key_case( (array) $atts, CASE_LOWER );
		$ualp_atts = shortcode_atts( array( 'id' => get_current_user_id() ), $atts, $tag );
		global $wpdb;
		if ( is_multisite() ) {
			$results = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM {$wpdb->base_prefix}ualp_user_activity WHERE user_id = %d", $ualp_atts['id'] ) );
		} else {
			$results = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM {$wpdb->prefix}ualp_user_activity WHERE user_id = %d", $ualp_atts['id'] ) );
		}
			echo "<table class='user_history'>";
			echo '<tr>';
			echo '<th>Date</th>';
			echo '<th>User Name</th>';
			echo '<th>Hook</th>';
			echo '<th>Type</th>';
			echo '<th>Description</th>';
			echo '</tr>';
		foreach ( $results as $key => $value ) {
			echo '<tr>';
			echo '<td>' . esc_html( $value->modified_date ) . '</td>';
			echo '<td>' . esc_html( $value->user_name ) . '</td>';
			echo '<td>' . esc_html( $value->hook ) . '</td>';
			echo '<td>' . esc_html( $value->object_type ) . '</td>';
			echo '<td>' . esc_html( $value->description ) . '</td>';
			echo '</tr>';
		}
			echo '</table>';
			return ob_get_clean();
	}
}
add_action( 'admin_init', 'ualp_global_array_description' );

if ( ! function_exists( 'ualp_global_array_description' ) ) {
	/**
	 * Display Global Array Description.
	 */
	function ualp_global_array_description() {
		global $allhookdetails;
		$post_types     = ualp_posttypes();
		$taxonomies     = ualp_taxonomies();
		$allhookdetails = array(
			'activated_plugin'                          => 'Activate Plugin',
			'deactivated_plugin'                        => 'Deactivate Plugin',
			'delete_plugin'                             => 'Delete Plugin',
			'plugin_modify'                             => 'Modify Plugin File',
			'plugin_installed'                          => 'Install Plugin',
			'plugin_updated'                            => 'Plugin Update',
			'wpcf7_after_create'                        => 'Contact Form 7 Create',
			'wpcf7_after_update'                        => 'Contact Form 7 Update',
			'wpcf7_admin_notices'                       => 'Contact Form 7 Delete',
			'wpcf7-recaptcha-setup'                     => 'Recaptcha Settings Update',
			'ualp_export_activity_log'                  => 'Export Activity Log',
			'ualp_general_settings_updated'             => 'UALP General Settings Update',
			'ualp_hook_log_settings_updated'            => 'Log Hook Settings Update',
			'ualp_manage_role'                          => 'Role settings Update',
			'ualp_set_password'                         => 'Log Password Set',
			'ualp_change_password'                      => 'Log Password Change',
			'ualp_email_settings_updated'               => 'Email Settings Update',
			'ualp_custom_event_log_updated'             => 'Custom Event Update',
			'ualp_exclude_log_updated'                  => 'Exclude Log Setting',
			'ualp_highlight_log_updated'                => 'Highlight Log Setting',
			'ualp_insert_email_notification'            => 'Trigger Notification Create',
			'ualp_update_email_notification'            => 'Trigger Notification Update',
			'wp_login'                                  => 'User Login',
			'wp_login_failed'                           => 'User Login Fail',
			'wp_logout'                                 => 'User Logout',
			'delete_user'                               => 'User Delete',
			'user_register'                             => 'User Register',
			'insert_user_meta'                          => 'User Profile Update',
			'theme_file_modify'                         => 'Modify Theme File',
			'switch_theme'                              => 'Theme Switch',
			'customize_save'                            => 'Theme Customize Update',
			'theme_updated'                             => 'Theme Update',
			'theme_installed'                           => 'Install Theme',
			'delete_site_transient_update_themes'       => 'Delete Theme',
			'wp_insert_comment'                         => 'Comment Insert',
			'edit_comment'                              => 'Update Comment',
			'delete_comment'                            => 'Delete Comment',
			'trash_comment'                             => 'Trash Comment',
			'spam_comment'                              => 'Spam Comment',
			'restore_comment'                           => 'Restore Comment',
			'comment_approve'                           => 'Comment Approve',
			'comment_unapprove'                         => 'Comment Unpprove',
			'wp_create_nav_menu'                        => 'Create Menu',
			'delete_nav_menu'                           => 'Delete Menu',
			'admin_head'                                => 'Admin Page View',
			'wp_head'                                   => 'Page View',
			'404_page'                                  => '404 Page View',
			'_core_updated_successfully'                => 'Wordpress Core Update',
			'import_end'                                => 'Import Wordpress Data',
			'export_wp'                                 => 'Export Wordpress Data',
			'widget_update_callback'                    => 'Widget Update',
			'updated_option'                            => 'Settings Update',
			'dbdelta_queries'                           => 'Database Delete',
			'wp_privacy_personal_data_exporters'        => 'Export Personal Data Downloaded',
			'wp_privacy_personal_data_erasers'          => 'Erase Personal Data',
			'wp_update_nav_menu'                        => 'Menu Update',
			'pre_insert_term'                           => 'Taxonomy Create',
			'wp_update_term_parent'                     => 'Taxonomy Update',
			'before_delete_post'                        => 'Posts Delete',
			'ualpSettingsUpdated'                       => 'bbPress Setting Update',
			'sidebar_admin_setup'                       => 'Widget Add/Delete',
			'updated_post_meta'                         => 'Yoast SEO Update',
			'woocommerce_updated_option'                => 'Woocommerce Setting Update',
			'woocommerce_new_product_variation'         => 'Create Product Variation',
			'wp_ajax_woocommerce_remove_variations'     => 'Delete Product Variation',
			'woocommerce_save_product_variation'        => 'Save Product Variation',
			'groups_create_group'                       => 'BubbyPress Create Group',
			'groups_update_group'                       => 'BubbyPress Update Group',
			'groups_before_delete_group'                => 'BubbyPress Delete Group',
			'groups_leave_group'                        => 'BubbyPress Delete Group',
			'groups_join_group'                         => 'BubbyPress Join Group',
			'groups_promote_member'                     => 'BubbyPress Promote Group',
			'groups_demote_member'                      => 'BubbyPress Demote Group',
			'groups_ban_member'                         => 'BubbyPress Ban Group',
			'groups_unban_member'                       => 'BubbyPress Unban Group',
			'groups_remove_member'                      => 'BubbyPress Remove Member',
			'xprofile_field_after_save'                 => 'BubbyPress Profile Field Save',
			'xprofile_fields_deleted_field'             => 'BubbyPress Profile Field Delete',
			'xprofile_group_after_save'                 => 'BubbyPress Create/Update Profile Field Group',
			'xprofile_groups_deleted_group'             => 'BuddyPress Deleted Profile Field Group',
			'edd_activate_discount'                     => 'Activate Discount Code',
			'edd_deactivate_discount'                   => 'Deactivate Discount Code',
			'edd_add_discount'                          => 'Add Discount Code',
			'edd_delete_discount'                       => 'Delete Discount Code',
			'transition_post_status'                    => 'Posts create, update, delete',
			'gf_export_forms'                           => 'Gravity Form Export',
			'notification_duplicated'                   => 'Notification Duplicate',
			'gform_entry_created'                       => 'Gravity Form Entry Create',
			'gf_resend_notifications'                   => 'Gravity Form Resend Email',
			'gform_pre_note_deleted'                    => 'Gravity Form Note Delete',
			'gform_post_export_entries'                 => 'Gravity Form Entries Export',
			'gform_post_note_added'                     => 'Gravity Form Note Add',
			'gform_delete_entries'                      => 'Gravity Form Entry Delete',
			'gform_post_form_views_deleted'             => 'Gravity Form View Delete',
			'gform_post_form_activated'                 => 'Gravity Form Active',
			'gform_post_form_deactivated'               => 'Gravity Form Deactive',
			'gform_before_delete_form'                  => 'Gravity Form Delete',
			'gform_post_form_trashed'                   => 'Gravity Form Trash',
			'gform_post_form_restored'                  => 'Gravity Form Restore',
			'gform_post_form_duplicated'                => 'Gravity Form Duplicate',
			'gform_after_save_form'                     => 'Gravity Form Save',
			'gform_forms_post_import'                   => 'Gravity Form Import',
			'gform_pre_notification_deleted'            => 'Gravity Form Notification Delete',
			'gform_pre_confirmation_deleted'            => 'Gravity Form Confirmation Delete',
			'wp_ajax_rg_update_notification_active'     => 'Gravity Form Notification active/deactive',
			'wp_ajax_rg_update_confirmation_active'     => 'Gravity Form Confirmation active/deactive',
			'gform_pre_confirmation_save'               => 'Gravity Form Confirmation Save',
			'gform_pre_notification_save'               => 'Gravity Form Notification Save',
			'gform_delete_lead'                         => 'Gravity Form Lead Delete',
			'gform_update_status'                       => 'Gravity Form Status Update',
			'gform_update_is_read'                      => 'Gravity Form Read Entry',
			'gform_update_is_starred'                   => 'Gravity Form Entry Status',
			'gravityforms_updated_option'               => 'Gravity Form Setting Update',
			'wordfence_updateIssueStatus'               => 'Wordfence Issue status',
			'wordfence_saveWAFConfig'                   => 'Wordfence WAF Config Update',
			'wordfence_wafConfigureAutoPrepend'         => 'Wordfence Optimize',
			'wordfence_whitelistBulkEnable'             => 'WordFence Bulk Enable Whitelist',
			'wordfence_whitelistBulkDisable'            => 'WordFence Bulk Disable Whitelist',
			'wordfence_whitelistBulkDelete'             => 'WordFence Bulk Delete Whitelist',
			'wordfence_updateConfig'                    => 'Wordfence Config Update',
			'wordfence_loadLiveTraffic'                 => 'WordFence Load Live Traffic',
			'wordfence_loadCacheExclusions'             => 'WordFence Load Cache',
			'wordfence_saveCacheConfig'                 => 'WordFence Save Cache Config',
			'wordfence_cache_clear'                     => 'WordFence Clear cache',
			'wordfence_reverseLookup'                   => 'WordFence Reverse Look up',
			'wordfence_whois'                           => 'WordFence WHOIS Lookup',
			'wordfence_clearPageCache'                  => 'WordFence Clear Page Cache',
			'wordfence_saveConfig'                      => 'WordFence Save Configuration',
			'wordfence_blockIP'                         => 'WordFence Block IP',
			'wordfence_addTwoFactor'                    => 'WordFence Add Two Factor',
			'wordfence_exportSettings'                  => 'WordFence Export Settings',
			'wordfence_clearAllBlocked'                 => 'WordFence Clear All Block',
			'wordfence_blockIPUARange'                  => 'WordFence Block IP UA Range',
			'wordfence_unblockRange'                    => 'WordFence Unblock Range',
			'wordfence_saveCountryBlocking'             => 'WordFence Save Country Block',
			'wordfence_saveDebuggingConfig'             => 'WordFence Save Debugging Config',
			'wordfence_startPasswdAudit'                => 'WordFence Start Password Audit',
			'wordfence_saveScanSchedule'                => 'WordFence Save Scan Schedule',
			'wordfence_updateWAFRules'                  => 'WordFence update WAF Rules',
			'wordfence_sendTestEmail'                   => 'WordFence Send Test Email',
			'wordfence_sendDiagnostic'                  => 'WordFence Send Diagnostic',
			'wordfence_updateAllIssues'                 => 'WordFence Update All Issues',
			'wordfence_sendActivityLog'                 => 'WordFence Send Activity Log',
			'wordfence_addCacheExclusion'               => 'WordFence Add Cache Exclusion',
			'wordfence_daily_autoUpdate'                => 'WordFence Daily Auto Update',
			'wordfence_update_blocked_IPs'              => 'WordFence Update blocked IPs',
			'wordfence_start_scheduled_scan'            => 'WordFence Start scheduled scan',
			'wordfence_doScan'                          => 'WordFence Do Scan',
			'wordfence_daily_cron'                      => 'WordFence Daily cron',
			'wordfence_hourly_cron'                     => 'WordFence Hourly cron',
			'wordfence_email_activity_report'           => 'WordFence Email activity report',
			'wordfence_scan'                            => 'WordFence Scan',
			'wordfence_updateAlertEmail'                => 'WordFence Update Alert Email',
			'wordfence_restoreFile'                     => 'WordFence Restore File',
			'wordfence_deletePasswdAudit'               => 'WordFence Delete Password Audit',
			'wordfence_weakPasswordsFix'                => 'WordFence Fix weak passwords',
			'wordfence_killPasswdAudit'                 => 'WordFence Kill Password Audit',
			'wordfence_importSettings'                  => 'WordFence Import Settings',
			'wordfence_bulkOperation'                   => 'WordFence Bulk Operation',
			'wordfence_deleteFile'                      => 'WordFence Delete File',
			'wordfence_deleteDatabaseOption'            => 'WordFence Delete Database Option',
			'wordfence_removeExclusion'                 => 'WordFence Remove Exclusion',
			'wordfence_deleteIssue'                     => 'WordFence Delete Issue',
			'wordfence_unlockOutIP'                     => 'WordFence Unlock Out IP',
			'wordfence_unblockIP'                       => 'WordFence Unblock IP',
			'wordfence_permBlockIP'                     => 'WordFence Permanently Block IP',
			'wordfence_downloadHtaccess'                => 'WordFence Htaccess Download',
			'wordfence_checkFalconHtaccess'             => 'WordFence Check Falcon Htaccess',
			'wordfence_removeFromCache'                 => 'WordFence Remove From Cache',
			'wordfence_autoUpdateChoice'                => 'WordFence Enable auto update',
			'wordfence_saveCacheOptions'                => 'WordFence Cache Option Save',
			'wordfence_adminEmailChoice'                => 'WordFence Admin Email Choice',
			'wordfence_getCacheStats'                   => 'WordFence Get Cache Stats',
			'wordfence_killScan'                        => 'WordFenc Kill Scan',
			'wordfence_tourClosed'                      => 'WordFence Tour Closed',
			'wordfence_removeCacheExclusion'            => 'WordFence Remove Cache Exclusion',
			'wordfence_unblockNetwork'                  => 'WordFence Unblock Network',
			'wordfence_permanentlyBlockAllIPs'          => 'WordFence Permanently Block All IPs',
			'wordfence_deleteAdminUser'                 => 'WordFence Admin User Delete',
			'wordfence_revokeAdminUser'                 => 'WordFence Admin User Revoke',
			'wordfence_hideFileHtaccess'                => 'WordFence Hide htaccess file',
			'wpseo_handle_import'                       => 'SEO Setting Import',
			'wpseo_import'                              => 'SEO Importing settings',
			'wpseo_opengraph'                           => 'SEO Opengraph Output Added',
			'wpseo_twitter'                             => 'SEO Twitter output added',
			'wpseo_save_auth_code'                      => 'SEO authentication code save',
			'updated_post_meta'                         => 'SEO Meta Update',
			'bdp_update_shortcode'                      => 'Blog Layout Updated',
			'bdp_reset_shortcode'                       => 'Blog Layout Reset',
			'bdp_reset_archive_page'                    => 'Archive Layout Reset',
			'bdp_add_shortcode'                         => 'Blog Layout Create',
			'bdp_update_single_file'                    => 'Single file Update',
			'bdp_add_archive_layout'                    => 'Archive Layout Create',
			'bdp_delete_shortcode'                      => 'Blog Layout Deleted',
			'bdp_delete_single_template'                => 'Single file Delete',
			'bdp_copy_single_template'                  => 'Single file create',
			'bdp_duplicate_layout_settings'             => 'Blog Layout Duplicate',
			'bdp_import_blog_layout_settings'           => 'Blog Layout Import',
			'bdp_import_archive_layout_settings'        => 'Archive Layout Import',
			'bdp_export_blog_layout_settings'           => 'Blog Layout Export',
			'bdp_export_archive_layout_settings'        => 'Archive Layout Export',
			'bdp_update_archive_page'                   => 'Archive Layout Update',
			'bdp_import_single_layout_settings'         => 'Single layout Import',
			'bdp_export_single_layout_settings'         => 'Single Layout Export',
			'bdp_delete_archive'                        => 'Archive layout delete',
			'bdp_delete_single_layout'                  => 'Single Layout Delete',
			'bdp_update_single_page'                    => 'Single Layout Update',
			'bdp_reset_single_page'                     => 'Single Layout Reset',
			'bdp_add_single_layout'                     => 'Single Layout Create',
			'bdp_duplicate_single_layout_settings'      => 'Single Layout Duplicate',
			'import_sample_portfolio_data'              => 'Portfolio Designer Sample import',
			'create_portfolio_layout'                   => 'Portfolio Layout create',
			'duplicate_portfolio_layout'                => 'Portfolio Layout Duplicate',
			'delete_portfolio_layout'                   => 'Portfolio Layout Delete',
			'update_portfolio_layout'                   => 'Portfolio Layout Update',
			'reset_portfolio_layout'                    => 'Portfolio Layout Reset',
			'create_post_type'                          => 'Portflio Post type create',
			'update_post_type'                          => 'Portfolio Post type Update',
			'import_portfolio_layout'                   => 'Portfolio Layout Import',
			'export_portfolio_layout'                   => 'Portfolio Layout Export',
			'delete_post_type'                          => 'Portfolio Post type Delete',
			'save_reservation_settings'                 => 'Reservation Settings Update',
			'rest_update_reservation_status'            => 'Reservation status Update',
			'reset_reservation_settings'                => 'Reset Reservation Setting',
			'save_wcfe_settings'                        => 'Checkout Field Setting Update',
			'wp_ajax_wcfe_get_checkout_required_fields' => 'Checkout Setting Restore',
			'edd_settings'                              => 'EDD Setting Update',
			'wp_ajax_autoptimize_delete_cache'          => 'Autoptimizer Delete Cache',
			'autoptimizer_settings'                     => 'Autoptimizer Setting Update',
			'bbpress_settings'                          => 'bbPress Setting Update',
			'wp_ajax_save_fields_settings'              => 'User Ultra Profile field update',
			'wp_ajax_delete_profile_field'              => 'User Ultra Profile Field Delete',
			'wp_ajax_sort_fileds_list'                  => 'User Ultra Field order update',
			'wp_ajax_custom_fields_reset'               => 'User Ultra custom fields reset',
			'wp_ajax_create_uploader_folder'            => 'User Ultra Uploader folder create',
			'wp_ajax_package_add_new'                   => 'User Ultra Membership Package create',
			'wp_ajax_package_delete'                    => 'User Ultra Membership Package delete',
			'wp_ajax_package_edit_confirm'              => 'User Ultra Membership Package update',
			'wp_ajax_sync_users'                        => 'User Ultra Sync users',
			'wp_ajax_user_resend_activation_link'       => 'User Ultra Resend Activation Link',
			'wp_ajax_delete_uultra_transtient'          => 'User Ultra Transients Delete',
			'wp_ajax_delete_uultra_stats'               => 'Clear Users Ultra Stats',
			'wp_ajax_delete_uultra_reviews'             => 'Clean Users Ultra Ratings',
			'wp_ajax_edit_photo_cate_conf'              => 'User Ultra photo category update',
			'wp_ajax_edit_photo_cate_del'               => 'User Ultra Photo category delete',
			'wp_ajax_edit_photo_cate'                   => 'User Ultra Photo Category Update',
			'userultra_admin_menu_hook'                 => 'User Ultra Photo category create',
			'switch_to_user'                            => 'Switch User',
			'switch_off_user'                           => 'Switch Off User',
			'switch_back_user'                          => 'Switch Back User',
			'export_acf'                                => 'ACF File Exported',
			'user_ultra_settings'                       => 'Auto sync with woocommerce',
			'pre_delete_term'                           => 'Delete Taxonomy',
			'ualp_disable_email_notification'           => 'Disable Email Notification',
			'delete_themes'                             => 'Delete Theme',
			'seo_check_admin_referer'                   => 'SEO Settiing Update',
			'wordfence_loadBlockRanges'                 => 'WordFence Load Block Range',
			'password_reset'                            => 'UALP Password Reset',
			'seo_updated_post_meta'                     => 'SEO Post Meta Update',
		);
		foreach ( $post_types as $post_type ) {
			if ( 'wpcf7_contact_form' != $post_type->name && 'custom_css' != $post_type->name && 'customize_changeset' != $post_type->name && 'attachment' != $post_type->name && 'oembed_cache' != $post_type->name && 'wp_block' != $post_type->name ) {
				$allhookdetails[ $post_type->name . '_create' ] = $post_type->label . ' Create';
				$allhookdetails[ $post_type->name . '_update' ] = $post_type->label . ' Update';
				$allhookdetails[ $post_type->name . '_delete' ] = $post_type->label . ' Delete';
			}
			if ( 'attachment' == $post_type->name ) {
				$allhookdetails[ 'add_' . $post_type->name ]    = 'Add ' . $post_type->label;
				$allhookdetails[ 'edit_' . $post_type->name ]   = 'Edit ' . $post_type->label;
				$allhookdetails[ 'delete_' . $post_type->name ] = 'Delete ' . $post_type->label;
			}
		}
		foreach ( $taxonomies as $taxonomy ) {
			if ( 'wpcf7_contact_form' != $taxonomy->name && 'custom_css' != $taxonomy->name && 'customize_changeset' != $taxonomy->name && 'product_visibility' != $taxonomy->name ) {
				$allhookdetails[ $taxonomy->name . '_create' ] = $taxonomy->label . ' Create (' . $taxonomy->name . '_create )';

				$allhookdetails[ $taxonomy->name . '_update' ] = $taxonomy->label . ' Update (' . $taxonomy->name . '_update )';

				$allhookdetails[ $taxonomy->name . '_delete' ] = $taxonomy->label . ' Delete (' . $taxonomy->name . '_delete )';

			}
		}
	}
}
